/*--------------------------------------------------------------------------*\
|   CIF.C - Interface to  Comressor                                    |
|                                                                            |
\*--------------------------------------------------------------------------*/
/**************************************************************************
 *
 *  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 *  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
 *  PURPOSE.
 *
 *  Copyright (c) 1991 - 1995  Microsoft Corporation.  All Rights Reserved.
 *
 **************************************************************************/

#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
#include "compddk.h"
#define NO_CDEVICE
#include <VT_ACC.h>
#define DEVNODE DWORD
#include <vtdioc.h>
#include "vt_regs.h"
#include "mpeg2dec\ifrmdec.h"
#include "bwhw10.h"
//#include "device.h"

//#include <stdarg.h>
//#include <vcdriver.h>
//#include <vckernel.h>
//#include <bwuser.h>
//#include "hardware.h"
//#include "bwerrors.h"
#include "xlate.h"

#define MAX_PATHNAME    256
#define MAX_COMMANDLINE (MAX_PATHNAME+1+MAX_PATHNAME+1+MAX_PATHNAME+1+10+1)

STATE DefaultState = {0};

#define FOURCC_DIB      mmioFOURCC('D','I','B',' ')
#define FOURCC_BW10      mmioFOURCC('B','W','1','0') //mmioFOURCC('R','L','E',' ')
#define FOURCC_YUYV		mmioFOURCC('Y','U','Y','V')
#define FOURCC_YUY2		mmioFOURCC('Y','U','Y','2')
#define FOURCC_UYVY		mmioFOURCC('U','Y','V','Y')
			
#define TWOCC_DIB       aviTWOCC('d','b')
#define TWOCC_       aviTWOCC('d','c')
#define TWOCC_DIBX      aviTWOCC('d','x')

WCHAR   szDescription[] = L"Broadway I-frame MPEG";
WCHAR   szName[]        = L"Broadway";

/****************************************************************************
****************************************************************************/
#ifdef _DEBUG
#define DEBUG
#endif 
//#define DEBUG


#ifdef DEBUG
#include "stdio.h"
#pragma message ("warning Debug prints are on")
extern "C" void __cdecl dprintf(LPSTR szFormat, ...);
#define DB
#else
// this define produces a comment "//" before the paramiters 
#define dprintf / ## /
#define DB / ## /
#endif

#define errprintf dprintf
#define statprintf dprintf
//#define statprintf / ## /

//#define CANDRAW

OSVERSIONINFO VerInfo;


#pragma optimize("", off)

static BOOL NEAR PASCAL IsApp(LPTSTR szApp)
{
    TCHAR ach[128];
    int  i;
    HINSTANCE hInstance;

#ifdef _WIN32
    hInstance = GetModuleHandle(NULL);
#else
    _asm mov hInstance,ss
#endif

    GetModuleFileName(hInstance, ach, sizeof(ach));

    for (i = lstrlen(ach);
        i > 0 && ach[i-1] != '\\' && ach[i-1] != '/' && ach[i] != ':';
        i--)
        ;

    return lstrcmpi(ach + i, szApp) == 0;
}
#pragma optimize("", on)

/*****************************************************************************
 ****************************************************************************/
//
//  Load()
//
void NEAR PASCAL Load()
{
}

/*****************************************************************************
 ****************************************************************************/
//
//  Free()
//
void NEAR PASCAL Free()
{
}
/*****************************************************************************
 ****************************************************************************/

//
//  Open()   - open a instance of the  compressor
//
PINST NEAR PASCAL Open(ICOPEN* Open)
{
    PINST pri;


    //
    //  VIDEDIT Hack
    //
    //  we dont want to see two "Microsoft " compressors.
    //  so lie to VidEdit and fail to open.
    //

//  if (GetModuleHandle(TEXT("MEDDIBS")) && IsApp(TEXT("VIDEDIT.EXE")))
//      return NULL;
	dprintf("Codec Open for %d \n" ,Open->dwFlags); 
    pri = new BwInst;
	pri->dwOpenFlags=Open->dwFlags;
    if (pri)
    {
        SetState(pri, NULL, 0);
    }
/* modes are
#define ICMODE_COMPRESS		1
#define ICMODE_DECOMPRESS	2
#define ICMODE_FASTDECOMPRESS   3
#define ICMODE_QUERY            4
#define ICMODE_FASTCOMPRESS     5
#define ICMODE_DRAW             8
*/

	if (Open->dwFlags!=ICMODE_QUERY)
	{
		/* 
		 * this is for debugging - we can output to the screen 
		 * in WinNT but not Win95
		 */
		VerInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
		GetVersionEx(&VerInfo);

		ECODE ec=VT_OpenDevice(TEXT("vtool"),0,  &pri->dwDevice);
		if (ec)
		{
			 pri->dwDevice=NULL;
		}
	}
	else
	{
		statprintf("Open for Query no device opened\n");
		pri->dwDevice=NULL;
	}
    return pri;
}

DWORD BwInst::CheckLoaded()
{
	if (!fUcodeLoaded && dwDevice!=NULL)
	{
		fUcodeLoaded=TRUE;
		return (VT_SetMode(dwDevice,VT_CODEC));
	}
	return VT_NO_ERROR;
}

DWORD BwInst::SetFrameInfo(LPBITMAPINFOHEADER lpbi) // set hwcodec frame info  
{
	COMPRESSINFO Info;
	Info.StructSize=sizeof(Info);
	if (dwDevice!=NULL)
	{
		VT_GetCodecInfo(dwDevice,&Info);
		Info.StructSize=sizeof(Info);
		Info.FrameWidth=(short)lpbi->biWidth;
		Info.FrameHeight=(short)lpbi->biHeight;
		if (lpbi->biHeight==288)
		{
			Info.FrameRate=2500;
			Info.FrameType=FT_PAL;
		}
		else
		{	
			if (lpbi->biWidth==320)
			{
				Info.FrameRate=3000;
				Info.FrameType=FT_SQPIXEL;
			}
			else
			{
				Info.FrameRate=2997;
				Info.FrameType=FT_NTSC;
			}

		}
		VT_SetCodecInfo(dwDevice,&Info);
	}
	return VT_NO_ERROR;
}

DWORD BwInst::GetHw(DWORD Timeoutms)
{
	if (dwDevice!=NULL) return VT_GetHW(dwDevice,Timeoutms);
	else return 0xffffffff;
}

DWORD BwInst::ReleaseHw()
{
	return VT_ReleaseHW(dwDevice);
}



/*****************************************************************************
 ****************************************************************************/
//
//  Close()   - close a instance of the  compressor
//
DWORD  BwInst::Close()
{
    if (!this || IsBadWritePtr(this,sizeof(BwInst)) )
        return FALSE;

	if (dwDevice!=NULL) 
		VT_DeleteDevice(dwDevice);

    delete this;
    return TRUE;
}

/*****************************************************************************
 ****************************************************************************/
//
//  GetState()   - get the current state of the  compressor
//
//  will copy current state into passed buffer.
//  returns the size in bytes required to store the entire state.
//


DWORD NEAR PASCAL GetState(PINST pri, LPVOID pv, DWORD dwSize)
{
    if (pv == NULL || dwSize == 0)
        return sizeof(STATE);

    if (pri == NULL || dwSize < sizeof(STATE))
        return 0;

    *(LPSTATE)pv = pri->State;
    return sizeof(STATE);
}

/*****************************************************************************
 ****************************************************************************/
//
//  SetState()   - sets the current state of the  compressor
//
DWORD NEAR PASCAL SetState(PINST pri, LPVOID pv, DWORD dwSize)
{
    if (pv == NULL || dwSize == 0)
    {
        pv = &DefaultState;
        dwSize = sizeof(STATE);
    }

    if (pri == NULL || dwSize < sizeof(STATE))
        return 0;

    pri->State = *(LPSTATE)pv;
    return sizeof(STATE);
}

#if !defined NUMELMS
 #define NUMELMS(aa) (sizeof(aa)/sizeof((aa)[0]))
#endif

#if defined _WIN32 && !defined UNICODE

int LoadUnicodeString(HINSTANCE hinst, UINT wID, LPWSTR lpBuffer, int cchBuffer)
{
    char    ach[128];
    int	    i;

    i = LoadString(hinst, wID, ach, sizeof(ach));
//    wcscpy(lpBuffer, ach);

    if (i > 0)
	  MultiByteToWideChar(CP_ACP, 0, ach, -1, lpBuffer, cchBuffer);

    return i;
}

#else
#define LoadUnicodeString   LoadString
#endif


/*****************************************************************************
 ****************************************************************************/
DWORD NEAR PASCAL GetInfo(PINST pri, ICINFO FAR *icinfo, DWORD dwSize)
{
    if (icinfo == NULL)
        return sizeof(ICINFO);

    if (dwSize < sizeof(ICINFO))
        return 0;

    icinfo->dwSize      = sizeof(ICINFO);
    icinfo->fccType     = ICTYPE_VIDEO;
    icinfo->fccHandler  = FOURCC_BW10;
    icinfo->dwFlags     = VIDCF_QUALITY   |  // supports quality

#ifdef CANDRAW
		                  VIDCF_DRAW |
#endif
                          VIDCF_CRUNCH;      // can crunch to a data rate
    icinfo->dwVersion   = ICVERSION;
    
//    LoadUnicodeString(ghModule, IDS_DESCRIPTION, icinfo->szDescription, NUMELMS(icinfo->szDescription));
//    LoadUnicodeString(ghModule, IDS_NAME, icinfo->szName, NUMELMS(icinfo->szName));
    wcscpy(icinfo->szDescription, szDescription);
    wcscpy(icinfo->szName, szName);
//    LoadString(ghModule, IDS_DESCRIPTION, icinfo->szDescription, NUMELMS(icinfo->szDescription));
//    LoadString(ghModule, IDS_NAME, icinfo->szName, NUMELMS(icinfo->szName));

    return sizeof(ICINFO);
}

/*****************************************************************************
 ****************************************************************************/
DWORD BwInst::CompressQuery( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{
    //
    // determine if the input DIB data is in a format we like.
    //

    if (lpbiIn == NULL ||
        ( /*lpbiIn->biBitCount != 8 &&*/lpbiIn->biBitCount != 16 && lpbiIn->biBitCount != 24) ||
        (lpbiIn->biCompression != BI_RGB && lpbiIn->biCompression!=FOURCC_UYVY))
    {
		statprintf("Query Source Failed : Bits=%d Compression=%4.4s\n",lpbiIn->biBitCount,&lpbiIn->biCompression);
        return (DWORD)ICERR_BADFORMAT;
    }

    
	//
    //  are we being asked to query just the input format?
    //
    if (lpbiOut == NULL)
        return ICERR_OK;

    //
    // make sure we can handle the format to compress to also.
    //
	// check output size
	// use abs height
	int height=abs(lpbiOut->biHeight);
	if (lpbiOut!=NULL)
	if (lpbiOut->biCompression == FOURCC_BW10)
	{
		if (!( (lpbiOut->biWidth == 352 && (height==240 || height==288))
			   || (lpbiOut->biWidth == 320 && height==240 ) )) 
		{
			statprintf("Bad Output width %d height %d\n",lpbiOut->biWidth,lpbiOut->biHeight);
			return (DWORD)ICERR_BADFORMAT;
		}
	}
	else
		if (lpbiOut->biWidth & 1)  // can't do odd widths
		{
			statprintf("Output width is odd%d \n",lpbiOut->biWidth);
			return (DWORD)ICERR_BADFORMAT;
		}


    if (lpbiOut->biCompression != FOURCC_BW10 
		&& lpbiOut->biCompression != FOURCC_UYVY )        // must be  format
	{
		statprintf("Query Failed Bad output: Bits=%d Compression=%4c Width=%d Height=%d\n"	,lpbiOut->biBitCount,&lpbiOut->biCompression,lpbiOut->biWidth,lpbiOut->biHeight);
        return (DWORD)ICERR_BADFORMAT;
	}
    return ICERR_OK;
}


/*****************************************************************************
 ****************************************************************************/
DWORD BwInst::CompressGetFormat( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{
    DWORD dw;
	statprintf("GetFormat:");
    if (dw = CompressQuery( lpbiIn, NULL))
	{
		statprintf("Returning after Query %d\n",dw);
        return dw;
	}

    dw = lpbiIn->biSize + (int)lpbiIn->biClrUsed * sizeof(RGBQUAD);

    //
    // if lpbiOut == NULL then, return the size required to hold a output
    // format
    //
    if (lpbiOut == NULL)
	{
		statprintf("Output size check size %d\n",dw);
        return dw;
	}

    hmemcpy(lpbiOut, lpbiIn, dw);

    lpbiOut->biBitCount    = 24;
    lpbiOut->biCompression = FOURCC_BW10;
    lpbiOut->biSizeImage   = CompressGetSize(lpbiIn, lpbiOut);
	statprintf(" Passed\n");
    return ICERR_OK;
}

/*****************************************************************************
 ****************************************************************************/
static compresscount=0;


DWORD BwInst::CompressBegin( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{
    DWORD dw;
	statprintf("Compress Begin\n");
	compresscount=0;
    if (dw = CompressQuery( lpbiIn, lpbiOut))
        return dw;

	delete CompressPreProc;
	if (lpbiIn->biCompression==FOURCC_UYVY)
	{
		CompressPreProc=(FrameConverter*)new FromYuvToUYVY();
	}
	else
	{
		switch (lpbiIn->biBitCount)
		{
		case 16:
			CompressPreProc=(FrameConverter*)new FromRGB16ToYuv();
			break;
		case 24:
			CompressPreProc=(FrameConverter*)new FromRGB32ToYuv();
			break;
		}
	}
	
	CompressPreProc->Init(lpbiIn->biWidth,lpbiIn->biHeight,lpbiOut->biWidth,lpbiOut->biHeight);
	if (lpbiOut->biCompression==FOURCC_BW10) 
		SetFrameInfo(lpbiOut);  // set hardware frame type
    lpbiOut->biSizeImage   = CompressGetSize(lpbiIn, lpbiOut);

	if (dw=CheckLoaded())
	{
		if (lpbiOut->biCompression == FOURCC_BW10)
			return (DWORD) ICERR_ABORT;

	}
    fCompressBegin = TRUE;
    return ICERR_OK;
}

/*****************************************************************************
 ****************************************************************************/
DWORD BwInst::CompressGetSize( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{
    int dx,dy;

    //
    // we assume  data will never be greater then 64K.
    //
    dx = (int)lpbiOut->biWidth;
    dy = (int)abs(lpbiOut->biHeight);

    return (lpbiOut->biCompression == FOURCC_BW10 ? 1024*64 : dx*dy*2);  // ASSUME LESS THEN 64 K OUTPUT SIZE  
}

/*****************************************************************************
 ****************************************************************************/
#include <time.h> 
#define CODEC_STATUS_REGISTER (0x7fb0c)

DWORD BwInst::Compress(ICCOMPRESS FAR *icinfo, DWORD dwSize)
{
    DWORD dw;
	ECODE ec;
	DWORD Written,Read,size;
	void *Ptr;
	int ReloadTried=0;
	statprintf("Compress:");

    if (!fCompressBegin)
    {
        if (dw = CompressBegin( icinfo->lpbiInput, icinfo->lpbiOutput))
            return dw;

        fCompressBegin = FALSE;
    }

	// support of conversion to uyvy for direct recode
	if (icinfo->lpbiOutput->biCompression != FOURCC_BW10)
	{
		// do software thing here
		CompressPreProc->ProcessFrame((UCHAR*)icinfo->lpOutput,(UCHAR*)icinfo->lpInput);
		return ICERR_OK;
	}

	if (ec=GetHw())
	{
		errprintf("Compress can't get hardware\n");
		return ICERR_DONTDRAW;
	}
	DWORD t0=timeGetTime();
	VT_SetParam(dwDevice,CODECMODE,YUV_ENCODE);


    //
    //  we can compress in one of two ways:
    //
    //      if a frame size is given (>0) then call CrunchDib using the passed
    //      quality as the "frame half" setting.
    //
    //      if a frame size is not given (==0) then use the passed quality
    //      as the tolerance and do a normal DeltaFrame()
    //

    if (icinfo->dwQuality == ICQUALITY_DEFAULT)
	{
        icinfo->dwQuality = 10000; //QUALITY_DEFAULT;
		icinfo->dwFrameSize=0;
	}
	long BitRateSet=0;
    if (icinfo->dwFrameSize > 0 && icinfo->dwFrameSize < 64000)
    {
		// set bitrate assume 30 frames per second
		if (icinfo->dwFrameSize>50000) icinfo->dwFrameSize = 50000;
		BitRateSet=(long)(icinfo->dwFrameSize*8/30);
	}
    else
    {
		// set quality
 //       dw = ICQUALITY_HIGH - icinfo->dwQuality;
//		VT_SetParam(dwDevice,QUALITY,icinfo->dwQuality);
		BitRateSet=(icinfo->dwQuality+2000)*1000;
	}
	VT_SetParam(dwDevice,DATARATE,(long)BitRateSet);

        if (icinfo->lpckid)
            *icinfo->lpckid = TWOCC_;
	DWORD status;
#define Timeout(From,ms) ((timeGetTime()-From) > ms)
	for (int i=0;i<5;i++)
	{
		DWORD t1a,t1b,t1c,t1=timeGetTime();
		ec=VT_GetHardwareBuffer(dwDevice,NULL,&Ptr,NULL,&size);
		t1a=timeGetTime();

		CompressPreProc->ProcessFrame((UCHAR*)Ptr,(UCHAR*)icinfo->lpInput);
//		VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
		// waite for status 200
		statprintf("Status wait time %6.3f \n",(timeGetTime()-t1a)/1000.0);
		ec=VT_WriteData(dwDevice,(DWORD*)Ptr,CompressPreProc->GetOutputFrameSize()/sizeof(DWORD),&Written);
//		if (ec) errprintf("Write Data Returned %d\n",ec);
		ec=VT_Start(dwDevice);
		VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
#if 0
		while (status==0)
		{
				if (Timeout(t1a,5000))
				{
					errprintf("Start timeout\n");
		 		    ec=VT_Start(dwDevice);
					break;
				}
			Sleep(1);
			VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
		}
#endif
		VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
		int count;
		if (!ec)
		{
			t1b=timeGetTime();
			count=0;
			while (!(dwDevice->Regs->Status & DONE_FLAG_1))
			{
				if (Timeout(t1a,2000))
				{
					errprintf("Done flag timeout\n");
					break;
				}
				count++;
				Sleep(1);
			}
			if (dwDevice->Regs->Status & DONE_FLAG_1) // input compleated
			{
				// TOGGLE VSYNC INPUT
				//VT_ReadModifyWrite(dwDevice,CR_REGS,0,0X2,0X2);
				//VT_ReadModifyWrite(dwDevice,CR_REGS,0,0X2,0X0);
				t1b=timeGetTime();
				count=0;
				DWORD oStat;
				VT_Read(dwDevice,VR_DRAM,&oStat,CODEC_STATUS_REGISTER,1);
				if (oStat==0x10 || !(dwDevice->Regs->Csr & VRP_LOCAL))
				{
					// posible data input problem
					// push extra data??
					Sleep(1);
					errprintf("Sending extra data status %x ",oStat);
					while (!(dwDevice->Regs->Csr & VRP_LOCAL))
					{
					    count++;
						dwDevice->Regs->PortAIn=0x80808080;
//						Sleep(0);
						while ( dwDevice->Regs->Csr & (PORTA_FLAG | VRP_LOCAL)==PORTA_FLAG && count<0xf000 );
					}
					errprintf("Sent extra %d words extra data\n",count);
					count=0;
				}
				do 
				{	
					Sleep(1);
					VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
					if (status!=oStat)
					{
						statprintf("Status change at %6.3f from 0X%X to 0X%X\n",(timeGetTime()-t1b)/1000.0,oStat,status);
						oStat=status;
					}
				} while (status>=0x10 && !Timeout(t1b, 1500));
				t1c=timeGetTime();

				VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);

				ec=VT_ReadData(dwDevice,&Ptr,&Read);
				count=0;
				while (Read<200  && (timeGetTime()-t1< 2000) &&  ec==VT_NO_ERROR)
				{
					Sleep(1);
					ec=VT_ReadData(dwDevice,&Ptr,&Read);
				}
			}
			else
			{   // input did not complete attempt to recover
				VT_Stop(dwDevice);
				VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
				t1b=timeGetTime();
				double tt0=((double)t1b-t1a) /1000;
				double tt1=((double)t1a-t1) /1000;
				errprintf("Bad Xfer on encode Write time=%6.3f xfer=%6.3f\n",tt1,tt0);
				Sleep(100);
				VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
				if (status==0) continue;
				else ec=0xffffffff; //next loop
			}
		}
		if (Read>=200 && ec==VT_NO_ERROR)
		{
			Sleep(1); // wait a bit more
			ec=VT_ReadData(dwDevice,&Ptr,&Read);
			CopyMemory(icinfo->lpOutput,(DWORD*)Ptr+16,(Read-16)*sizeof(DWORD));
			icinfo->lpbiOutput->biSizeImage=(Read-16)*sizeof(DWORD);
			*(DWORD*)icinfo->lpOutput=0xFF000000 | (Read-16)*sizeof(DWORD);
		//
		// set the AVI index flags,
		//
			*icinfo->lpdwFlags |=  AVIIF_KEYFRAME;
			DWORD t2=timeGetTime();
//			double tt0=((double)t1-t0) /1000;  // yuv
			double tt1=((double)t1a-t1) /1000;  // yuv 
			double tt2=((double)t1b-t1a) /1000; // xfer
			double tt3=((double)t1c-t1b) /1000;  // encode


			double tt=((double)t2-t0) /1000;
			
			statprintf("frame %d Image Size=%d Encode=%6.3fs YUV=%6.3fs Xfer=%6.3fs Process=%6.3fs\n",compresscount,icinfo->lpbiOutput->biSizeImage,tt,tt1,tt2,tt3); 
			compresscount++;
			ec=VT_Stop(dwDevice);
			ReleaseHw();
			return ICERR_OK;
		}
		else
		{
			VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
			DWORD t2=timeGetTime();

			double tt=((double)t2-t0) /1000;
			if (0) // (!ec && i<2) 
			{
				errprintf("Try Again on Encode frame %d time %7.4f\n",compresscount,tt);
				ec=VT_Stop(dwDevice);
				continue; // try again on first two tries
			}
			if (ec!=VT_ERR_FIFOOVERFLOW)
			{
//					fUcodeLoaded=FALSE;
					errprintf("Reloading on Encode frame %d after %6.3f\n",compresscount,tt);

					VT_Reset(dwDevice); // will steal the device 
//					VT_SetMode(dwDevice,VT_IDLE);
					VT_SetMode(dwDevice,VT_CODEC);
					VT_SetParam(dwDevice,CODECMODE,YUV_ENCODE);
					Sleep(500);
					if (ReloadTried++) break;
			}
			if (ec==VT_ERR_FIFOOVERFLOW)
			{
				errprintf("Fifo overflow on Encode frame %d \n",compresscount);
				if (i>0)  // if we have tried twice
				{
					BitRateSet>>=1;
					VT_SetParam(dwDevice,DATARATE, BitRateSet);
				}
			}
		}
	}
	ReleaseHw();
	errprintf("Frame compress Failed!!!!\n");
	return (DWORD)ICERR_INTERNAL;
}

/*****************************************************************************
 ****************************************************************************/
DWORD BwInst::CompressEnd()
{
    fCompressBegin = FALSE;
	statprintf("Compress End\n");
    return ICERR_OK;
}

class IcDecompressEx: public ICDECOMPRESSEX
{
public:
	IcDecompressEx(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut);
	int Size() {return sizeof(ICDECOMPRESSEX);}
};
 IcDecompressEx::IcDecompressEx(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{

	xDst=0;
	yDst=0;
	
	if (lpbiOut != NULL) {
		dxDst=lpbiOut->biWidth;
		dyDst=abs(lpbiOut->biHeight);
	} else {
		dxDst=0;
		dyDst=0;
	}

	xSrc=0;
	ySrc=0;
	
	if (lpbiIn != NULL) {
		dxSrc=lpbiIn->biWidth;
		dySrc=lpbiIn->biHeight;
	} else {
		dxSrc=0;
		dySrc=0;
	}
	
	lpbiSrc=lpbiIn;
	lpbiDst=lpbiOut;
	lpSrc=NULL;
	lpDst=NULL;
}

DWORD BwInst::DecompressQuery( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{
    /*
     * determine if the input DIB data is in a format we like.
     */
	statprintf("Decompress called ");
	IcDecompressEx  icinfoEx(lpbiIn,lpbiOut);
	return DecompressQueryEx(&icinfoEx, icinfoEx.Size());
}

int BwInst::DecompressQueryEx(ICDECOMPRESSEX *icinfo, DWORD dwSize)
{	  
	statprintf("Decompress QueryEX called\n");
    /*
     * determine if the input DIB data is in a format we like.
     */
	LPBITMAPINFOHEADER lpbiIn=icinfo->lpbiSrc;
	LPBITMAPINFOHEADER lpbiOut=icinfo->lpbiDst;

    if (lpbiIn == NULL || (lpbiIn->biCompression != FOURCC_BW10 
		&& lpbiIn->biCompression !=FOURCC_YUY2 && lpbiIn->biCompression !=FOURCC_UYVY))
	{
		statprintf("Decompress Query Input Failed : Bits=%d Compression=%4.4s\n",lpbiIn->biBitCount,&lpbiIn->biCompression);
        return (DWORD)ICERR_BADFORMAT;
    }

    /*
     *  are we being asked to query just the input format?
     */
    if (lpbiOut == NULL) {
        return ICERR_OK;
    }

    /*
     * check output format to make sure we can convert to this
     * must be full dib
     */
	switch (lpbiOut->biCompression)
	{
	case BI_BITFIELDS:
		{
		DWORD *pBitFields=(DWORD*)(lpbiOut+1);
		statprintf("Bitfields attempted : bits=%d Red %x Green %x Blue %x\n",lpbiOut->biBitCount,((DWORD*)(lpbiOut+1))[0],((DWORD*)(lpbiOut+1))[1],((DWORD*)(lpbiOut+1))[2] );
		if (lpbiOut->biBitCount!=16 || pBitFields[0] != 0xf800 || pBitFields[1] != 0x07e0 || pBitFields[2] != 0x1f) {
				statprintf("Decompress Query Bitfields Failed :  bits=%d Red %x Green %x Blue %x\n",lpbiOut->biBitCount,((DWORD*)(lpbiOut+1))[0],((DWORD*)(lpbiOut+1))[1],((DWORD*)(lpbiOut+1))[2] );
				return((DWORD) ICERR_BADFORMAT);
		}
		break;
		}
	case BI_RGB:
	    /*
		 * we translate to 16, 24 or 32 bits
	     */
		switch (lpbiOut->biBitCount) {
			 case 16:
				break;
			 case 24:
				break;
			 case 32:
				break;
      
			default:
				statprintf("Decompress Query bit depth Failed bits=%d\n",lpbiOut->biBitCount);
				return((DWORD) ICERR_BADFORMAT);
		}
		break;
	case FOURCC_UYVY:
		statprintf("UYVY requested bits=%d Height=%d Width=%d Size=%d\n",lpbiOut->biBitCount,icinfo->dyDst,icinfo->dxDst,lpbiOut->biSizeImage);
		break;
	case FOURCC_YUY2:
		statprintf("YUY2 requested\n");
		break;
	default :
		statprintf("Decompress Query Output Failed : Bits=%d Compression=%4.4s Hex %x\n",lpbiOut->biBitCount,&lpbiOut->biCompression,lpbiOut->biCompression);
		return (DWORD)ICERR_BADFORMAT;
    }
	
	if (lpbiOut->biHeight<0) {
		statprintf("Inverted dib attempted\n");
	}

    /* must be 1:1 (no stretching) unless yuv out */ 
    if (icinfo->dxDst != icinfo->dxSrc 
		|| icinfo->dyDst != icinfo->dySrc ) 
	{
		statprintf("Output scaleing attempted dxDst=%d dyDst=%d \n",icinfo->dxDst,icinfo->dyDst);
        if (lpbiOut->biCompression !=FOURCC_UYVY) return ICERR_BADPARAM;
	}
// is this needed
    if ((icinfo->dxDst != (int)lpbiIn->biWidth) ||
        (icinfo->dyDst != (int)lpbiIn->biHeight)) {

	    if (lpbiOut->biCompression !=FOURCC_UYVY)
		{
			statprintf("Why are we here??? Decompress Query size Failed Width=%d Height=%d\n",lpbiOut->biWidth,lpbiOut->biHeight);
			return((DWORD) ICERR_BADFORMAT);
		}

    }


	// now check extra input paramiters
	    //
    //  we cant clip the source.
    //
    if (icinfo->xSrc != 0 || icinfo->ySrc != 0) 
        return ICERR_BADPARAM;

    if (icinfo->xDst != 0 || icinfo->yDst != 0 || lpbiOut->biWidth>icinfo->dxDst) 
 	{
		statprintf("Output windowing requested xDst=%d yDst=%d Width=%d Height=%d \n",icinfo->xDst,icinfo->yDst,lpbiOut->biWidth,lpbiOut->biHeight);
//      return ICERR_BADPARAM;
	}

	return ICERR_OK;
}



DWORD BwInst::DecompressGetFormat( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{
    DWORD dw;
    int dx,dy;

    dw = DecompressQuery( lpbiIn, NULL);
    if (dw != ICERR_OK) {
        return dw;
    }

    /*
     * if lpbiOut == NULL then, return the size required to hold a output
     * format
     */
    if (lpbiOut == NULL) {
        return (int)lpbiIn->biSize + (int)lpbiIn->biClrUsed * sizeof(RGBQUAD);
    }

    hmemcpy(lpbiOut, lpbiIn,
    (int)lpbiIn->biSize + (int)lpbiIn->biClrUsed * sizeof(RGBQUAD));

    dx = (int)lpbiIn->biWidth & ~1;
    dy = (int)lpbiIn->biHeight & ~1;

    lpbiOut->biWidth       = dx;
    lpbiOut->biHeight      = dy;
// defaulting to  yuv causes problems in Third party apps
    lpbiOut->biBitCount    = 24;    // convert 16->24

    lpbiOut->biCompression = BI_RGB;
    lpbiOut->biSizeImage   = dx*dy*3; // fix if not yuv

    return ICERR_OK;
}


int BwInst::MustInitDecoder=TRUE;


BwInst::BwInst()
{
    fCompressBegin = FALSE;
    fDecompressBegin = FALSE;

	DecompressHurryupDropped=0;
	CompressPreProc=NULL;
	fUcodeLoaded=FALSE;
	DeCompressPostProc=NULL;
	fUseSoftwareCodec=FALSE;
	if (MustInitDecoder) 
	{
		InitMpegDecode();
		MustInitDecoder=FALSE;
	}
	SwDecoder=OpenDecoder();
	ttime=0;
}

BwInst::~BwInst()
{
	if (CompressPreProc)
		delete CompressPreProc;
	if (DeCompressPostProc)
		delete DeCompressPostProc;
	if (SwDecoder)
//		dprintf("Did not close software decoder\n");
		CloseDecoder(SwDecoder);

}
static  DecodeCount=0;
/*****************************************************************************
 ****************************************************************************/
DWORD BwInst::DecompressBeginEx(ICDECOMPRESSEX *icinfo, DWORD dwSize)
{
	statprintf("Decompress BeginEX called\n");
	DWORD dw=DecompressQueryEx(icinfo,dwSize);
	if (dw) return dw;

	LPBITMAPINFOHEADER lpbiIn=icinfo->lpbiSrc;
	LPBITMAPINFOHEADER lpbiOut=icinfo->lpbiDst;

	
	DecodeCount=0;
	
    fDecompressBegin = TRUE;

    // Make sure we know the size of an uncompressed DIB
    if (lpbiOut->biSizeImage == 0)
		lpbiOut->biSizeImage = lpbiOut->biHeight * DibWidthBytes(lpbiOut);

	if (DeCompressPostProc!=NULL && DeCompressPostProc->GetOutputBitsPerPixel()==lpbiOut->biBitCount)
		DeCompressPostProc->InitEx(icinfo);
	else
	{
		delete DeCompressPostProc;
		if (lpbiIn->biCompression ==FOURCC_YUY2)
		{
			switch (lpbiOut->biCompression)
			{
			case BI_BITFIELDS:
				statprintf("Begin using Bitfields bits=%d Red %x Green %x Blue %x\n",lpbiOut->biBitCount,((DWORD*)(lpbiOut+1))[0],((DWORD*)(lpbiOut+1))[1],((DWORD*)(lpbiOut+1))[2] );
				DeCompressPostProc=(FrameConverter*)new FromYUY2ToRGBBF16();
				break;
			case BI_RGB:
				switch (lpbiOut->biBitCount)
				{
				case 16:
					DeCompressPostProc=(FrameConverter*)new FromYUY2ToRGB16();
					break;
				case 24:
					DeCompressPostProc=(FrameConverter*)new FromYUY2ToRGB24();
					break;
				case 32:
					DeCompressPostProc=(FrameConverter*)new FromYUY2ToRGB32();
					break;
				default: 
					return (DWORD)ICERR_BADFORMAT;
				}
				break;
			case FOURCC_UYVY:
				statprintf("Begin UYVY attempted\n");
				DeCompressPostProc=(FrameConverter*)new FromYUY2ToUYVY();

				break;
			case FOURCC_YUY2:
				statprintf("Begin YUY2 attempted\n");
				DeCompressPostProc=(FrameConverter*)new FromYUY2ToYUY2();
				break;

			default :
				statprintf("Decompress Begin Output Failed : Bits=%d Compression=%4.4s Hex %x\n",lpbiOut->biBitCount,&lpbiOut->biCompression,lpbiOut->biCompression);
				return (DWORD)ICERR_BADFORMAT;
			}
		}
		else
			switch (lpbiOut->biCompression)
			{
			case BI_BITFIELDS:
				statprintf("Begin using Bitfields bits=%d Red %x Green %x Blue %x\n",lpbiOut->biBitCount,((DWORD*)(lpbiOut+1))[0],((DWORD*)(lpbiOut+1))[1],((DWORD*)(lpbiOut+1))[2] );
				DeCompressPostProc=(FrameConverter*)new FromYuvToRGBBF16();
				SwDecodeOutputType = RGB565;
				break;
			case BI_RGB:
				switch (lpbiOut->biBitCount)
				{
				case 16:
					DeCompressPostProc=(FrameConverter*)new FromYuvToRGB16();
					SwDecodeOutputType = RGB555;
					break;
				case 24:
					DeCompressPostProc=(FrameConverter*)new FromYuvToRGB();
					SwDecodeOutputType = RGB24BIT;
					break;
				case 32:
					DeCompressPostProc=(FrameConverter*)new FromYuvToRGB32();
					break;
				default: 
					return (DWORD)ICERR_BADFORMAT;
				}
				break;
			case FOURCC_UYVY:
				statprintf("Begin UYVY attempted\n");
				DeCompressPostProc=(FrameConverter*)new FromYuvToUYVY();
				SwDecodeOutputType = UYVY;

				break;
			case FOURCC_YUY2:
				statprintf("Begin YUY2 attempted\n");
				DeCompressPostProc=(FrameConverter*)new FromYuvToYUY2();
				SwDecodeOutputType = UYVY;

				break;

			default :
				statprintf("Decompress Begin Output Failed : Bits=%d Compression=%4.4s Hex %x\n",lpbiOut->biBitCount,&lpbiOut->biCompression,lpbiOut->biCompression);
				return (DWORD)ICERR_BADFORMAT;
			}
		DeCompressPostProc->InitEx(icinfo);
	}
	// use input to avoid inverted dib output or stretching
	if (lpbiIn->biCompression==FOURCC_BW10)
	{ 
		SetFrameSize(SwDecoder,lpbiIn->biWidth,lpbiIn->biHeight);
		SetFrameInfo(lpbiIn);  // set hardware frame type
 		if (dw=CheckLoaded())
		{
			// flag no hardware here
			fUseSoftwareCodec=TRUE;
		}
	}
   return ICERR_OK;
}


DWORD BwInst::DecompressBegin(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut)
{
	statprintf("Decompress Begin\n");
	IcDecompressEx  icinfoEx(lpbiIn,lpbiOut);
	return DecompressBeginEx(&icinfoEx, icinfoEx.Size());
}
#define SEQUENCE_HEADER 0XB3010000

/*****************************************************************************
 ****************************************************************************/
DWORD BwInst::Decompress( ICDECOMPRESS *icinfo, DWORD dwSize)
{
	statprintf("Decompress called ");
	ICDECOMPRESSEX  icinfoEx;
	memcpy(&icinfoEx,icinfo,dwSize);
	icinfoEx.xDst=0;
	icinfoEx.yDst=0;
	icinfoEx.dxDst=icinfo->lpbiOutput->biWidth;
	icinfoEx.dyDst=abs(icinfo->lpbiOutput->biHeight);
	icinfoEx.xSrc=0;
	icinfoEx.ySrc=0;
	icinfoEx.dxSrc=icinfo->lpbiInput->biWidth;
	icinfoEx.dySrc=icinfo->lpbiInput->biHeight;

	return DecompressEx(&icinfoEx, dwSize);
}
#include "..\vtaccess\ie_dmm.h"
DWORD BwInst::DecompressEx( ICDECOMPRESSEX  *icinfo, DWORD dwSize)
{
    DWORD dw;
	ECODE ec;
	DWORD ImageSize;
	int ReloadTried=0;
	statprintf("DecompressEx:\n");

    if (!fDecompressBegin)
    {
        if (dw = DecompressBegin( icinfo->lpbiSrc, icinfo->lpbiDst))
            return dw;

        fDecompressBegin = FALSE;
    }

	DeCompressPostProc->InitEx(icinfo);

	statprintf("DecompressEx Input : Bits=%d Compression=%4.4s Hex %x\n",icinfo->lpbiSrc->biBitCount,&icinfo->lpbiSrc->biCompression,icinfo->lpbiSrc->biCompression);
	statprintf("DecompressEx Output : Bits=%d Compression=%4.4s Hex %x\n",icinfo->lpbiDst->biBitCount,&icinfo->lpbiDst->biCompression,icinfo->lpbiDst->biCompression);

    if (icinfo->dwFlags & ICDECOMPRESS_HURRYUP)
#if 1
			return ICERR_OK;
#else
	{
		// try clearing the flag
//		icinfo->dwFlags &= ~ICDECOMPRESS_HURRYUP;
		if (DecompressHurryupDropped++<2)
			return ICERR_DONTDRAW;
		else
			DecompressHurryupDropped=0;
	}
	else
		DecompressHurryupDropped=0;
#endif

	if (icinfo->lpbiSrc->biSizeImage==0)
		return ICERR_DONTDRAW;

	/* 
	 * if input is yuv - just convert it to the reqested format
	 * and return
	 */
	if (icinfo->lpbiSrc->biCompression == FOURCC_YUY2 || icinfo->lpbiSrc->biCompression == FOURCC_UYVY) {
		DeCompressPostProc->ProcessFrame((PUCHAR)icinfo->lpDst,(PUCHAR)icinfo->lpSrc);
		return ICERR_OK; 
	}

	DWORD t0=timeGetTime();

	DecodeCount++;
	DWORD Written,Read,status;
	void *Ptr;
	
	ImageSize=((DWORD*)icinfo->lpSrc)[0];
	if (ImageSize!=0 && ImageSize!=SEQUENCE_HEADER)
	{
		((DWORD*)icinfo->lpSrc)[0]=SEQUENCE_HEADER;
	}
	if ((ImageSize & 0xff000000)==0xff000000 && ((ImageSize & 0x00ffffff) > 0) 
		&& ((ImageSize & 0x00ffffff) <= icinfo->lpbiSrc->biSizeImage))  
		ImageSize&=0x00ffffff;
	else
		ImageSize=icinfo->lpbiSrc->biSizeImage;



	if ( fUseSoftwareCodec || (ec=GetHw(5))) // wait up to 10 ms
	{
//	   ec=DecodeFrame(SwDecoder,(UCHAR*)icinfo->lpInput,ImageSize,
//					(UCHAR*)icinfo->lpOutput, SwDecodeOutputType);
		ec=DeCompressPostProc->DecodeFrame(SwDecoder,(UCHAR*)icinfo->lpDst,(UCHAR*)icinfo->lpSrc,ImageSize);
		errprintf("Software decode time %d\n",timeGetTime()-t0);
		if (ec) 
			return ec;
		else  {
			//test code, put red dot to mark as sw decode
#if 0
			if(icinfo->lpbiDst->biBitCount == 16)
				((short *)icinfo->lpDst)[0] = 0x7c00;
			else {
				((unsigned char *)icinfo->lpDst)[0] = 0;
				((unsigned char *)icinfo->lpDst)[1] = 0;
				((unsigned char *)icinfo->lpDst)[2] = 255;
			}
			//end of test code	
//			statprintf("Software Decode Time %6.3fs\n",(timeGetTime()-t0)/1000.0);
#endif

			return ICERR_OK;
		} 
	}

	
	for(int i=0;i<2;i++)
	{
		ec=VT_Start(dwDevice);
		if (ec) return (DWORD)ICERR_ABORT;
		dwDevice->Regs->Status=0;
		ec=VT_WriteData(dwDevice,(DWORD*)icinfo->lpSrc,ImageSize/sizeof(DWORD),&Written);
		int count=0;
		if (!ec) 
		{
			DWORD tt=timeGetTime();
#if 0
			do // could just plain miss status so check for done too
			{
				VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
				if (Timeout(tt,1000)) 
				{
DB					VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
					errprintf("Decode Startup Timeout on frame %d status=0X%X\n",DecodeCount,status);
					break;
				}
				Sleep(0);
			} while (status==0);
#endif
			Sleep(18);
			ec=VT_ReadData(dwDevice,&Ptr,&Read);
			tt=timeGetTime();
			while (Read<DeCompressPostProc->GetInputFrameSize()/sizeof(DWORD) && ec==VT_NO_ERROR)
			{
				count++;
				if (Timeout(tt,1000)) 
				{
					VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
DB					dwDevice->Regs->Status=1<<21; // clear diag led
					errprintf("Decode Timeout on frame %d status=0X%X read=%d size=%d\n",DecodeCount,status,Read,DeCompressPostProc->GetInputFrameSize());
					break;
				}
				Sleep(0);
				ec=VT_ReadData(dwDevice,&Ptr,&Read);
			}
		}
		if (Read>=10000 && ec==VT_NO_ERROR)
		{
			ec=VT_Stop(dwDevice);
DB			DWORD t1=timeGetTime();
			DeCompressPostProc->ProcessFrame((PUCHAR)icinfo->lpDst,(PUCHAR)Ptr);
#ifdef DEBUG
			DWORD tt=timeGetTime()-t0;
			ttime+=tt;
			if ( tt> ttime/DecodeCount+15)
				errprintf("ERR frame %d Hardware Decode Time %6.3fs YUV time  %6.3fs loop count %d\n",DecodeCount,(t1-t0)/1000.0,(timeGetTime()-t1)/1000.0,count);
			else				
				statprintf("Hardware Decode Time %6.3fs YUV time  %6.3fs loop count %d\n",(t1-t0)/1000.0,(timeGetTime()-t1)/1000.0,count)
				;
#endif
			ReleaseHw();
		    return ICERR_OK;
		}
		else
		{
			if (ec==VT_ERR_FIFOOVERFLOW)
			{
				errprintf("Fifo overflow on decode frame %d \n",DecodeCount);
				// wait for status to clear
				DWORD t1=timeGetTime();
				do{
					Sleep(1);
					VT_Read(dwDevice,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
				} while (status!=0 && !Timeout(t1,30));
				ec=VT_Stop(dwDevice);

				// try again
			}
			else
			{
				//reload microcode and try again
				ReleaseHw();
				errprintf("Returning Don't Draw on decode frame %d ec=%d \n",DecodeCount,ec);
				return ICERR_DONTDRAW;
#if 0
					VT_Reset(dwDevice); // will steal the device 
//					VT_SetMode(dwDevice,VT_IDLE);
					VT_SetMode(dwDevice,VT_CODEC);
					VT_SetParam(dwDevice,CODECMODE,YUV_DECODE);
					if (ReloadTried++) break; // will try software
					Sleep(1000); // Give Ucode time to get going
#endif
			}
		}
	}
	ReleaseHw();
	ec=DeCompressPostProc->DecodeFrame(SwDecoder,(UCHAR*)icinfo->lpDst,(UCHAR*)icinfo->lpSrc,ImageSize);
	if (ec) 
	{
		errprintf("Failed decompress on frame %d\n",DecodeCount);
		return ICERR_DONTDRAW;
	}
	else
	{
		errprintf("************Switched to software codec on frame %d \n",DecodeCount);
		fUseSoftwareCodec=TRUE;
		return ICERR_OK; 
	}
}

/*****************************************************************************
 ****************************************************************************/
DWORD BwInst::DecompressEnd()
{
    fDecompressBegin = FALSE;
	delete DeCompressPostProc;
	DeCompressPostProc=NULL;
	dprintf("Averidge decode time is %6.2f ms\n",((double)ttime/DecodeCount));
	statprintf("Decompress End\n");
    return ICERR_OK;
}

DWORD		BwInst::DrawBegin(ICDRAWBEGIN *lParam1, DWORD strucsize)
{
	VT_SetMode(dwDevice,VT_IDECODE);
	VT_Start(dwDevice);
    //fDrawBegin = TRUE;
    return ICERR_OK;
}

DWORD		BwInst::Draw(ICDRAW *pDraw, DWORD strucsize)
{
	// WRITE THE DATA
	DWORD Written,status;
	if (pDraw->lpData==NULL) 
	{
		dprintf("Null buffer input\n");
		return ICERR_OK;
	}
	DWORD ImageSize=((DWORD*)pDraw->lpData)[0];
	if (ImageSize!=0 && ImageSize!=SEQUENCE_HEADER)
	{
		((DWORD*)pDraw->lpData)[0]=SEQUENCE_HEADER;
	}
	if ((ImageSize & 0xff000000)==0xff000000 && ((ImageSize & 0x00ffffff) > 0) 
		&& ((ImageSize & 0x00ffffff) <= pDraw->cbData))  
		ImageSize&=0x00ffffff;
	else
		ImageSize=pDraw->cbData;
	ImageSize>>=2;
	status=VT_WriteData(dwDevice,(DWORD*)pDraw->lpData,ImageSize,&Written);
	// go sleep loop ???? Do a draw??????
	if (status)
		dwDevice->Regs->Status = FIFO_OVERFLOW;  // clear fifo overflow
	while (Written<ImageSize)
	{
		Sleep(10);
		status=VT_WriteData(dwDevice,(DWORD*)pDraw->lpData,ImageSize,&Written);
		if (status)
			dwDevice->Regs->Status = FIFO_OVERFLOW;  // clear fifo overflow
	}
    return ICERR_OK;
}

DWORD		BwInst::DrawEnd()
{
	VT_SetMode(dwDevice,VT_CODEC);
    //fDrawBegin = FALSE;
    return ICERR_OK;
}

void BwInst::DecodeToUYVY(DWORD *InData, long InSize, long InWidth, long InHeight,
				  short *OutData)

/*
This function uses the sw decoder to decompress the specified data.
The output data is in UYVY (yuv 422) format.
*/
{
	SetFrameSize(SwDecoder, InWidth, InHeight);
	DecodeFrame(SwDecoder, (unsigned char *) InData, InSize * sizeof(DWORD),
						OutData, UYVY);
	
}


#ifdef DEBUG
FILE  *of=NULL;
#define TRACEWND_CLASSNAME "MfxTraceWindow"
#define TRACEWND_MESSAGE   "*WM_TRACE_MSG"


extern "C" void __cdecl dprintf(LPSTR szFormat, ...)
{
    char ach[128];
    va_list va;

#if 1
    va_start(va, szFormat);
    vsprintf(ach,szFormat,va);
    va_end(va);
#else
	strcpy(ach,szFormat);
#endif


if (VerInfo.dwPlatformId == VER_PLATFORM_WIN32_NT) 
{

	HWND TraceWnd = FindWindow(TRACEWND_CLASSNAME, NULL);
	if (TraceWnd) {
		static UINT WM_TRACE_MSG = RegisterWindowMessage(TRACEWND_MESSAGE);

		// Found Trace window: send message there as a global atom.
		// Delete atom after use.
		//
		ATOM atom = GlobalAddAtom((LPCSTR)ach);
		SendMessage(TraceWnd,WM_TRACE_MSG, (WPARAM)atom,NULL);
		GlobalDeleteAtom(atom);
	}
	else OutputDebugStringA(ach);
} else {
	if (of==NULL)
	{
		of=fopen("c:\\bw10.log","a+");
	}
	if (of!=NULL)
	{
		fwrite(ach,sizeof(char),strlen(ach),of);
//		fflush(of);
	}
	if (of!=NULL)
	{
		fclose(of);
		of=NULL;
	}
}

}
#endif
