/*--------------------------------------------------------------------------*\
|									     |
|   MS.H								     |
\*--------------------------------------------------------------------------*/

 /**************************************************************************
 *
 *  THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 *  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A PARTICULAR
 *  PURPOSE.
 *
 *  Copyright (c) 1991 - 1995  Microsoft Corporation.  All Rights Reserved.
 *
 **************************************************************************/

#ifdef _WIN32
#define huge
#endif

#include "fconv.h"

//
// compressor state info
//
class BwState {
public:
	DWORD state; // put any state info here
} ;

typedef BwState STATE,  *LPSTATE, *PSTATE;



class BwInst {
public:
	BwInst();
	~BwInst();

	void DecodeToUYVY(DWORD *InData, long InSize, long InWidth, long InHeight,
						short *OutData);

	DWORD        CompressBegin( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut);
	DWORD        CompressQuery( LPBITMAPINFOHEADER lpbiIn,LPBITMAPINFOHEADER lpbiOut);
	DWORD        CompressGetFormat( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut);
	DWORD        Compress(ICCOMPRESS FAR *icinfo, DWORD dwSize);
	DWORD        CompressGetSize( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut);
	DWORD        CompressEnd();
	DWORD		DecompressGetFormat( LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut);
	DWORD		DecompressEnd();

	DWORD		DecompressQuery(LPBITMAPINFOHEADER lpbiIn,LPBITMAPINFOHEADER lpbiOut);
	DWORD		DecompressBegin(LPBITMAPINFOHEADER lpbiIn, LPBITMAPINFOHEADER lpbiOut);
	DWORD		Decompress(ICDECOMPRESS FAR *icinfo, DWORD dwSize);
// ex functions
	int 		DecompressQueryEx(ICDECOMPRESSEX  *icinfo, DWORD dwSize);
	DWORD		DecompressBeginEx(ICDECOMPRESSEX  *icinfo, DWORD dwSize);
	DWORD  		DecompressEx(ICDECOMPRESSEX  *icinfo, DWORD dwSize);

	// use decompress query
	//DWORD		DrawQuery(LPBITMAPINFOHEADER lpbiIn,LPBITMAPINFOHEADER lpbiOut);

    DWORD		DrawBegin(ICDRAWBEGIN *lParam1, DWORD strucsize);

    DWORD		Draw(ICDRAW *lParam1, DWORD strucsize);

    DWORD		DrawEnd();
	DWORD		DrawWindow(PRECT prc);


	DWORD		CheckLoaded();
	DWORD		SetFrameInfo(LPBITMAPINFOHEADER lpbi); // set hwcodec frame info  
	DWORD		GetHw(DWORD Timeoutms=200);
	DWORD		ReleaseHw();
	DWORD		Close();
	//    LPVOID	lpbiPrev;
	DEVID		dwDevice;
//    PDEVICE_INFO pDevInfo;
	FrameConverter *CompressPreProc;
	FrameConverter *DeCompressPostProc;
	static int   MustInitDecoder;
	DECODE_FRAME *SwDecoder;
    int         iStart;
    long        lLastParm;
    long	lFrames;
    STATE    State;
	DWORD		dwOpenFlags;
	BOOL		fUseSoftwareCodec;
	BOOL		fUcodeLoaded;
    BOOL        fCompressBegin;
    BOOL        fDecompressBegin;
	int			DecompressHurryupDropped;
	int			ttime;
	ESWDecodeOutputType SwDecodeOutputType;
}; 

typedef BwInst INST, *PINST;


#define QUALITY_DEFAULT     10000

#define IDS_DESCRIPTION 42
#define IDS_NAME        43

extern HMODULE ghModule;

/****************************************************************************
 ***************************************************************************/

#ifdef _INC_COMPDDK

void       NEAR PASCAL Load(void);
void       NEAR PASCAL Free(void);
PINST   NEAR PASCAL Open(ICOPEN* Open);
DWORD      NEAR PASCAL GetState(PINST pri, LPVOID pv, DWORD dwSize);
DWORD      NEAR PASCAL SetState(PINST pri, LPVOID pv, DWORD dwSize);

DWORD      NEAR PASCAL GetInfo(PINST pri, ICINFO FAR *icinfo, DWORD dwSize);


#endif

/****************************************************************************
 ***************************************************************************/


//#define MAXSUMSQUARES               195075L
//#define MAXTOL                      0x00FFFFFFL
//#define ADAPTIVE                    -1
//#define NO_LIMIT                    -1

/****************************************************************************
 ***************************************************************************/

/* RgbTol Table structure */

typedef struct {
        int             ClrUsed;
        RGBQUAD         argbq[256];
	DWORD huge	*hpTable;
} RGBTOL;

extern RGBTOL gRgbTol;

/* Public functions anyone can call */


BOOL NEAR PASCAL MakeRgbTable(LPBITMAPINFOHEADER lpbi);


// in DF.ASM


/****************************************************************************
 DIB macros.
 ***************************************************************************/

#define WIDTHBYTES(i)           ((unsigned)((i+31)&(~31))/8)  /* ULONG aligned ! */

#define DibWidthBytesN(lpbi, n) (UINT)WIDTHBYTES((UINT)(lpbi)->biWidth * (UINT)(n))
#define DibWidthBytes(lpbi)     DibWidthBytesN(lpbi, (lpbi)->biBitCount)

#define DibSizeImage(lpbi)      ((lpbi)->biSizeImage == 0 \
                                    ? ((DWORD)(UINT)DibWidthBytes(lpbi) * (DWORD)(UINT)(lpbi)->biHeight) \
                                    : (lpbi)->biSizeImage)

#define DibSize(lpbi)           ((lpbi)->biSize + (lpbi)->biSizeImage + (int)(lpbi)->biClrUsed * sizeof(RGBQUAD))
#define DibPaletteSize(lpbi)    (DibNumColors(lpbi) * sizeof(RGBQUAD))

#define DibPtr(lpbi)            (LPVOID)(DibColors(lpbi) + (UINT)(lpbi)->biClrUsed)
#define DibColors(lpbi)         ((LPRGBQUAD)((LPBYTE)(lpbi) + (int)(lpbi)->biSize))

#define DibNumColors(lpbi)      ((lpbi)->biClrUsed == 0 && (lpbi)->biBitCount <= 8 \
                                    ? (int)(1 << (int)(lpbi)->biBitCount)          \
                                    : (int)(lpbi)->biClrUsed)

#define DibXYN(lpbi,pb,x,y,n)   (LPVOID)(                                     \
                                (LPBYTE)(pb) +                                 \
                                (UINT)((UINT)(x) * (UINT)(n) / 8u) +          \
                                ((DWORD)DibWidthBytesN(lpbi,n) * (DWORD)(UINT)(y)))

#define DibXY(lpbi,x,y)         DibXYN(lpbi,DibPtr(lpbi),x,y,(lpbi)->biBitCount)


#define FixBitmapInfo(lpbi)     if ((lpbi)->biSizeImage == 0)                 \
                                    (lpbi)->biSizeImage = DibSizeImage(lpbi); \
                                if ((lpbi)->biClrUsed == 0)                   \
                                    (lpbi)->biClrUsed = DibNumColors(lpbi);



/****************************************************************************
 ***************************************************************************/

#ifdef DEBUG
    extern void FAR CDECL dprintf(LPSTR, ...);
    #define DPF(_x_) dprintf _x_
#else
    #define DPF ; / ## /
#endif
