#include <windows.h>
#include <windowsx.h>
#include <mmsystem.h>
//#include <compddk.h>
#include <vfw.h>
#include <VT_ACC.h>
#include "mpeg2dec\ifrmdec.h"
#include "bwhw10.h"
#include <time.h> 
#define CODEC_STATUS_REGISTER (0x7fb0c)
#include "stretch.h"
#include "clipscale.h"

#define MAX_INPUT_DWORDS 1024*64/sizeof(DWORD)

#ifdef _DEBUG
#include "stdio.h"
extern "C" void __cdecl dprintf(LPSTR szFormat, ...);
#else
// this define produces a comment "//" before the paramiters 
#define dprintf / ## /
#endif

#define Timeout(From,ms) ((timeGetTime()-From) > ms)


ECODE StartEncode(DEVID Dev,DWORD *pData,DWORD DataSize)
{

/*
		DWORD status;
		VT_Read(Dev,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
		long t1a=timeGetTime();
		VT_Read(Dev,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
		// waite for status 200
		while (status!=0x200)
		{
				if (Timeout(t1a,5000))
				{
					dprintf("Start timeout\n");
		 		    ec=VT_Start(Dev);
					break;
				}
			Sleep(1);
			VT_Read(Dev,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
		}
		dprintf("Status wait time %6.3f \n",(timeGetTime()-t1a)/1000.0);
*/

		DWORD Written;
		ECODE ec=VT_WriteData(Dev,pData,DataSize,&Written);
		return (ec? ec : VT_Start(Dev));
}

ECODE GetEncodedData(DEVID Dev,DWORD **pData,DWORD *DataSize)
{
	DWORD t1=timeGetTime();
	DWORD status,ec;

	do 
	{	
		Sleep(1);
		VT_Read(Dev,VR_DRAM,&status,CODEC_STATUS_REGISTER,1);
	} while (status>=0x10 && !Timeout(t1, 1500));

	Sleep(1); // wait a bit more
	ec=VT_ReadData(Dev,(void **)pData,DataSize);
	if (ec) return ec;
	*pData+=16;  // drop 16 zeros off begginng
	*DataSize-=16;
	**pData=0xFF000000 |(*DataSize)*sizeof(DWORD);
//
// set the AVI index flags,
	return VT_Stop(Dev);
	
}


ECODE __stdcall CropVideoStream(void *InParam)
/*
This function uses the broadway hardware to crop and stretch the specified video stream
The cropped data is then sent to the second video stream
*/
{
	//get pointer to vid crop object 
	VIDEOCROP *VidCrop = (VIDEOCROP *)InParam;

	PAVISTREAM pInputStream = VidCrop->pInputStream;
	PAVISTREAM pOutputStream = VidCrop->pOutputStream;

	//get input & output data size
    BITMAPINFO biIn;
	long FormatSize = sizeof(biIn);
    if (0 != AVIStreamReadFormat(pInputStream, 0, &biIn, &FormatSize))
		return VT_CROP_ERROR;  //error code...
    int InWidth = biIn.bmiHeader.biWidth;
    int InHeight = biIn.bmiHeader.biHeight;
	int ClipWidth = InWidth - VidCrop->ClipLeft - VidCrop->ClipRight;
	int ClipHeight = InHeight - VidCrop->ClipTop -  VidCrop->ClipBottom;

    BITMAPINFO biOut;
	FormatSize = sizeof(biOut);
//    if (0 != AVIStreamReadFormat(pOutputStream, 0, &biOut, &FormatSize))
//		return VT_CROP_ERROR;  //error code...
/*
because of some *(&%^&* AVI file bug we can't always read the output format without crashing.
(the crash happens if the input has been edited so as to increase it's size.) 
This code is only used to convert to the size of the original, so we will just
set the output info equal to the input info.
*/
	biOut = biIn;

    int NewWidth = biOut.bmiHeader.biWidth;
    int NewHeight = biOut.bmiHeader.biHeight;


	//alloc data
    DWORD *InData = new DWORD[MAX_INPUT_DWORDS];	//compressed data buffer
    DWORD *pOutData ,OutSize;						//hardware buffer pointer
	short *InFrameData = new short[InWidth * InHeight];   //uncompressed input frame
	short *OutFrameData = new short[NewWidth * NewHeight];//uncompresed output frame	
	DWORD OutFrameDwords = NewWidth*NewHeight*sizeof(short)/sizeof(DWORD);


	//setup the codec sw and hardware
    BwInst *pInst = new BwInst;
	ECODE ec=VT_OpenDevice(TEXT("vtool"),0,  &pInst->dwDevice);
	if (ec != VT_NO_ERROR)
		return ec; 
	
	pInst->CheckLoaded();
	pInst->SetFrameInfo(&biOut.bmiHeader); //set output frame info
	if (!pInst->GetHw(1000)) // 1000 is 1 second timeout
	{
		// return error code here
	}
	VT_SetParam(pInst->dwDevice,CODECMODE,YUV_ENCODE);

    //do the mpeg encode thing
	DWORD status = VT_NO_ERROR;
    long SamplesRead = 0;
    long BytesRead = 0;
	long FrameCount = 0;
	long LastGoodFrameBytes = 0;
    int InSize = MAX_INPUT_DWORDS * sizeof(DWORD);

	// preproc first frame
	AVIStreamRead(pInputStream, FrameCount, 1, InData, InSize, &BytesRead, &SamplesRead);
	InData[0] = 0XB3010000;  //overwrite data size word with mpeg start code
	VT_SetParam(pInst->dwDevice,DATARATE,10000000);

	pInst->DecodeToUYVY(InData, BytesRead/sizeof(DWORD), InWidth, InHeight, InFrameData);
	StretchYUV422(OutFrameData, NewWidth, NewHeight, InFrameData, InWidth,	
					VidCrop->ClipLeft, VidCrop->ClipTop, ClipWidth, ClipHeight);

    //encode each frame in the avi stream
    while ( SamplesRead > 0) {
		//update object data frame count
		EnterCriticalSection(&VidCrop->CritSect);
		VidCrop->CurrentFrame = FrameCount++;
		BOOL abort = VidCrop->AbortCropping;  //should we abort?
		LeaveCriticalSection(&VidCrop->CritSect);

		//exit loop if abort flag is set in object data
		if (abort)
			break;

		// now start the encode
		StartEncode(pInst->dwDevice,(DWORD *)OutFrameData,OutFrameDwords);

		//read more data
        SamplesRead = 0;
		BytesRead = 0;
		AVIStreamRead(pInputStream, FrameCount, 1, InData, InSize, &BytesRead, &SamplesRead);

        //check for dropped frame
        if (BytesRead == 0) {
            //if this is a dropped frame, send last good frame (it's still in the buffer)
            BytesRead = LastGoodFrameBytes;
		}
		else
		{
			LastGoodFrameBytes = BytesRead;

			InData[0] = 0XB3010000;  //overwrite data size word with mpeg start code
			pInst->DecodeToUYVY(InData, BytesRead/sizeof(DWORD), InWidth, InHeight, InFrameData);
			StretchYUV422(OutFrameData, NewWidth, NewHeight, InFrameData, InWidth,	
							VidCrop->ClipLeft, VidCrop->ClipTop, ClipWidth, ClipHeight);
		}

		// now get the previous encoded frame
		ec = GetEncodedData(pInst->dwDevice,&pOutData,&OutSize);
		if (ec != 0) {
			dprintf("cropping encode error %x", ec);
			OutSize = 0;	//zero in case of error, we will show as a dropped frame
		}
		// now write the data to the output avi file
		if (0 != AVIStreamWrite(pOutputStream, FrameCount-1, 1, pOutData, OutSize*sizeof(DWORD),
													AVIIF_KEYFRAME, NULL, NULL)) {
			status = VT_CROP_ERROR;
			break;
		}

    }	

    //clean up
    delete [] InData;
	delete [] InFrameData;
	delete [] OutFrameData;
	pInst->ReleaseHw();
	delete pInst;
	return status;
}


extern "C" VIDEOCROP * __stdcall StartVideoCrop(PAVISTREAM pInputStream, PAVISTREAM pOutputStream,
					  int ClipLeft, int ClipTop, int ClipRight, int ClipBottom)

/*
This functions creates a video crop object and starts the worker thread to do the cropping.
The function returns the pointer to the object.
*/
{

	//allocate & init crop object data
	VIDEOCROP *VidCrop = new VIDEOCROP;
	if (VidCrop == NULL)
		return NULL;
	
	VidCrop->AbortCropping = FALSE;
	InitializeCriticalSection(&VidCrop->CritSect);
	VidCrop->pInputStream = pInputStream;
	VidCrop->pOutputStream = pOutputStream;
	VidCrop->ClipLeft = ClipLeft;
  	VidCrop->ClipTop =  ClipTop;
	VidCrop->ClipRight = ClipRight;
	VidCrop->ClipBottom = ClipBottom;
	VidCrop->CurrentFrame = 0;

	//allocate thread to do the work;
	DWORD ThreadID;
	VidCrop->hThread = CreateThread(NULL, 0, CropVideoStream, VidCrop, 0, &ThreadID);
	if (VidCrop->hThread == NULL) {
		delete VidCrop;
		return NULL;
	} 

	return VidCrop;
}

extern "C" long __stdcall GetVideoCropCurrentFrame(VIDEOCROP *VidCrop)
/*
returns the frame the currently being processed	(largest long if all done)
*/
{
	//if we are all done, return largest long
	if (WAIT_OBJECT_0 == WaitForSingleObject(VidCrop->hThread, 0) )
		return 0x7fffffff;

	//otherwise read from object data
	EnterCriticalSection(&VidCrop->CritSect);
	long CurrentFrame = VidCrop->CurrentFrame;
	LeaveCriticalSection(&VidCrop->CritSect);

	return CurrentFrame;
}


extern "C" DWORD __stdcall StopVideoCrop(VIDEOCROP *VidCrop)
/*
Stop the video cropping operation and clean up the video crop object
*/
{
	//stop processing (if needed)
	EnterCriticalSection(&VidCrop->CritSect);
	VidCrop->AbortCropping = TRUE;
	LeaveCriticalSection(&VidCrop->CritSect);
	WaitForSingleObject(VidCrop->hThread, INFINITE);
  
	//get processing results
	DWORD status = 1;
	GetExitCodeThread(VidCrop->hThread, &status);
	
	//clean up vid crop object
	CloseHandle(VidCrop->hThread);
	delete VidCrop;

	return status;
}
