#ifndef __IFRMDEC__
#define __IFRMDEC__
/*ifrmdec.h
interface to iframe decode library
*/ 

#ifdef __cplusplus
extern "C" {
#endif

typedef struct {
	int FrameWidth;
	int FrameHeight;
	unsigned char *FrameBuff[3];  //buffers for lum, Cb and Cr data
} DECODE_FRAME;

typedef enum {RGB555, RGB565, RGB24BIT, UYVY} ESWDecodeOutputType;

void InitMpegDecode(void);
void FreeMpegDecode(void);
DECODE_FRAME *OpenDecoder(void);
void CloseDecoder(DECODE_FRAME *df);
int SetFrameSize(DECODE_FRAME *df, int width, int height);
int DecodeFrame(DECODE_FRAME *df, unsigned char *FrameData, int FrameBytes,
							void *OutData, ESWDecodeOutputType OutputType);


#ifdef __cplusplus
}
#endif


#endif  //#ifndef __IFRMDEC__
