#ifndef _SBFILTER_
#define _SBFILTER_



/*
sbfilter.h
This class implements the MPEG-1 layer I & II audio encoding
subband filter. (see ISO/IEC 11172-3)
*/
#ifndef			PI
#define         PI                      3.14159265358979
#endif
#ifndef			PI64
#define         PI64                    PI/64
#endif

class CSubbandFilter {
    private:
	float	X[512];			//512 input samples (in circular buffer)
	int		InputIndex;		//circular index of next input 
	static const float C[512];	//input window function
	static int inited;		//set to true when static variables are initialized
	static float M[32*64];	/*2048 frequency coefs  (I know, I know, I could use
							a 128 point circular cos table, but with only 2048 total
							coefs, why waste time computing circular indexes?) */


    public:
    CSubbandFilter(void);

	//calc 32 subband values from 32 input samples
	void CalcSubbands(int MaxSB,float *TimeSamps, float *FreqSamps);

	// faster version for MaxSB <= 16
	void CalcSubbands_LE16(int MaxSB,float *TimeSamps, float *FreqSamps);

	// even faster version for MaxSB <= 8
	void CalcSubbands_LE8(int MaxSB,float *TimeSamps, float *FreqSamps);
	

};


#endif //#ifndef _SBFILTER_
