/*
 * 4000_reg.h - copy of /usr/dist/cl4000/tools/.common-2.1.1/reg4000.h
 *
 * (C) Copyright 1993 - C-Cube Microsystems - All rights reserved
 *
 */
#ifndef _REG4000_H_
#   define _REG4000_H_

/******************************************************************************
 *
 * The basic names are word addresses.  There is an alternate set of names
 * suffixed with "_B" that are byte addresses of the same name.
 */

/******************************************************************************
 *
 * G-Bus Registers (word addresses)
 *
 */

/*
 * HOST
 */
#   define GBUS_HCTL       0x0e
#   define GBUS_SEMA       0x0f

/*
 * DMA
 */
#   define GBUS_DMAMODE    0x0d
#   define GBUS_GUARD_BIT  0x1b
#   define GBUS_DMAREF     0x0c

/*
 * CPU
 */
#   define GBUS_DIR        0x23
#   define GBUS_PSW        0x22
#   define GBUS_IMEMDATA   0x07
#   define GBUS_IMEMCTL    0x0b
#   define GBUS_ISW        0x08
#   define GBUS_ISWRITE    0x09
#   define GBUS_ISREAD     0x09
#   define GBUS_ATTENT     0x1c

/*
 * ME
 */
#   define GBUS_MECTL      0x10
#   define GBUS_MECLIPDATA 0x11
#   define GBUS_MEMEMCTL   0x12
#   define GBUS_MEMEMDATA  0x13
#   define GBUS_MESCORECTL 0x14
#   define GBUS_MESCOREDAT 0x15

/*
 * VIDEO
 */
#   define GBUS_VACTL      0x16
#   define GBUS_VADATA     0x03
#   define GBUS_VBCTL      0x17
#   define GBUS_VBDATA     0x04

/*
 * VLC
 */
#   define GBUS_VLCCTL     0x18
#   define GBUS_VLCDATA    0x05
#   define GBUS_VLCSTART   0x19

/*
 * VLD
 */
#   define GBUS_VLDCTL     0x24
#   define GBUS_VLDDATA    0x25

/*
 * AMEM
 */
#   define GBUS_AMEM0      0x28
#   define GBUS_AMEM1      0x29
#   define GBUS_AMEM2      0x2a
#   define GBUS_AMEM3      0x2b
#   define GBUS_AMEM4      0x2c
#   define GBUS_AMEM5      0x2d
#   define GBUS_AMEM6      0x2e
#   define GBUS_AMEM7      0x2f


/******************************************************************************
 *
 * W-Bus Registers (word addresses)
 *
 */

/*
 * DMA
 */
#   define WBUS_CHMEM0     0x00
#   define WBUS_CHMEM1     0x01
#   define WBUS_CHMEM2     0x02
#   define WBUS_CHMEM3     0x03
#   define WBUS_CHMEM4     0x04
#   define WBUS_CHMEM5     0x05
#   define WBUS_CHMEM6     0x06
#   define WBUS_CHMEM7     0x07
#   define WBUS_BLT        0x10
#   define WBUS_INTCTL     0x11

/*
 * CPU
 */
#   define WBUS_CPUCTL     0x08
#   define WBUS_MULCTL     0x09
#   define WBUS_MULACC     0x0a
#   define WBUS_ISREADW    0x0f
#   define WBUS_JPC        0x0e

/*
 * VLC
 */
#   define WBUS_CPUPACK    0x0b
#   define WBUS_VLCZZ      0x0c

/*
 * VLD
 */
#   define WBUS_VLDZZ      0x0d

/******************************************************************************
 *
 * G-Bus Registers (byte addresses)
 *
 */

/*
 * HOST
 */
#   define GBUS_HCTL_B       (GBUS_HCTL << 2)
#   define GBUS_SEMA_B       (GBUS_SEMA << 2)

/*
 * DMA
 */
#   define GBUS_DMAMODE_B    (GBUS_DMAMODE << 2)
#   define GBUS_GUARD_BIT_B  (GBUS_GUARD_BIT << 2)
#   define GBUS_DMAREF_B     (GBUS_DMAREF << 2)

/*
 * CPU
 */
#   define GBUS_DIR_B        (GBUS_DIR << 2)
#   define GBUS_PSW_B        (GBUS_PSW << 2)
#   define GBUS_IMEMDATA_B   (GBUS_IMEMDATA << 2)
#   define GBUS_IMEMCTL_B    (GBUS_IMEMCTL << 2)
#   define GBUS_ISW_B        (GBUS_ISW << 2)
#   define GBUS_ISWRITE_B    (GBUS_ISWRITE << 2)
#   define GBUS_ISREAD_B     (GBUS_ISREAD << 2)
#   define GBUS_ATTENT_B     (GBUS_ATTENT << 2)

/*
 * ME
 */
#   define GBUS_MECTL_B      (GBUS_MECTL << 2)
#   define GBUS_MECLIPDATA_B (GBUS_MECLIPDATA << 2)
#   define GBUS_MEMEMCTL_B   (GBUS_MEMEMCTL << 2)
#   define GBUS_MEMEMDATA_B  (GBUS_MEMEMDATA << 2)
#   define GBUS_MESCORECTL_B (GBUS_MESCORECTL << 2)
#   define GBUS_MESCOREDAT_B (GBUS_MESCOREDAT << 2)

/*
 * VIDEO
 */
#   define GBUS_VACTL_B      (GBUS_VACTL << 2)
#   define GBUS_VADATA_B     (GBUS_VADATA << 2)
#   define GBUS_VBCTL_B      (GBUS_VBCTL << 2)
#   define GBUS_VBDATA_B     (GBUS_VBDATA << 2)

/*
 * VLC
 */
#   define GBUS_VLCCTL_B     (GBUS_VLCCTL << 2)
#   define GBUS_VLCDATA_B    (GBUS_VLCDATA << 2)
#   define GBUS_VLCSTART_B   (GBUS_VLCSTART << 2)

/*
 * VLD
 */
#   define GBUS_VLDCTL_B     (GBUS_VLDCTL << 2)
#   define GBUS_VLDDATA_B    (GBUS_VLDDATA << 2)

/*
 * AMEM
 */
#   define GBUS_AMEM0_B      (GBUS_AMEM0 << 2)
#   define GBUS_AMEM1_B      (GBUS_AMEM1 << 2)
#   define GBUS_AMEM2_B      (GBUS_AMEM2 << 2)
#   define GBUS_AMEM3_B      (GBUS_AMEM3 << 2)
#   define GBUS_AMEM4_B      (GBUS_AMEM4 << 2)
#   define GBUS_AMEM5_B      (GBUS_AMEM5 << 2)
#   define GBUS_AMEM6_B      (GBUS_AMEM6 << 2)
#   define GBUS_AMEM7_B      (GBUS_AMEM7 << 2)


/******************************************************************************
 *
 * W-Bus Registers (byte addresses)
 *
 */

/*
 * DMA
 */
#   define WBUS_CHMEM0_B     (WBUS_CHMEM0 << 2)
#   define WBUS_CHMEM1_B     (WBUS_CHMEM1 << 2)
#   define WBUS_CHMEM2_B     (WBUS_CHMEM2 << 2)
#   define WBUS_CHMEM3_B     (WBUS_CHMEM3 << 2)
#   define WBUS_CHMEM4_B     (WBUS_CHMEM4 << 2)
#   define WBUS_CHMEM5_B     (WBUS_CHMEM5 << 2)
#   define WBUS_CHMEM6_B     (WBUS_CHMEM6 << 2)
#   define WBUS_CHMEM7_B     (WBUS_CHMEM7 << 2)
#   define WBUS_BLT_B        (WBUS_BLT << 2)
#   define WBUS_INTCTL_B     (WBUS_INTCTL << 2)

/*
 * CPU
 */
#   define WBUS_CPUCTL_B     (WBUS_CPUCTL << 2)
#   define WBUS_MULCTL_B     (WBUS_MULCTL << 2)
#   define WBUS_MULACC_B     (WBUS_MULACC << 2)
#   define WBUS_ISREADW_B    (WBUS_ISREADW << 2)
#   define WBUS_JPC_B        (WBUS_JPC << 2)

/*
 * VLC
 */
#   define WBUS_CPUPACK_B    (WBUS_CPUPACK << 2)
#   define WBUS_VLCZZ_B      (WBUS_VLCZZ << 2)

/*
 * VLD
 */
#   define WBUS_VLDZZ_B      (WBUS_VLDZZ << 2)

/*****************************************************************************/

#   undef DECLARE
#   ifdef _REG4000_C_
#       define DECLARE
#   else /* _REG4000_C_ */
#       define DECLARE extern
#   endif /* _REG4000_C_ */

#endif /* _REG4000_H_ */
