/*************************************************************************
 *
 * Copyright C-Cube Microsystems 1995
 *
 *************************************************************************/
/*  @(#)dmem.h	1.16 2/6/97 */

#define MBCOL                   22
/* #define DROP_FRAMES */

/* FREE SPACE FOR STATUS INDICATORS */
#define SAVE_FRAME_NUMBER       (0x1FE << 2)
#define SAVE_SKIPPED_FRAMES     (0x1FF << 2)

/* FREE SPACE FOR HIGH LEVEL REFERENCE XFER TABLES STARTS AT 0x200<<2   */
#ifndef SYNCED_OBITS /* SO1 */
#define REFB_SCHED_B_SIZE	(0x20 << 2)
#else
#define REFB_ZERO_STUF_SIZE     (0x20 << 2)
#define REFB_XFER_SIZE          (0x14 << 2)
#define REFB_SCHED_B_SIZE       ((REFB_ZERO_STUF_SIZE) + (REFB_XFER_SIZE))
#endif /* SYNCED_OBITS */
#define CONTROL_DMEM            (0x200 << 2)
#define CONTROL_FLAG_LOC        (0x20F << 2)
#define DUMMY_XFER              (0x220 << 2)
#ifndef SYNCED_OBITS /* SO2 */
#define DA_REFB_SCHED_B_PING    (0x290 << 2)
#define DA_REFB_SCHED_B_PONG    (DA_REFB_SCHED_B_PING + REFB_SCHED_B_SIZE)
#define DA_REFB_SCHED_B_END	(DA_REFB_SCHED_B_PONG + REFB_SCHED_B_SIZE)
#else /* SO3 */
#define DA_FRAME_IN_OBIT_Q      (0x280 << 2)
#define DA_BANK_LOC             (0x281 << 2)
#define DA_REFB_SCHED_B         (0x290 << 2)
#define DA_REFB_SCHED_B_END     (DA_REFB_SCHED_B + REFB_XFER_SIZE)
#endif /* SYNCED_OBITS */

/* The reference schedule buffer ends at 0x2B0 */ 
/* Second chance stuff */
#define SECOND_CHANCE_FLAG		(0x2f0 << 2)
#define VIDEO_HDEC_PTR_SECOND_CHANCE	(0x2f1 << 2)
#define CHK_SECOND_CHANCE_LINE	(0x2f2 << 2)

/* Version no. */
#define DA_VERSION_NO		(0x39d << 2)

/* Vsync polarity control: */
/* if dmem[DA_VSYNC_POLARITY >> 2] == 0 */
/*    vsync == 0 => even field */ 
/*    vsync == 1 => odd field */ 
/* else */
/*    vsync == 1 => even field */ 
/*    vsync == 0 => odd field */ 

#define DA_VSYNC_POLARITY	(0x39e << 2)
#define DA_VCR_BLANK            (0x39f << 2) 

/* MSE data passing area  */
#define DA_MSE_READY            (0x3A0)     
#define DA_MSE_PREV_SCORE       (DA_MSE_READY + 1)
#define DA_MSE_NEXT_SCORE       (DA_MSE_READY + 2)
#define DA_INV32_MATCH          (DA_MSE_READY + 3)
#define DA_FRAME_FLAG           (DA_MSE_READY + 4)

/* capture words area must be aligned on N_HDEC_BUFFERS word address */
#define N_HDEC_BUFFERS 3
#define DA_CAPTURE_EVEN_TABLE  (0x3c0 << 2)
#define DA_CAPTURE_ODD_TABLE   (0x3d0 << 2)

/* locations for managing video B output banks */
#define FEATURE_OBANK_ENABLE	(0x1)
#define FEATURE_OBITS_FIELD	(0x2)
#define DA_FEATURE_FLAGS	(0x3d3 << 2)
#define DA_BANK1B_SIZE          (0x3d4 << 2)
#define DA_BANK2B_SIZE          (0x3d5 << 2)

/* Video A/B 8/16 bits control flag */
#define DA_VIDA_BUS_WIDTH	(0x3d6 << 2)
#define DA_VIDB_BUS_WIDTH	(0x3d7 << 2)

/* bitstream (data size, in 32-bit word) header control flag */
#define DA_OBITS_HDR_ENABLE	(0x3d8 << 2)

#ifdef DROP_FRAMES
#define D_DROP_FRAMES_NUMBER    (0x3d9 << 2)
#define D_INTRA_DIST            (0x3da << 2)
#define D_REF_DIST              (0x3db << 2)
#define D_GOP_DIST              (0x39c << 2)
#define CHANGE_GOP              (0x39b << 2)
#endif


/* SCR REGISTER LOCATION */	
#define DA_SCR_REG_ADDR			(0x3dc << 2)

/* AUDIO START REGISTER LOCATION */
#define DA_DUMMY			(0x3dd << 2)
#define DA_AUDIO_START_REG		(0x3de << 2)

/* PTS REGISTER LOCATION */	
#define DA_PTS_REG_ADDR			(0x3df << 2)

/* VIDEO CAPTURE JUNK LOCATIONS */
#define DA_ODD_VACTL_WORD 		(0x3e0 << 2)
#define DA_EVEN_VACTL_WORD		(0x3e1 << 2)
#define DA_CUR_VACTL_WORD 		(0x3e2 << 2)

#define DA_ODD_VIDEO_MB_ROW_INCR 	(0x3e3 << 2)
#define DA_EVEN_VIDEO_MB_ROW_INCR 	(0x3e4 << 2)
#define DA_CUR_VIDEO_MB_ROW_INCR 	(0x3e5 << 2)

#define DA_ODD_FIRST_VIS_OFFSET		(0x3e6 << 2)
#define DA_EVEN_FIRST_VIS_OFFSET	(0x3e7 << 2)

#define DA_ODD_FIELD_JUNK_SKIP		(0x3e8 << 2)
#define DA_EVEN_FIELD_JUNK_SKIP		(0x3e9 << 2)

#define DA_ABS_LINES_INIT_VAL		(0x3ea << 2)
#define DA_FIELD_DADR			(0x3eb << 2)

#define DROP_FRAMES_NUMBER       (0x3ec << 2)

/* CHIP_WAIT_LOC: USED FOR INTERCHIP COORDINATION */
#define CHIP_WAIT_LOC            (0x3ed << 2)

/* STACK SAVE DMEM LOCATION WHEN ENTERING SLICE */
#define SP_SAVE_DADR		(0x3ee << 2)

/* VIDEO DEBUG POINTER LOCATION Must be in low dmem for single IMEM load*/
#define VID_DEBUG_PTR_LOC	(0x3ef << 2)

/* INPUT DMEM LOCATIONS OVERLAYING LOW INSTRUCTIONS */
/* RATE CONTROL DMEM LOCATIONS */
/* MUST BE LOADED AFTER CODE!!!!! */
#define I_FRAME_BITS_PER_MB     (0x3f0 << 2)
#define P_FRAME_BITS_PER_MB     (0x3f1 << 2)
#define B_FRAME_BITS_PER_MB     (0x3f2 << 2)
#define BITS_PER_SEC_DIV_400    (0x3f3 << 2)
#define ONE_OVER_VBV_SIZE       (0x3f4 << 2)
#define INIT_VBV_FULLNESS       (0x3f5 << 2)
#define HDR_VBV_SIZE_LOC        (0x3f6 << 2)
#define VBV_DLY_SCALE_LOC       (0x3f7 << 2)
#define AVG_BITS_PER_FRAME      (0x3f8 << 2)

/* Data passed down from the LOADER */
#define TARGET_BIT_RATE         (0x3f9 << 2)
#define IONLY_FLAG              (0x3fa << 2)

/* VIDEO LOCATIONS */
#define DA_HAVE_TOKEN           (0x3fb << 2)
#define DA_WAIT_VIDA_RDY        (0x3fc << 2)
#define DA_VIDIN_DST            (0x3fd << 2)
#define DA_VIDIN2_DST           (0x3fe << 2)
#define REFBXF_TBLPTR_DADR      (0x3ff << 2)

#ifdef SYNCED_OBITS /* SO4 */
/* Free space from 0x400 - 0x4ff and it is used as the output */
/* bitstream schedule queue */
#define DA_OBIT_SCHED_Q_WR      (0x600 << 2)
#define DA_OBIT_SCHED_Q_RD      (0x601 << 2)
#define DA_OBIT_SCHED_Q_BASE    (0x400 << 2)
#define OBIT_SCHED_Q_SIZE       (0x100 << 2)
#define DA_OBIT_SCHED_Q_END     (DA_OBIT_SCHED_Q_BASE + OBIT_SCHED_Q_SIZE)
#endif /* SYNCED_OBITS */


#define BASE                    (0x9000)

#define		DMA_a0_TABLE	(BASE)
#define         DA_ME2          (BASE+0x40)
#define		DA_CLIPX	(BASE+0x400)
#define		DA_CLIPY	(BASE+0x560)
#define 	DA_BTB          (BASE+0x680)
#define 	DA_PTB          (BASE+0xc80)

/*  VLC Table DRAM Addresses  */
#define	VLC_TABLES			(DA_PTB + 0x600)

#define MBA_TBL      0x0         /* Low 16 bits of VLC_Table addresses. */
#define MTYPE_P_TBL  0x24
#define MTYPE_B_TBL  0x2C
#define CBP_TBL      0x3C
#define MV_TBL       0x7C
#define DC_L_TBL     0xAD
#define DC_C_TBL     0x12E
#define DPCM_TBL     0x1AF
#define MTYPE_I_TBL  0x2af

#define	COS_TABLE			(VLC_TABLES + 0x2c0)
#define	COS_TABLE_SIZE			(32)

#define PTABLE_ADDRESS			(COS_TABLE + COS_TABLE_SIZE)
#define PTABLE_SIZE			(64)	

#define	MQUANT_OFFSET_TABLE		(PTABLE_ADDRESS + PTABLE_SIZE)
#define	D_MQUANT_TABLE			(MQUANT_OFFSET_TABLE)
#define	MQUANT_OFFSET_TABLE_SIZE	(396)		

#define	ME1_CLIP_TABLE_SIZE		(792+(8<<2)) 

#define	ME1_CLIP_TABLE_B		(MQUANT_OFFSET_TABLE + MQUANT_OFFSET_TABLE_SIZE) 
#define	ME1_CLIP_TABLE_P		(ME1_CLIP_TABLE_B + ME1_CLIP_TABLE_SIZE) 

#define DA_F_VBS_VBF            	(ME1_CLIP_TABLE_P + ME1_CLIP_TABLE_SIZE)

#define QUANT_TABLE_SIZE        (32)
#define NUM_QUANT_TABLES        (32)
#define TOTAL_QUANT_TABLE_SIZE		(QUANT_TABLE_SIZE*NUM_QUANT_TABLES)
#define	QUANT_TABLES_INTRA		(DA_F_VBS_VBF + 0x200)
#define	QUANT_TABLES_NONINTRA		(QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)
#define	DQUANT_TABLES_INTRA		(QUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE)
#define	DQUANT_TABLES_NONINTRA		(DQUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)

#define	BITSTREAM_BASE_ADDR		(BASE+0x3000)
#define D_VLC_OUTPUT			(BITSTREAM_BASE_ADDR)

/* this size must be a power of 2 */
#define	BITSTREAM_BUF_SIZE		(0x8000)


/* @@@@@@@@@@@@@@@@@@ START OF THE BUFFERS @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ */

#define BUF_START_ADDR			(BITSTREAM_BASE_ADDR + BITSTREAM_BUF_SIZE)

#define DISTANCE			(4)

#define BUF_HDEC_EVEN_SIZE		(18*22*128)   /* longer row for 710 capture */

#define BUF_REF_LUMA_SIZE		(18*MBCOL*64)
#define BUF_REF_CHROMA_SIZE		(18*MBCOL*32)
#define BUF_SIF_LUMA_SIZE		(18*MBCOL*64)
#define BUF_SIF_CHROMA_SIZE		(18*MBCOL*32)
#define BUF_QSIF_SIZE			(18*MBCOL*16)

/* PP buf size has 2 leading locations with SUM_STAT_TOT and SUM_STAT_MIN */
#define STAT_OFFSET_SIZE		(0x10)
#define BUF_PP_STATS_SIZE		((18*MBCOL*2) + STAT_OFFSET_SIZE)



#define BUF_REF_LUMA_1			(BUF_START_ADDR)
#define BUF_REF_LUMA_2			(BUF_REF_LUMA_1 + BUF_REF_LUMA_SIZE + (64*DISTANCE))

#define BUF_REF_CHROMA_1		(BUF_REF_LUMA_2 + BUF_REF_LUMA_SIZE + (64*DISTANCE))

#define BUF_REF_CHROMA_2		(BUF_REF_CHROMA_1 + BUF_REF_CHROMA_SIZE + (64*DISTANCE))

#define BUF_SIF_LUMA_1			(BUF_REF_CHROMA_2 + BUF_REF_CHROMA_SIZE + (64*DISTANCE))
#define BUF_SIF_LUMA_2			(BUF_SIF_LUMA_1 + BUF_SIF_LUMA_SIZE + (64*DISTANCE))
#define BUF_SIF_LUMA_3			(BUF_SIF_LUMA_2 + BUF_SIF_LUMA_SIZE + (64*DISTANCE))
#define BUF_SIF_LUMA_4			(BUF_SIF_LUMA_3 + BUF_SIF_LUMA_SIZE + (64*DISTANCE))

#define BUF_SIF_CHROMA_1		(BUF_SIF_LUMA_4 + BUF_SIF_LUMA_SIZE + (32*DISTANCE))
#define BUF_SIF_CHROMA_2		(BUF_SIF_CHROMA_1 + BUF_SIF_CHROMA_SIZE + (32*DISTANCE))
#define BUF_SIF_CHROMA_3		(BUF_SIF_CHROMA_2 + BUF_SIF_CHROMA_SIZE + (32*DISTANCE))
#define BUF_SIF_CHROMA_4		(BUF_SIF_CHROMA_3 + BUF_SIF_CHROMA_SIZE + (32*DISTANCE))

#define BUF_QSIF_1			(BUF_SIF_CHROMA_4 + BUF_SIF_CHROMA_SIZE + (16*DISTANCE))
#define BUF_QSIF_2			(BUF_QSIF_1 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_3			(BUF_QSIF_2 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_4			(BUF_QSIF_3 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_5			(BUF_QSIF_4 + BUF_QSIF_SIZE + (16*DISTANCE))
#define BUF_QSIF_6			(BUF_QSIF_5 + BUF_QSIF_SIZE + (16*DISTANCE))


#define	ALT_QUANT_TABLES_INTRA		(BUF_QSIF_6 + BUF_QSIF_SIZE + (16*DISTANCE))
#define	ALT_QUANT_TABLES_NONINTRA	(ALT_QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)
#define	ALT_DQUANT_TABLES_INTRA		(ALT_QUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE)
#define	ALT_DQUANT_TABLES_NONINTRA	(ALT_DQUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE)

#define D_ME_RESULTS			(ALT_DQUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE) 
#define	D_ME_RES_SIZE			((22 * 18 * 8) + 0x10)
/* 0x10 extra locations for leading frame data struct */
#define	QS_NBS_TABLE			(D_ME_RESULTS + D_ME_RES_SIZE)
#define DA_QP_MASK              	(QS_NBS_TABLE)

#ifdef HIGH_LEVEL	
#define REAL_PP_STAT_BUF_BEGIN		(QS_NBS_TABLE + BUF_PP_STATS_SIZE)
#else 					/* C-MODEL USES DA_QP_MASK */
#define REAL_PP_STAT_BUF_BEGIN		(QS_NBS_TABLE + 700)
#endif

#define	BUF_PP_STATS_1			(REAL_PP_STAT_BUF_BEGIN+ STAT_OFFSET_SIZE)
#define	BUF_PP_STATS_2			(BUF_PP_STATS_1 + BUF_PP_STATS_SIZE)
#define	BUF_PP_STATS_3			(BUF_PP_STATS_2 + BUF_PP_STATS_SIZE)
#define	BUF_PP_STATS_4			(BUF_PP_STATS_3 + BUF_PP_STATS_SIZE)


#define D_TRASH                 	((BUF_PP_STATS_4 + BUF_PP_STATS_SIZE + 0x7f) & 0xffffff80)
#define D_END_ADDR			(D_TRASH + 0x10)


/* round to the next 0x200 boundary */
#define HDEC_START_ADDR                 (((D_END_ADDR/0x200)+1)*0x200) + 0x600
#define BUF_HDEC_EVEN_1			(HDEC_START_ADDR)
#define BUF_HDEC_EVEN_2			(BUF_HDEC_EVEN_1 + BUF_HDEC_EVEN_SIZE)
#define BUF_HDEC_EVEN_3			(BUF_HDEC_EVEN_2 + BUF_HDEC_EVEN_SIZE)
#define BUF_HDEC_EVEN_4			(BUF_HDEC_EVEN_3)
#define BUF_HDEC_ODD_1			(BUF_HDEC_EVEN_1)
#define BUF_HDEC_ODD_2			(BUF_HDEC_EVEN_2)
#define BUF_HDEC_ODD_3			(BUF_HDEC_EVEN_3)
#define BUF_HDEC_ODD_4			(BUF_HDEC_EVEN_4)


/* *******  David and Tom's Buffer Definitions ************** */

#define D_LUMA_601_E			BUF_HDEC_EVEN_1	
#define D_LUMA_601_O			BUF_HDEC_ODD_1	
#define D_LUMA_SIF_PREV			BUF_SIF_LUMA_1
#define D_LUMA_SIF_OUT			BUF_SIF_LUMA_2
#define D_CHROMA_SIF_OUT		BUF_SIF_CHROMA_1
#define D_LUMA_QSIF_OUT			BUF_QSIF_1
#define D_LUMA_CURR			BUF_SIF_LUMA_3
#define D_CH_CURR			BUF_SIF_CHROMA_2
#define D_LUMA_FWD_REF			BUF_REF_LUMA_1
#define D_LUMA_BWD_REF			BUF_REF_LUMA_2
#define D_CH_FWD_REF			BUF_REF_CHROMA_1
#define D_CH_BWD_REF			BUF_REF_CHROMA_2
#define D_QSIF_CURR			BUF_QSIF_2
#define D_QSIF_FWD_REF			BUF_QSIF_3
#define D_QSIF_BWD_REF			BUF_QSIF_4
#define D_LUMA_RECON_OUT		BUF_REF_LUMA_2
#define D_CHROMA_RECON_OUT		BUF_REF_CHROMA_2
#define BIT_BUFFER			BITSTREAM_BASE_ADDR

#define D_LUMA_601_PREV			D_LUMA_SIF_PREV
#define D_QSIF_REF			D_QSIF_FWD_REF

#define D_ME1_CLIP_TABLE_B		ME1_CLIP_TABLE_B
#define D_QUANT_TABLES_INTRA		QUANT_TABLES_INTRA
#define D_QUANT_TABLES_NONINTRA		QUANT_TABLES_NONINTRA

#define D_F_VBF_VBS_PTR			DA_F_VBS_VBF

/* *************************************************** */
 

