#ifdef BUILD_DLL
#include "stdincs.h"
extern HANDLE hModule;  // Global handle
#elif defined(NO_MFC)  
#include "bldhelper.h"
extern HANDLE hModule;  // Global handle
#else
#include "stdafx.h"
#define hModule AfxGetResourceHandle( )
#include "bldhelper.h"
#endif

#include <assert.h>
#include <stdio.h>


void or32(volatile DWORD *addr,DWORD value)
{
	*addr|=value;
/*
	__asm {
			mov dx,addr
			mov dword ptr dx,value
	}
*/
}

inline void or32a(volatile DWORD *addr,DWORD value)
{
	__asm 
	{
		mov       ecx,dword ptr value
		mov       eax,dword ptr addr
		or        dword ptr [eax],ecx
	}
}

inline void Write32a(volatile DWORD* addr,DWORD value) 
{
	__asm 
	{
		mov       ecx,dword ptr value
		mov       eax,dword ptr addr
		mov       dword ptr [eax],ecx

	  
//		mov edx,addr
//		mov dword ptr [edx], value
	}
}

#define or32m(addr,value) __asm or dword ptr [addr] , value
 
#if 0
static DWORD Change32(volatile DWORD *addr,DWORD mask,DWORD value)
{
		return *addr= (*addr & ~mask) | (value & mask);

/*
	__asm {
			mov dx,addr
			mov dword ptr dx,value
	}
*/
}
#endif
#define  IREG_READ_TIMEOUT	 1000
#define  IREG_WRITE_TIMEOUT	 1000


void CDevice::VrpPokeNoMutex(DWORD addr, DWORD data)
{
 	int i=0;
	PREGS r=Regs;
//	or32a(&r->Csr,IREG_WR);
	Write32(&r->Csr,r->Csr|IREG_WR);
    r->IRegAddr=addr;
    r->IRegData=data;
	while (r->Csr & IREG_OP_BUSY) 
		if (i++>IREG_WRITE_TIMEOUT) 
		{
			throw VT_ERR_IREG_TIMEOUT;
		}
#ifdef DIAGNOSE
//	if (!(Regs->Csr & VRP_SEL)) throw VT_ERR_VRP_SEL;
#endif
}

DWORD CDevice::VrpPeekNoMutex(DWORD addr)
{
	int i=0;
	Write32(&Regs->Csr,Regs->Csr&~IREG_WR);
    Regs->IRegAddr = addr;
	while (Regs->Csr & IREG_OP_BUSY) 
		if (i++>IREG_READ_TIMEOUT) 
			throw VT_ERR_IREG_TIMEOUT;
#ifdef DIAGNOSE
//	if (!(Regs->Csr & VRP_SEL)) throw VT_ERR_VRP_SEL;
#endif
    return Regs->IRegData;
}


void CDevice::VrpChange(DWORD addr,DWORD mask, DWORD data)
{
 	CAutoMutex AutoMutex;  // I do not believe this is needed
	VrpPokeNoMutex( addr, (VrpPeekNoMutex( addr) & ~mask) | (data & mask));
}



void CDevice::CrPoke(DWORD addr, DWORD data)
{
	CAutoMutex AutoMutex;  // I do not believe this is needed
	Change32(&Regs->Csr,VRP_SEL,0);
	VrpPokeNoMutex(addr<<2, data);
#ifdef CHECK_BUILD
	if (VrpPeekNoMutex(addr<<2) != data)
	{
		__asm int 3;
	}
#endif
	Change32(&Regs->Csr,VRP_SEL,VRP_SEL);
}

DWORD CDevice::CrPeek(DWORD addr)
{
	CAutoMutex AutoMutex;  // I do not believe this is needed
	DWORD value;
	Change32(&Regs->Csr,VRP_SEL,0);
	value=VrpPeekNoMutex(addr<<2);
	Change32(&Regs->Csr,VRP_SEL,VRP_SEL);
	return value;
}

void CDevice::CrChange(DWORD addr,DWORD mask, DWORD data)
{
 	CAutoMutex AutoMutex;  // I do not believe this is needed
	Change32(&Regs->Csr,VRP_SEL,0);
	VrpPokeNoMutex( addr, (VrpPeekNoMutex( addr) & ~mask) | (data & mask));
	Change32(&Regs->Csr,VRP_SEL,VRP_SEL);
}

ECODE CDevice::VidOutCtlPoke(DWORD data)
{
	    DWORD ctrl2;
		ctrl2=CrPeek(CTRL2);
		CrChange(CTRL1,VIDEO_EN,0);
		CrChange(CTRL2,FIFO_RESET,FIFO_RESET);
		CrChange(CTRL1,FIRST_PIXEL,FIRST_PIXEL);
		CrPoke(CTRL2,FIFO_MODE_WRITE|FIFO_RESET);
		CrPoke(CTRL2,FIFO_MODE_WRITE|FIFO_RESET);
		CrPoke(FIFO_DATA,data);
		CrPoke(FIFO_DATA,data);
		CrChange(CTRL2,FIFO_LD,FIFO_LD);
		CrChange(CTRL2,FIFO_LD,0);
		CrChange(CTRL1,FIRST_PIXEL,0);
		CrPoke(CTRL2,ctrl2);// if this worked all worked
		return 0;
}


#ifdef _debug
	#ifndef BUILD_DLL
		#ifdef _CONSOLE
			#define dprintf printf
		#else
			#define dprintf OutputDebugString 
		#endif
	#endif
#endif

static VIP_REGS DefaultVipValues={
0x00, 0x00,
0xc0, 0x23,
0x00, 0x00, 
0xDb, 0xFF, 
0x88, 0x1, 
0x80, 0x47, 
0x40, 0x00, 
0x00, 0x00, 
0x50, 0x0c, 
0x00} ;

#define MAX_REGISTRY_PATH 256

#define STR_BROADWAY_OPTIONS_SUBKEY "SOFTWARE\\Data Translation\\Broadway\\Options"
#define STR_ENABLE_SHORT_BURSTS     "EnableShortBursts"


BOOL HW_GetShortBurstEnable (BOOL bDefault)
{
    DWORD dwResult, Type, Length, lRet;
    HKEY hkOptions;

    /* See if we can get a registry handle to our settings data */
    lRet = RegOpenKey(HKEY_LOCAL_MACHINE, STR_BROADWAY_OPTIONS_SUBKEY, &hkOptions);
    if (lRet  == ERROR_SUCCESS) {

        /* try to get the current Neptune setting */
        Length = sizeof(dwResult);  
        lRet = RegQueryValueEx(hkOptions
                               ,STR_ENABLE_SHORT_BURSTS
                               ,NULL
                               ,&Type
                               ,(PUCHAR)&dwResult
                               ,&Length
                               );

        RegCloseKey(hkOptions);
        
        /* if there was a current setting - use it */
        if ((lRet == ERROR_SUCCESS) && (Type == REG_DWORD)) {
            return (dwResult == 0) ?FALSE:TRUE;
        }
    }

    return bDefault;
}

void ShortDelay(int Delay_us,BOOL FromLast=FALSE);
void InitShortDelay();

CDevice::CDevice(HANDLE hDev/*=NULL*/,PDEVICE_INFO pDI)
{
	memset(this,0,sizeof(CDevice));  //zero out structure
	memcpy(&VipRegs,&DefaultVipValues,sizeof(VIP_REGS));
	CaptureInfo.StructSize=sizeof(CAPTUREINFO);
	RecodeInfo.StructSize=sizeof(RECODEINFO);
	CodecInfo.StructSize=sizeof(COMPRESSINFO);
	InitShortDelay();
	ShortBurstsOnly=HW_GetShortBurstEnable (FALSE);
	if (Mutex==NULL) CreateMutex();
	if (hDev) // we have a driver/vxd init pointers to global data
	{
		hDriver=hDev;
	}

	if (!pDI)
	{

		pDeviceInfo=new DEVICE_INFO;
		pDeviceInfo->pUserInfo = (PUSER_INFO)new char[4096];
		memset(pDeviceInfo->pUserInfo,0,4096);
		pDeviceInfo->pUserInfo->dwStructSize = 4096;
		pDeviceInfo->pUserInfo->dwSizeReserved = 4096-FIELD_OFFSET(USER_INFO,dwSizeReserved);
		pDeviceInfo->pUserInfo->State = INITIALIZED;
		pGlobalState=&pDeviceInfo->pUserInfo->State;
		pGlobalInfo=(SGlobalInfo*)&pDeviceInfo->pUserInfo->cbReserved;
		pGlobalInfo->StructSize=sizeof(SGlobalInfo);
	}
	else
	{
		// init VRP values  
		pDeviceInfo=pDI;
		Regs=(VT_REGS*)pDI->pRegs;
		//VT_SetupHardwareBuffer(this,pDI->pPhysAddr,pDI->pLinearAddr,pDI->dwMemoryBytes/sizeof(DWORD));

		FB_PhysAddr=pDI->pPhysAddr;
		FB_LinAddr=(DWORD*)pDI->pLinearAddr;
		FB_Size=pDI->dwMemoryBytes/sizeof(DWORD);

		pGlobalState=&pDeviceInfo->pUserInfo->State;
		pGlobalInfo=(SGlobalInfo*)&pDeviceInfo->pUserInfo->cbReserved;
		AcquireMutex();
		if (pGlobalInfo->StructSize!=sizeof(SGlobalInfo))
		{
			// two posible causes:
			//	1 upgrading drivers /app
			//  2 app version is incompatible with vtaccess version
			dprintf("Reseting global info\n");
			memset((void*)pGlobalInfo,0,sizeof(SGlobalInfo));
			pGlobalInfo->StructSize=sizeof(SGlobalInfo);  //init global info
			assert(GetGlobalState() == INITIALIZED); 
			assert(pGlobalInfo->GlobalOpenCount==0); 

			SetGlobalState (INITIALIZED); 
		}

		InterlockedIncrement((long*)&pGlobalInfo->GlobalOpenCount);
		DriverNumber=pGlobalInfo->GlobalOpenCount;
		dprintf("Open Driver %d\n",DriverNumber);
#ifdef BUILD_DLL

		if (GetGlobalState()  == INITIALIZED )
		{

			// set the secondary ID number from Altera chip
			if (pDeviceInfo->RevisionID==2)
			{
				Reset();
				// read special revision id
				int id2=0;
				CrPoke(CTRL1,VIP_RESET);
				Change32(&Regs->Status,1<<21,0);
				Change32(&Regs->Status,1<<21,1<<21);
				CrPoke(CTRL1,VIP_RESET);
				for (int i=0;i<3;i++)
				{
					if (Regs->Csr & SDI) 
						id2|=1<<i;
					Change32(&Regs->Csr,SCLK,0);	// clear SCLK
					Change32(&Regs->Csr,SCLK,SCLK);	// SET SCLK
				}
				if (Regs->Csr & SDI) 
					id2|=1<<i;
				
				CrPoke(CTRL1,0x10); // restore the register

				switch (id2)
				{
				case 1:
					pGlobalInfo->RevisionID=3;
					break;
				case 3: 
					pGlobalInfo->RevisionID=4;  // in this case disable board using vid out
					VidOutCtlPoke(2);  
					break;
				case 0xf:
					pGlobalInfo->RevisionID=2;
					Reset();
					//VT_Reset(this); // fix for rev 2 boards reasoning unknown
					break;
				default:
					ShowMessage(VT_ERR_INCOMPATIBLE_HARDWARE);
				}
			}
			else
				pGlobalInfo->RevisionID=pDeviceInfo->RevisionID;
	
			//pGlobalInfo->RevisionID=2; // debug fource 
			Reset();
			//VT_Reset(this);
		}
#else
		//set local rev
		if (GetGlobalState()  == INITIALIZED )
			Reset();
		if (pGlobalInfo->RevisionID>2 && pGlobalInfo->RevisionID<16)
			SetRevisionID((UCHAR)pGlobalInfo->RevisionID);
		else
			SetRevisionID((UCHAR)pDeviceInfo->RevisionID);

#endif				
		if (!CheckValidBoard())
		{
			SetGlobalState((BOARD_STATE)0XDEAD);
		}
		if (GetGlobalState() == CODEC_INITIALIZED 
			||  GetGlobalState()== CODEC_BUSY)
		{
			// COPY CURRENT CODEC INFO OVER
			// This line depends on the operation of CCodec::CCodec()
			CopyMemory(&CodecInfo,(void*)&pGlobalInfo->CodecState,sizeof(COMPRESSINFO));
		}
		
		ReleaseMutex();
	}

}


void CDevice::Reset()
{

	Regs->Csr=SOFT_RESET;
	Change32(&Regs->Csr,SOFT_RESET,0);	// make shure board is enabled
	Change32(&Regs->Csr, SCLK | SDO | VRP_SEL, SCLK | SDO | VRP_SEL); // set Vip com bits to default state
	if (ShortBurstsOnly)
		Change32(&Regs->Csr,DISABLE_LARGEBURST,DISABLE_LARGEBURST);  // Needs to be registry setting
	CrPoke(CTRL1,0x10);  // disable 
	CrPoke(CTRL2,FIFO_MODE_RECODE);  // disable 
	Regs->Status=Regs->Status;

}

CDevice::~CDevice()
{
	CAutoMutex AutoMutex;  // I do not believe this is needed
	if (hDriver)
	{
	    /* all done with the kernal mode driver... */

		dprintf("Close driver %d\n",DriverNumber);
		InterlockedDecrement((long*)&pGlobalInfo->GlobalOpenCount);
		if (GetGlobalState()==INITIALIZED && GetRevisionID()>=4 ) 
		{
			VidOutCtlPoke(3);
			dprintf("Board disabled\n");
		}
		free(pDeviceInfo);
		
		CloseHandle (hDriver);
	}
	else
	{
		delete pDeviceInfo->pUserInfo;
		delete pDeviceInfo;
	}
}

void CDevice::ShowMessage(DWORD StrId)
{
	LoadString(hModule,StrId,ErrorMessage,sizeof(ErrorMessage));
	MessageBox(NULL,ErrorMessage,NULL,MB_TASKMODAL | MB_OK);
}

void CDevice::FatalError(ECODE ecode,TCHAR *String)
{
	if (String)
		MessageBox(NULL,String,NULL,MB_TASKMODAL | MB_OK);
	else
	{
		sprintf(ErrorMessage,__FILE__ ": Error %d ",ecode);
		MessageBox(NULL,String,NULL,MB_TASKMODAL | MB_OK);
	}
	RaiseException(ecode,0,0,NULL);
}


ECODE CDevice::SetVipFilterMode(BOOL LoadValues)
{
	if (CaptureInfo.FilterValue==1)
	{
		if (CurrentSource==SVIDEO)
		{
			VipRegs.VipSyncCtrl|=3; // Disable Vertical noise
			VipRegs.VipLumaCtrl|=0x80; // Disable Croma trap (For svideo)
			VipRegs.VipLumaCtrl&=0x40; // Disable Prefilter
			VipRegs.VipChromaCtrl|=3 | 4; // Wide Croma bandwidth | Fast time cons
		}
		else
		{
			VipRegs.VipSyncCtrl|=3; // Disable Vertical noise
			VipRegs.VipLumaCtrl&=~0x80; // Disable Croma trap (For svideo)
			VipRegs.VipLumaCtrl|=0x40; // Enable Prefilter
			VipRegs.VipChromaCtrl|=3 | 4; // Wide Croma bandwidth | Fast time cons
		}
	}
	else
	{
		VipRegs.VipSyncCtrl&=0xfc;
		VipRegs.VipLumaCtrl=DefaultVipValues.VipLumaCtrl;
		VipRegs.VipChromaCtrl=DefaultVipValues.VipChromaCtrl; 
	}

	if (LoadValues)
	{
		WriteVIP(VIP_SYNC_CTRL,(DWORD*)&VipRegs.VipSyncCtrl,1);
		WriteVIP(VIP_LUMA_CTRL,(DWORD*)&VipRegs.VipLumaCtrl,1);
		WriteVIP(VIP_CHROMA_CTRL,(DWORD*)&VipRegs.VipChromaCtrl,1);
	}
	return VT_NO_ERROR;
}

ECODE CDevice::CheckDevice(CDevice& Dev,BOOL CheckMicroCode /*=TRUE*/)
{
	if (&Dev==NULL) return VT_ERR_NULL_DEVID;
	if (Dev.CaptureInfo.StructSize!=sizeof(CAPTUREINFO))
		return VT_ERR_OTHER;
	if (CheckMicroCode && Dev.MicroCode==NULL) return VT_ERR_NO_MODE;
	//RecodeInfo.StructSize=sizeof(RECODEINFO);
	//CodecInfo.StructSize=sizeof(COMPRESSINFO);

	return VT_NO_ERROR;
}

static unsigned __int64 LastDelay=0;
static unsigned int CountsPer1024us=0;


void InitShortDelay()
{
   unsigned __int64 freq;
   if (QueryPerformanceFrequency((LARGE_INTEGER*)&freq))
   {
	   CountsPer1024us=(unsigned int)(freq*1024/1000000);
	   QueryPerformanceCounter((LARGE_INTEGER*)&LastDelay);
   }
}

void ShortDelay(int Delay_us,BOOL FromLast)
{
		
	unsigned __int64 PreviousDelay;
	   if (!FromLast)
		   QueryPerformanceCounter((LARGE_INTEGER*)&PreviousDelay);
	   else
		   PreviousDelay=LastDelay;
	   unsigned int DelayCount=(Delay_us*CountsPer1024us)>>10+1;
 	
	   do
	   {
		   QueryPerformanceCounter((LARGE_INTEGER*)&LastDelay);
	   }
	   while ((unsigned int)(LastDelay-PreviousDelay)< DelayCount);  
}

__inline void StartDelay()
{
	QueryPerformanceCounter((LARGE_INTEGER*)&LastDelay);
}

void WriteCsrDelay(PREGS bd_addr,DWORD value)
{
	ShortDelay(5,TRUE);
	bd_addr->Csr=value;
	StartDelay();
}

ECODE WriteSerialStart(PREGS bd_addr)
{
	int i=0;
	DWORD cpy=bd_addr->Csr & ~(SDO | SCLK);
	WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
	WriteCsrDelay(bd_addr,cpy | SCLK | SDO);// make shure time is long enough
	while(!(bd_addr->Csr & SDI))
	{
		// recovery code
		WriteCsrDelay(bd_addr,cpy | SDO);
		WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
		if (i++>32) return VT_VIP_UNDEFINED;
	} 
	WriteCsrDelay(bd_addr,cpy | SCLK);
	return 0;
}

void WriteSerialStop(PREGS bd_addr)
{
	DWORD cpy=bd_addr->Csr & ~(SDO | SCLK);
	WriteCsrDelay(bd_addr,cpy | SDO);
	WriteCsrDelay(bd_addr,cpy);
	WriteCsrDelay(bd_addr,cpy | SCLK);
	WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
}


ECODE WriteSerial(PREGS bd_addr,BYTE data)
{
    long i;
	BYTE newdata=0;
	DWORD cpy=bd_addr->Csr & ~( SCLK);
	data &=0xff;
	for (i=7;i >=0;i--)
	{
		WriteCsrDelay(bd_addr,cpy);
		if (data & (1<< i)) 
		   cpy|=SDO;	// set data
		else
		   cpy&=~SDO;	// CLEAR DATA
		WriteCsrDelay(bd_addr,cpy);
		WriteCsrDelay(bd_addr,cpy | SCLK);

		if (bd_addr->Csr & SDI)
		{
		    newdata|=1<<i; 
		}

	}
	WriteCsrDelay(bd_addr,cpy);
	cpy|=SDO;	// set data
	WriteCsrDelay(bd_addr,cpy);
	WriteCsrDelay(bd_addr,cpy | SCLK);
 
	if (data!=newdata || (bd_addr->Csr & SDI))
	{
		return VT_ERR_SR_WRITE;

//		printf("%2x %2x",data,newdata);
		if (bd_addr->Csr & SDI)
		{
		    dprintf(" no ack"); 
		}
	//	printf("\n");

	}
	return 0;

}

void ReadSerial(PREGS bd_addr,BYTE *data,BOOL LastRead)
{
    long i;
	DWORD cpy=bd_addr->Csr & ~( SCLK ) ;
	*data=0;
	WriteCsrDelay(bd_addr,cpy);
	cpy|=SDO;
	for (i=7;i >=0;i--)
	{
		WriteCsrDelay(bd_addr,cpy);
		WriteCsrDelay(bd_addr,cpy | SCLK);
		if (bd_addr->Csr & SDI)
		{
		   *data|=1<<i; 
//			printf("%1d",1);
		}
//		else
//			printf("%1d",0);
	}

	// now send an ack
	WriteCsrDelay(bd_addr,cpy);
	if (!LastRead)
		cpy&=~SDO; 	// clear output
	WriteCsrDelay(bd_addr,cpy);// delay not needed
	WriteCsrDelay(bd_addr,cpy | SCLK );
//	WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
//	printf("\n");
}

ECODE SrRead(PREGS bd_addr,BYTE *DestPtr, BYTE Source, DWORD Words,BYTE Slave,int Stride)
{
	DWORD j;
	CAutoMutex Mutex;
	memset(DestPtr,0,Words*Stride);
	ReturnIfError(WriteSerialStart(bd_addr));
	ReturnIfError(WriteSerial(bd_addr,Slave & 0xfe)); // slave address
	ReturnIfError(WriteSerial(bd_addr,Source++)); // subaddress address
	    //WriteSerialStop(bd_addr);
	ReturnIfError(WriteSerialStart(bd_addr));
	ReturnIfError(WriteSerial(bd_addr,Slave | 1)); // slave address
	for (j=Words;j>0;j--)
	{
		ReadSerial(bd_addr,DestPtr,j==1);
		DestPtr+=Stride;
	}
    WriteSerialStop(bd_addr);
	return 0;
}


ECODE CDevice::ReadFlash(DWORD *DestPtr, DWORD Source, DWORD Words)
{
	return SrRead(Regs,( BYTE*)DestPtr, (BYTE)(Source & 0xff), Words,(BYTE)(0xa0 | ((Source & 0x700) >>7 )),1) ;
}

ECODE CDevice::ReadVIP(DWORD *DestPtr, DWORD Source, DWORD Words)
{
	return SrRead(Regs,( BYTE*)DestPtr, (BYTE)(Source & 0xff), Words,0x48,4) ;
}

ECODE SrWrite(PREGS bd_addr,BYTE Dest, const BYTE *SrcPtr, DWORD Words,BYTE Slave,int Stride)
{
	DWORD i;
	CAutoMutex Mutex;
    ReturnIfError(WriteSerialStart(bd_addr));
	ReturnIfError(WriteSerial(bd_addr,Slave & 0xfe)); // slave address
	ReturnIfError(WriteSerial(bd_addr,Dest++)); // subaddress address
	for (i=0;i<Words;i++)
	{
		ReturnIfError(WriteSerial(bd_addr,*SrcPtr));
		SrcPtr+=Stride;
	}
    WriteSerialStop(bd_addr);
	return 0;
}


ECODE CDevice::WriteFlash(DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	int count=0;
	ECODE ec=SrWrite(Regs,(BYTE)(Dest)  ,(const BYTE*)SrcPtr, Words,(BYTE)(0xa0 | ((Dest & 0x700) >>7 )) ,1);
	DWORD value;
	if (Words==32 && !ec)
		while (ReadFlash(&value,0X7FF,1)) // wait for burn up to 30 ms
		{
			if (count++>30) return VT_ERR_SR_WRITE;
				Sleep(1);
		}
	return ec;
}

ECODE CDevice::WriteVIP(DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	return SrWrite(Regs,(BYTE)(Dest)  ,(const BYTE*)SrcPtr, Words,0x48,4 );
}

HANDLE CDevice::Mutex=NULL;

ECODE CDevice::AcquireMutex()
{
	int status=WaitForSingleObject(Mutex,INFINITE);
	return (status == WAIT_OBJECT_0) ?VT_NO_ERROR:VT_ERR_OTHER;
}


ECODE CDevice::ReleaseMutex()
{
	int status=::ReleaseMutex(Mutex);
	return (status == FALSE) ?VT_ERR_OTHER:VT_NO_ERROR;
}
/*CheckKey.cpp
This file contains the code and definitions to check the validity of the
Broadway software key. 

The CheckKey() function produces a 60 bit number when given a 64 bit key.
This 60 bit "plain text" number is a linear encode (i.e. bit munge) of a boards
serial number and rights data. Once the CheckKey() function and bit unscrambling
is performed on the key. The serial number and rights should be checked against the
values stored on the board. If they match - cool, the user has the rights as specified
by the rights flags. Otherwise, the user has no rights.
*/

//the following is the public key info
#define PUBLIC_KEY_E 239
#define PUBLIC_KEY_n 4280159713
typedef unsigned __int64 UINT64;

//#include "KeyFuncs.h"
unsigned long ExpMod(unsigned long base, unsigned long exp, unsigned long mod)
/*
this function computes base**exp modulo(mod)
*/

{
    int i;
    unsigned long mask;

    //find base raised to powers of two (mod n)
    UINT64 ModPow[32];
    ModPow[0] = base % mod;
    for (i=1,mask=1; mask <= exp; i++,mask <<= 1)
        ModPow[i] = (ModPow[i-1] * ModPow[i-1]) % mod;

    //save count of number of bits
    int BitCount = i;

    //compute answer by multiplying the powers of two used in the exponent
    //(mod n of course)
    mask = 1;
    UINT64 result = 1;
    for (i=0; i< BitCount; i++) {
        if (mask & exp)
            result = (result * ModPow[i]) % mod;
        mask <<= 1;
    }

    return (unsigned long)result;
}

#define pat 0x0a83de45  // top bits must be 0 and 28 bits of caps only


UINT64 CheckKey(UINT64 key)
/*
This function decodes the input 64 bit key and returns a 60 bit plain text result
*/
{

    unsigned long inl, inh, outl, outh;
    UINT64 result;

    //decode least sig half of key to get 30 bits of plain text
    inl = (unsigned long) key;
    outl = ExpMod(inl, PUBLIC_KEY_E, PUBLIC_KEY_n);
    outl &= 0x3fffffff;
     
    //decode most sig half of key to get 30 bits of plain text
    inh = (unsigned long) (key >> 32);
    outh = ExpMod(inh, PUBLIC_KEY_E, PUBLIC_KEY_n);
    outh &= 0x3fffffff;

    //combine LSH and MSH into 60 bit result
    result = outh;
    result <<= 30;
    result += outl;

    return result;
}

int CalcChecksum(DWORD value)
{
	int sum=0;
	for (int i=0;i<32;i++,value>>=1)
		if (value & 1) sum++;
	return sum;
}

BOOL CDevice::CheckValidBoard()
{
		EEPROM ep;
		ECODE ec=ReadFlash((DWORD*)&ep ,0, sizeof(ep));
		if (ec) // this board is pre eprom or has no eprom
		{
			if (GetRevisionID()>=4)
				return FALSE;
			else
				return TRUE;
		}
#ifdef BUILD_DLL
		if (GetRevisionID()!=ep.HardwareRev)
		{
			MessageBox(NULL,"Revisions do not match","Error",MB_OK);
			dprintf("Hardware revs do not match\n");
			return FALSE;
		}
#else
		SetRevisionID((UCHAR)ep.HardwareRev);
#endif
		UINT64 value=CheckKey(*(UINT64*)ep.Key);
		/* value contains the sn the features and the rev (includeing atara rev)
		broken combined in the following way:
		((sn*rev) ^ features) | (features << 32);

		*/
			DWORD c2=(DWORD)value & pat | ((DWORD)(value >>32) & ~pat);
			DWORD c1=(DWORD)value & ~pat | ((DWORD)(value >>32) & pat);
		//unscramble value
		DWORD features=c1 & ~CHECKSUM_MASK; 
		DWORD sn=((DWORD)c2 ) /GetRevisionID();
		DWORD csum=CalcChecksum(c2)+CalcChecksum(features);
		// now check
		if (sn==ep.SerialNumber && features==ep.caps && csum==c1>>CHECKSUM_LOC)
		{
			// board is good
			return TRUE;
		}
		else
		{  // KILL BOARD HERE
#ifdef BUILD_DLL
			if (ep.caps!=0 && (sn!=ep.SerialNumber || csum !=c1>>CHECKSUM_LOC)) // serial is valid not caps
			{
				ep.caps=0;
				ep.WriteCount++;
				DWORD Value=0x2;
				WriteFlash(0x7ff,&Value,1);

				WriteFlash(32,ep.Key,32);
				Value=0x0;
				WriteFlash(0x7ff,&Value,1);
			}
			else 
			{
				//restore caps?
				ep.caps=features;
				ep.WriteCount++;
				DWORD Value=0x2;
				WriteFlash(0x7ff,&Value,1);

				WriteFlash(32,ep.Key,32);
				Value=0x0;
				WriteFlash(0x7ff,&Value,1);
			}
#endif
			return FALSE;
		}
}
