#include "stdincs.h"
#include <assert.h>

ECODE CDevice::LoadFileBinSwap(VT_MEMTYPE Type,char *filename,DWORD Addr,DWORD LastAddr,DWORD FileOffset)
{

	char dataFileName[128];
	HANDLE hFile = NULL;
	HANDLE hMapFile = NULL;
	DWORD *pData;
	ECODE ecode=VT_NO_ERROR;
	DWORD readsize=LastAddr-Addr+1;
	DWORD size;

	if (Addr > LastAddr)
	  return VT_ERR_PROGRAMED_RANGE;
	assert(Type==VR_DRAM);
	strcpy(dataFileName,szTablePath);
	strcat(dataFileName,filename);
	strcpy(ErrorMessage,dataFileName);

	/* open first file and memory map it */
    hFile = CreateFile(dataFileName, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_FLAG_RANDOM_ACCESS, NULL);                              
    if (hFile== INVALID_HANDLE_VALUE) {ecode=VT_ERR_FILE_NOT_FOUND; goto error;}

	size=GetFileSize(hFile,NULL)/ sizeof (DWORD);
	if (size<readsize+FileOffset)
	{
		dprintf("File %s Is too short file size %d Read size %d\n",dataFileName,size,LastAddr-Addr+FileOffset+1);
		readsize=size-FileOffset;
	}

    hMapFile = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
    if (hMapFile== INVALID_HANDLE_VALUE) {ecode=VT_ERR_FILE_NOT_FOUND; goto error;}

    pData = (DWORD*)MapViewOfFile(hMapFile, FILE_MAP_READ, 0,	0, 0);    	                
    if (pData== NULL) {ecode=VT_ERR_FILE_NOT_FOUND; goto error;}


	ecode=VrpWriteSwap(Regs,DRAM_ADDR(Addr),pData+FileOffset,readsize);
	*ErrorMessage=0; // null the string
error:
    if (pData != NULL && pData!=INVALID_HANDLE_VALUE) {
        UnmapViewOfFile (pData);
    }        
    if (hMapFile != NULL&& hMapFile!=INVALID_HANDLE_VALUE) {
        CloseHandle (hMapFile);
    }        
    if (hFile != NULL && hFile!=INVALID_HANDLE_VALUE) {
        CloseHandle (hFile);
    }
	if (ecode)
	{
		wsprintf(ErrorMessage,"Could Not open File %s\n",dataFileName);
		FatalError(ecode,ErrorMessage);
	}
	
	return ecode;
}
