#define WIN32_LEAN_AND_MEAN
#include <windows.h>
//#include <vt_regs.h>
#include <bwhelper.h>
#include "..\bldhelper.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
HANDLE hModule=0;
ECODE BW_INTERFACE BroadwaySetHardwareKey(DEVID dwDevice,LPVOID Key)
{
	ReturnIfError(CDevice::CheckDevice(*dwDevice,FALSE));
	return VT_NO_ERROR;
}

ECODE BW_INTERFACE BroadwaySetSerialNumber(DEVID dwDevice,DWORD SerialNumber)
{
	ReturnIfError(CDevice::CheckDevice(*dwDevice,FALSE));
	return VT_NO_ERROR;
}

inline ECODE WritePPR(DEVID Device,DWORD Value)
{
	return Device->WriteFlash(0x7ff,&Value,1);
}

#define HARDWARE_REV	4;
#define FLASH_REV		0;
#define HARDWARE_TYPE_BROADWAY 0
#define HARDWARE_TYPE_BEGINNER 1

void FillRandom(void *ptr,int size)
{
	srand( (unsigned)time( NULL ) );

	for (int i=0;i<size;i++)
		((BYTE*)ptr)[i]=(rand()>>1) & 0xff;
}
#define pat 0x0a83de45  // top bits must be 0 and 28 bits of caps only

typedef unsigned __int64 UINT64;
UINT64 CheckKey(UINT64);
ECODE LoadKey(DEVID Dev,UINT64 key)
{
		EEPROM ep;
		ECODE ec=Dev->ReadFlash((DWORD*)&ep ,0, sizeof(ep));
		if (ec) // this board is pre eprom or has no eprom
		{
			if (Dev->GetRevisionID()>=4)
				return FALSE;
			else
				return TRUE;
		}
		if (Dev->GetRevisionID()!=ep.HardwareRev)
		{
			dprintf("Revisions do not match correcting\n");
			return FALSE;
//			Dev->pGlobalInfo->RevisionID=ep.HardwareRev;
		}
		*(UINT64*)ep.Key=key;
		
		UINT64 value=CheckKey(*(UINT64*)ep.Key);
		/* value contains the sn the features and the rev (includeing atara rev)
		broken combined in the following way:
		((sn*rev) ^ features) | (features << 32);
	ep.caps=type== HARDWARE_TYPE_BROADWAY ? BROADWAY_DEFAULT_CAPS
											| BROADWAY_CANCAPTURE_MPEG 
											| BROADWAY_CANOUTPUT_IMPEG
											:BROADWAY_CANCAPTURE_IMPEG 
											| BROADWAY_CANOUTPUT_IMPEG;

		*/
			DWORD c2=(DWORD)value & pat | ((DWORD)(value >>32) & ~pat);
			DWORD features=(DWORD)value & ~pat | ((DWORD)(value >>32) & pat);
		DWORD sn=((DWORD)c2  /Dev->GetRevisionID();

		DWORD features1=(DWORD)(value >> 32);
		DWORD sn1=(DWORD)value  /Dev->GetRevisionID();
		// now check
		if (sn==ep.SerialNumber)
		{
			// Key is good
			ep.HardwareType=(features ==(BROADWAY_CANCAPTURE_IMPEG | BROADWAY_CANOUTPUT_IMPEG)? 1 :0);

			ep.caps=features;
			ep.WriteCount++;
			DWORD Value=0x2;
			Dev->WriteFlash(0x7ff,&Value,1);

			Dev->WriteFlash(32,ep.Key,32);
			Value=0x0;
			Dev->WriteFlash(0x7ff,&Value,1);
			return TRUE;
		}
		else
		{  // KILL BOARD HERE
			return FALSE;
		}
}



int __cdecl  main(int argc, char *argv[])
{
	BWDEV Dev;
	char string[128]; 
	if (sizeof(EEPROM)!=64)
		printf("Invalid Eprom size %d\n",sizeof(EEPROM));
	BroadwayOpenDevice(&Dev,0);
	if (!Dev) 
	{
		printf("Broadway board not found\n");
		exit(1);
	}
	if (argc > 1)
	{
		if (argc != 3) 
		{
			printf("This Program requires the key as two paramiters \n");
			exit(1);
		}
		UINT64 key=((UINT64)strtoul(argv[1],NULL,25)<<32 ) | ((UINT64)strtoul(argv[2],NULL,26));
		if (!LoadKey(Dev,key))
			printf("Key is not valid board not changed\n");
	}
	if (Dev->CheckValidBoard())
	{
		Dev->SetGlobalState(INITIALIZED);
		BroadwayGetBoardName(Dev,string,128);
		printf("Board is Valid, type is %s\n",string);
		DWORD count;
		Dev->ReadFlash(&count,EEPROM_OFFSET(WriteCount),4);
		printf("Board has been configured %d times\n",count);
	}
	else
		printf("Validation Failed");
	BroadwayCloseDevice(Dev);
	return 0;
}