#include "stdincs.h"

#include "dtdefs.h"
#include "stdio.h"



#include "4000_reg.h"
#include "mcode.h"
#include "playback.h"

//#include <sys/types.h>
//#include "4000_pri.h"

//#include "emd_api.h"
#include "emd_dmm.h"
#include "emd_def.h"

extern int gMasterID;

static int polarity_switch = 1;
static int dmem_clr        = 0;
static int as_reg_value    = DA_DUMMY;


CPlayback::CPlayback(DEVSTRUCT *dwDevice):CMicrocode(dwDevice)
		
{
	m_vertical_offset=0;
	m_WriteLoc=0;
	mOutputMode=1;
	m_NextLoad=0;
	m_NextDma=0;
	m_NumBuffers=30; //Dev->FB_Size/(6*1024); // number of 24K byte buffers
	m_BuffersLoaded=0;
	m_FreeSpace=Dev->FB_Size;
//	m_BufferSize=(Dev->FB_Size/m_NumBuffers) & 0xffffc00; // round to 0x400  
	m_Buffers=new CFrameBuffer[m_NumBuffers];
	BufferPtr(m_NextLoad)=Dev->FB_LinAddr;
	m_BuffersInProcess=0;
	m_TransferInProcess=0;

}

CPlayback::~CPlayback()
{
	//Stop();
	Change32(&Regs->Csr,MSTR_MODE_MASK | STOP_1DONE_IN,0 );

	EnableOutput(FALSE);
	Dev->MicroCode=NULL;
	VT_Reset(Dev);
}

/***********************************************************************
 *
 *
 ***********************************************************************/

ECODE CPlayback::Load()
{
	PREGS Regs=GET_STRUCT_PTR(Dev);
 // PREGS Regs;
  uwide temp36;
  	VT_SetupFifo(Dev,70,8);  // reset fifo

  VT_ResetVRP(Dev); 
  VT_ResetVRP(Dev); 
  
   
  /* reset Regs & clear IMEM - set up for initialization sequence */
    
  reset(Regs);
  imemClear(Regs);
    
  imemWrite(Regs,0x10,0x8c0);
  run_inst(Regs,32);
  imemWrite(Regs,0x10,0);
  reset(Regs);
  smemClear(Regs);
    
  /*  Enable DMA Unit (Normal, Interleaved, Refr Count = 0x100). */
  GBusWrite(GBUS_DMAMODE,VIDTOOL_MEMCONFIG); 
//   GBusWrite(GBUS_DMAMODE,0xc9000000 | DMA_MODE_9_CHP);
    
  /*  Reset Vlc_Start register. */
  GBusWrite(GBUS_VLCSTART,0x0);
    
  /*  Enable CPU module (reset Ghalt, Greset), set PIO as input. */
  WBusWrite(Regs,WBUS_CPUCTL,0xc0000000);
  
  /*  Dummy VLD transfer to disable VLD. */
  WBusWrite(Regs,WBUS_CHMEM5,0x07840002);
    
  /*
   * set a breakpoint
   * run for awhile to initialize the VLD
   * then reset the Regs. 
   */
  GBusWrite(0x24,0x20);
  GBusWrite(0x24,0x0);
    
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
  GBusWrite(GBUS_VLDDATA,0x0);
    

  /*  VLD initialized: start again. */
  reset(Regs);                             

  rmemClear(Regs);

  if(dmem_clr == TRUE) {
    dramClear(Regs);
  }
    
 
  /* initialize the scv register on Scorpio as well! */
  /* turn on:
     Video A/B External Master Enable
     Video B out
   */
    
  /* initialize rmem locations - MUST BE DONE BEFORE INITIALIZING IMEM! */
    
  temp36.loword = 0xc00000;
  temp36.hiword = 0;
  rmemWrite(Regs,22,&temp36);
  CpuWritePC(Regs, 0, 0, 0);
    
  temp36.loword = 0x800000;
  temp36.hiword = 0;
  rmemWrite(Regs,23,&temp36);
  CpuWritePC(Regs, 0, 0, 0);
    
  temp36.loword = 0;
  temp36.hiword = 0;
  rmemWrite(Regs,30,&temp36);
  CpuWritePC(Regs, 0, 0, 0);
    
  /* Initialize initial IMEM image */
  //ReturnIfError(VT_LoadFile(Dev,VR_IMEM,"emd.imb"));
    
  /* Initialize initial DMEM image */
  ReturnIfError(LoadMicrocode("emd.dmb"));
    
  /* Load the tables and do the remainder of the initialization.  If SIF 
     resolution, make sure to initialize the rc and bitrate parameters! */
{

  /* initialize areas in DRAM */
  ReturnIfError(VT_LoadFileBin(Dev,VR_DRAM,"dqtables.bii", D_IDQM_Tbls, 
	       D_IDQM_Tbls + 2*32*31-1, 0));

  ReturnIfError(VT_LoadFileBin(Dev,VR_DRAM, "cos_SIF.tai", 
	       D_COS_TABLE, D_COS_TABLE + COS_TABLE_SIZE - 1, 0));

  /* Loading a default first 352x240 image */

//  ReturnIfError(Dev->LoadFileBinSwap(VR_DRAM, "image.def",
//       D_Vid_frame2, D_Vid_frame2+42240-1, 0x0)); // changed for pached ucode
//	       D_Vid_frame2, D_Vid_frame2+BUF_HDEC_SIZE-1, 0x0)); 
  ClearFrameBuffer();	

  /* Setup Memory locations for audio_start_register */
  dramWrite(Regs , DA_AUDIO_START_REG>>2, as_reg_value); 

 // set the video bus widths
  dramWrite(Regs,D_VIDA_BUS_WIDTH>>2,0X10);
  dramWrite(Regs,D_VIDB_BUS_WIDTH>>2,0);


  // set a vertical offset
#define D_VERT_OFFSET          (0x3a3 << 2) // should not be needed
  dramWrite(Regs,D_VERT_OFFSET>>2,m_vertical_offset);


  /* Initialize ME MemCtl */
  GBusWrite(GBUS_MEMEMCTL,0xc0000040);    

  /* Clear Host semaphore bit */
  GBusWrite(GBUS_SEMA,0x0);               

  /* Disable all INTs. */    
  WBusWrite(Regs,WBUS_INTCTL,0xfffefffe);      
   
  /* Reset Mul_Cntl Reg (clip 8) */
  /* Note: the setting of MULCTL will be overwritten by the ucode */
  /* so the setting here is don't care */
  WBusWrite(Regs,WBUS_MULCTL,0x4);             
    
  /*
   * Enable DMA Unit 
   * (Normal, Interleaved, 8 or 9-bit page, Refr Count = 0x100) 
   */
   GBusWrite(GBUS_DMAMODE,VIDTOOL_MEMCONFIG); 
   //GBusWrite(GBUS_DMAMODE,0xc9000000 | DMA_MODE_9_CHP); 
    
  /* Reset Vlc_Start register. */
  GBusWrite(GBUS_VLCSTART,0x0);

  /* 
   * enable CPU module (reset Ghalt, Greset), set PIO as input, 
   */
  WBusWrite(Regs,WBUS_CPUCTL,0xc0000000);

  /* enable smem, refresh and VLD */
  WBusWrite(Regs,WBUS_INTCTL,0x00010201);
 
}
  
    
  /*  set the Regsid */
  GBusWrite(GBUS_HCTL,0x50001000 + (CHIP_ID << 4));
  
  /* start the last Regs executing, then exit this program. */
  GBusWrite(GBUS_HCTL,0xf0000000);
  
  return VT_NO_ERROR;
}

#define MESSAGE_BASE	0x7F900
#define	DECODER_STATUS_REGISTER	(MESSAGE_BASE + 0X20C) 
#define	DECODER_READY	    0x800
#define	DECODER_PLAY	   0x1000
#define	DECODER_PAUSED	   0x2000
#define	DECODER_RESET	   0x4000
#define	DECODER_ENDSEQ	   0x8000
#define	DECODER_BUF_ERROR 0x10000
#define RESET             0x100
#define PLAY              0x200
#define PAUSE             0x300
#define CONTINUE          0x400
#define OUTPUT_RESOLUTION 0x500

#define PLAY_TOENDSEQ    0
#define PLAY_FOREVER     0xFFFF

#define NO_REPEAT_FRAMES  1

#define NO_SKIP_FRAMES    0
#define SKIP_BP_FRAMES  245
#define SKIP_B_FRAMES   255

#define OUTPUT_EQ_INPUT    0
#define OUTPUT_EQ_2XINPUT  1

#if 0
/***********************************************************************
 *
 * Priority Outputmode
 *
 ***********************************************************************/

int pOutputmode(int output_mode)
{
  int	status;
 
  if (!((output_mode == OUTPUT_EQ_INPUT) ||
	(output_mode == OUTPUT_EQ_2XINPUT)))
   output_mode =  OUTPUT_EQ_2XINPUT;
  status = send_pri_msg(gMasterID, OUTPUT_RESOLUTION, 2, &output_mode);
  return(status);
}



/***********************************************************************
 *
 * Priority Play 
 *
 ***********************************************************************/

int pPlay(int n_frames, int repeat_code, int skip_code)
{
  int	status,arg;
 
  if (repeat_code == 0)
   repeat_code = NO_REPEAT_FRAMES;
  arg = (((skip_code&0xFF)<<24) | 
	 ((repeat_code&0xFF)<<16) | 
	 (n_frames&0xFFFF));
  status = send_pri_msg(gMasterID, PLAY, 2, &arg);
  return(status);
}
#endif

ECODE CPlayback::SendPriorityCommand(const VRP_COMMAND *command)
{
	switch (command->command)
	{
	case RESET:
		dprintf("Reset command\n");
		dramWrite(Regs,D_REPEAT_CNT>>2,0);
		dramWrite(Regs,D_FORCED_REPEATS>>2,0);
		dramWrite(Regs,D_FRAME_NUMBER>>2,0);
		return Pause();
	case PLAY:
		dprintf("Play command\n");
		return Continue();
	default:;
	}
	return CMicrocode::SendPriorityCommand(command);
}
ECODE CPlayback::Start()
{
    CrChange(Regs,CTRL1,0xfe,0x10);
	// dma init ??
//	Regs->Csr=Regs->Csr & ~MSTR_MODE  | MSTR_OUTPUT | MSTR_INPUT; // Master in 
	//Regs->Csr=Regs->Csr & ~MSTR_MODE_MASK | MSTR_OUTPUT; // Mem in
//	CrChange(Regs,CTRL2,FIFO_MODE_MASK,FIFO_MODE_ICAPTURE);
	//CrChange(Regs,CTRL2,FIFO_MODE_MASK,FIFO_MODE_IONLY);
	//ReturnIfError(CMicrocode::Start());
	
	
	//VRP_COMMAND Cmd={OUTPUT_RESOLUTION,2,OUTPUT_EQ_INPUT};
	//ReturnIfError(SendPriorityCommand(&Cmd));
    ClearFrameBuffer();	
	EnableOutput(TRUE);
	Sleep(100);
	VRP_COMMAND Cmd1={PLAY,2,0x00010000};
	ReturnIfError(CMicrocode::SendPriorityCommand(&Cmd1));
	//Sleep(1000);
	Change32(&Regs->Csr,MSTR_MODE_MASK | STOP_1DONE_IN,0);
	Write32(&Regs->Status,DONE_FLAG_1);


	DWORD status;
    ReturnIfError(dramRead(Regs,DECODER_STATUS_REGISTER, &status));
    while ((status & DECODER_READY) == 0)
	{
	  dprintf("Waiting for Decoder Ready(0x%X)\n", status);
	  Sleep(10);
      ReturnIfError(dramRead(Regs,DECODER_STATUS_REGISTER, &status));
	} 
	Dev->State=VTS_RUNNING;
	m_WriteLoc=0;
	m_NextLoad=0;
	m_NextDma=0;
	SendBlackFrame();
	Sleep(10);
	SendBlackFrame();
	Sleep(10);
	//Pause();
	SendBlackFrame();
	Sleep(30);
	CheckDmaLoad();
	return VT_NO_ERROR;
}

#define READ_PTR_ADDR	0x00000215
#define WRITE_PTR_ADDR	0x00000216
#define BLOCK_SIZE 		0x200
#define BLOCK_SIZE_MASK 0x1ff  // must change if block size changes
#define BUFFER_SIZE 	0x4000
#define BUFFER_ADDR 	0x28000


void CPlayback::ClearFrameBuffer()
{
#if 0
	int addr=0x9000;
	while (addr<0x22000)
	{
		dramFill(Regs,addr,0,0x40);
		addr+=0x40;
		dramFill(Regs,addr,0x80808080,0x40);
		addr+=0x40;
	}
#endif
}

void CPlayback::SendBlackFrame(int count)
{

	char dataFileName[128];
	HANDLE hFile = NULL;
	void *pData;
	ECODE ecode=VT_NO_ERROR;
	DWORD size,buffersize=0;
	int i=0;

	strcpy(dataFileName,Dev->szTablePath);
	strcat(dataFileName,"image.def");
	strcpy(Dev->ErrorMessage,dataFileName);

	/* open first file and memory map it */
    hFile = CreateFile(dataFileName, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);                              
    if (hFile== INVALID_HANDLE_VALUE) {ecode=VT_ERR_FILE_NOT_FOUND; goto error;}

	size=GetFileSize(hFile,NULL)/ sizeof (DWORD);
	while (buffersize<size)
	{
		buffersize=size;
		GetNextBuffer( VT_WRITEBUFFER, &pData, &buffersize);
		Sleep(30);
		CheckDmaLoad();
	}
	if (buffersize<size) return;
	ReadFile(hFile,pData,size*sizeof(DWORD),&buffersize,NULL);
	dprintf("Send Black Frame:");
	while (i<count) 
	{
		WriteData((DWORD *)pData,size,&buffersize);
		if (buffersize) i++;
	}
	error:
    if (hFile != NULL && hFile!=INVALID_HANDLE_VALUE) {
        CloseHandle (hFile);
    }
	if (ecode)
	{
		wsprintf(Dev->ErrorMessage,"Could Not open File %s\n",dataFileName);
		Dev->FatalError(ecode,Dev->ErrorMessage);
	}
	
}

// enable playback output mode
ECODE CPlayback::EnableOutput(BOOL enable)
{
	PREGS Regs=GET_STRUCT_PTR(Dev);
    DWORD values[2];
	if (enable)
	{
		// enable output chip
		VidOutCtlPoke(Regs,0);
		VidOutCtlPoke(Regs,2);
		VidOutCtlPoke(Regs,0x22);
		DWORD fv=0x23;  // default final register value
		if (Dev->CurrentSource==SVIDEO)
			fv|=8;
		if (Dev->CurrentVideoMode==PAL)
			fv|=0x40;
		VidOutCtlPoke(Regs,fv);

		// lock input chip clock
		VT_Read(Dev,SR_REGS,values,8,1);
		values[0]|=4;
		//	values[0]&=~8;
		VT_Write(Dev,SR_REGS,8,values,1);

		// set data transfer mode regs
		VT_Read(Dev,CR_REGS,values,0,2);
		values[0]=0x20;
		values[1]=FIFO_MODE_RECODE|FIFO_RESET ; 
		VT_Write(Dev,CR_REGS,1,&values[1],1);
		VT_Read(Dev,CR_REGS,values,0,2);
	}
	else
	{
		// disable output
		VidOutCtlPoke(Regs,0);


		VT_Write(Dev,SR_REGS,8,&Dev->VipRegs.VipSyncCtrl,1);
	    VT_Read(Dev,CR_REGS,values,0,2);
 		values[0]=0x20;
		values[1]=FIFO_MODE_RECODE ; // was 12
		VT_Write(Dev,CR_REGS,1,&values[1],1);
		VT_Read(Dev,CR_REGS,values,0,2);
//	  status = pOutputmode(1);
	}
	return VT_NO_ERROR;
}

inline DWORD CPlayback::CalcXferSize(DWORD Words)
{
	return (Words<0x900? 0x1000 :((Words-1)&~(BLOCK_SIZE-1))+BLOCK_SIZE);
}

BOOL  CPlayback::NextBufferReady(DWORD SizeNeeded) 
	{
//		if (m_NextDma==m_NextLoad)
//			return TRUE;
		if (NextBuffer(m_NextLoad)==m_NextDma)
			return FALSE;
//		if (m_BuffersLoaded>28) 
//			return FALSE;
		// NOW CHECK FREE SPACE
#if 0
		if (BufferPtr(m_NextLoad)==Dev->FB_LinAddr)
			return (BufferPtr(m_NextDma) > Dev->FB_LinAddr+ MIN_BUFFER_SIZE && BufferPtr(m_NextDma) < Dev->FB_LinAddr+Dev->FB_Size-MIN_BUFFER_SIZE);
		else
			return (BufferPtr(m_NextDma) < BufferPtr(m_NextLoad)) || (BufferPtr(m_NextDma) > BufferPtr(m_NextLoad)+ MIN_BUFFER_SIZE );
#else
//		if (BufferPtr(m_NextLoad)==Dev->FB_LinAddr)
		if (BufferPtr(m_NextLoad)+ SizeNeeded>=Dev->FB_LinAddr+Dev->FB_Size)
		{
			// Place a dummy buffer on the list
			DWORD size=Dev->FB_Size-(BufferPtr(m_NextLoad)-Dev->FB_LinAddr);
			BufferValid(m_NextLoad)=size;
			SkipBuffer(m_NextLoad)=TRUE;
			m_FreeSpace-=size;
			//dprintf("Loaded buffer %d size %d\n", m_NextLoad,xferSize);
			m_NextLoad=NextBuffer(m_NextLoad);
			BufferPtr(m_NextLoad)=Dev->FB_LinAddr;
			if (NextBuffer(m_NextLoad)==m_NextDma)
				return FALSE;
		}
//		if (BufferPtr(m_NextLoad)+ SizeNeeded>=Dev->FB_LinAddr+Dev->FB_Size)
//			dprintf("Bogus situation \n");
	    return (m_FreeSpace>(int) SizeNeeded);
#endif
	}

ECODE CPlayback::GetNextBuffer( int Type, void **BuffPtr, DWORD *SizeWords)
{
	// currently ignoring type
	CAutoMutex Mutex;
#if 0
	if (*SizeWords==0||*SizeWords>MIN_BUFFER_SIZE) 
		*SizeWords=MIN_BUFFER_SIZE;
	else
		*SizeWords=CalcXferSize(*SizeWords);
#else
	*SizeWords=MIN_BUFFER_SIZE;
#endif	
	if(!NextBufferReady(*SizeWords))
	{
 		*SizeWords=0;
		*BuffPtr=NULL;
		return VT_ERR_NO_FREE_BUFFERS;
	}
	else
	{
		*BuffPtr=BufferPtr(m_NextLoad);
		//*SizeWords=BufferValid(m_NextLoad);
//		if (BufferPtr(m_NextLoad)+ *SizeWords>=Dev->FB_LinAddr+Dev->FB_Size)
//			dprintf("Bogus situation 2 \n");
		return VT_NO_ERROR;
	}
}


ECODE CPlayback::CheckDmaLoad()
{

// Muliti buffer operation no longer supported go back to May in Source safe
// for multi buffer operation this version will combine buffers into 
// a single transfer

	/* this routine will attempt to keep data flowing to the board
	because of a bug in the master1 circute it will not function while
	master2 is enabled.  (if master 2 is enabled the new address will
	not load into master1) 
	
Flow:
1:  if not ever started (master not enabled)  or  done and stopon done
	Start buffer1, set stop on done set next buffer to 2
	
	else 
2: if stop on done (SOD) and not done Load buffer 2 clear SOD recover
	if stop during processing
	else
3: if no SOD Two buffers in progress if not done exit
	else 
4:   one buffer done another is in process Set SOD clear Done Proced 
	with step 2:*/

	/* three buffer option: in state 3 copy buffers to ondeck buffer*/
// process state 3
	if (Dev->State<VTS_RUNNING)
		return VT_NO_ERROR;

	if (!(Regs->Status & DONE_FLAG_1) && (Regs->Csr & MSTR_INPUT) )
	{
		// Not ready for more data
		return VT_NO_ERROR;
	}

	m_BuffersLoaded-=m_BuffersInProcess;
	m_FreeSpace+=m_TransferInProcess;
	m_BuffersInProcess=0;
	m_TransferInProcess=0;
	if (m_NextDma==m_NextLoad) 
	{
		// no new buffers
		//dprintf("No buffers to Load\n");
		return VT_NO_ERROR;
	}


// Deal with bugus buffer at end of Main buffer
	if (SkipBuffer(m_NextDma))
	{
		SkipBuffer(m_NextDma)=FALSE;
		m_FreeSpace+=BufferValid(m_NextDma);
		m_NextDma=NextBuffer(m_NextDma);
			if (m_NextDma==m_NextLoad)
				return VT_NO_ERROR;
	}
// Combine buffers if possible
	m_BuffersInProcess=1;
	m_TransferInProcess=BufferValid(m_NextDma);
	int skipto=NextBuffer(m_NextDma);

	while (skipto!=m_NextLoad && BufferPhys(m_NextDma)<BufferPhys(skipto)&& !SkipBuffer(skipto) && m_BuffersInProcess<=4)
	{
		m_TransferInProcess+=BufferValid(skipto);
		skipto=NextBuffer(skipto);
		m_BuffersInProcess++;
	}

				// Incase done while clearing
	//Dev->CheckMasterErr();
	Change32(&Regs->Csr,MSTR_MODE_MASK ,0);
	Change32(&Regs->Status,0xffffffff,DONE_FLAG_1); // prevent burst write
	//Dev->CheckMasterErr();
	VT_LoadDma(Dev,MASTER1,m_TransferInProcess,BufferPhys(m_NextDma));
	Change32(&Regs->Csr,MSTR_MODE_MASK | STOP_1DONE_IN,MSTR_INPUT |STOP_1DONE_IN);

		//dprintf("Sent buffer %d\n", m_NextDma);
	Dev->CheckMasterErr();
	// init input buffer
	//dprintf("Sent buffer %d size %d\n" ,m_NextDma,BufferValid(m_NextDma));
	m_NextDma=skipto; //NextBuffer(m_NextDma);
	return VT_NO_ERROR;
}

ECODE CPlayback::WriteData(const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten)
{

	if (WordsWritten) *WordsWritten=0;
	CAutoMutex Mutex;
// first deal with input data
    //VT_AquireMutex();
	ReturnIfError(CheckDmaLoad());
	DWORD xferSize=CalcXferSize(Words);

	if (Words>0 && NextBufferReady(xferSize)) 
	{
		DWORD PadSize;
		if ((int)Words>MIN_BUFFER_SIZE )
		{
			// punt here
			//VT_ReleaseMutex();
			return 0xBAD0;
		}
		// load the buffer to the list
		if (SrcPtr!=BufferPtr(m_NextLoad))
			CopyMemory(BufferPtr(m_NextLoad),SrcPtr,Words*sizeof(DWORD));	
		PadSize=xferSize-Words;
		ZeroMemory(BufferPtr(m_NextLoad)+Words,PadSize*sizeof(DWORD));
		BufferValid(m_NextLoad)=xferSize;
		SkipBuffer(m_NextLoad)=FALSE;
		
		//dprintf("Loaded buffer %d size %d\n", m_NextLoad,xferSize);
		DWORD* nextptr=BufferPtr(m_NextLoad)+xferSize;
		m_NextLoad=NextBuffer(m_NextLoad);

		BufferPtr(m_NextLoad)=nextptr;

		m_BuffersLoaded++;
		m_FreeSpace-=xferSize;
		*WordsWritten=Words;
		//dprintf("Wrote %d words\n",xferSize);
		return CheckDmaLoad();
	}
    //VT_ReleaseMutex();
	return VT_NO_ERROR;
}

ECODE CPlayback::Stop()
{
	//VRP_COMMAND Cmd1={RESET,1,0x0};
	//CAutoMutex Mutex;
	if (Dev->State<VTS_RUNNING)
		return VT_NO_ERROR;
	//for (i=0;i<30;i++)
		SendBlackFrame(30);

//		VRP_COMMAND Cmd1={RESET,1,0x0};
//	ReturnIfError(CMicrocode::SendPriorityCommand(&Cmd1));
	Dev->State=VTS_READY;
#if 0

	for (int i=0 ;m_NextDma!=m_NextLoad && i<20;i++ )
	{
		VT_ReleaseMutex();
		Sleep(20);
		VT_AquireMutex();
		CheckDmaLoad();
	}
	SendBlackFrame();

	Change32(&Regs->Csr,MSTR_MODE_MASK | STOP_1DONE_IN,MSTR_INPUT );
	Write32(&Regs->Status,DONE_FLAG_1);
	Dev->State=VTS_READY;
	VT_ReleaseMutex();

	for (i=0 ;m_NextDma!=m_NextLoad && i<20;i++ )
	{
		Sleep(0);
		CheckDmaLoad();
	}
	Change32(&Regs->Csr,MSTR_MODE_MASK | STOP_1DONE_IN,MSTR_INPUT );
	Write32(&Regs->Status,DONE_FLAG_1);
	Pause();
	SendBlackFrame();
	SendBlackFrame();

	for (i=0 ;m_NextDma!=m_NextLoad && i<20;i++ )
	{
		Sleep(20);
		CheckDmaLoad();
	}
#endif
	//ReturnIfError(SendPriorityCommand(&Cmd1));
	//ClearFrameBuffer();
	return VT_NO_ERROR;
}
ECODE CPlayback::Pause()
{
	VRP_COMMAND Cmd1={PAUSE,1,0x0};
	ReturnIfError(SendPriorityCommand(&Cmd1));
	Dev->State=VTS_PAUSED;
	return VT_NO_ERROR;
}

ECODE CPlayback::Continue()
{
	VRP_COMMAND Cmd1={CONTINUE,1,0x0};
	ReturnIfError(SendPriorityCommand(&Cmd1));
	return VT_NO_ERROR;
}

ECODE CPlayback::GetStatus(DWORD param,long *value)
{ 
	switch (param)
	{

	case BUFFERS_PENDING:
		*value=m_BuffersLoaded;
		break;
	default: return CMicrocode::GetStatus(param,value);
	}
	return VT_NO_ERROR;
}

ECODE CPlayback::SetParam(DWORD param,long  value)
{
	switch (param)
	{
	case PLAYBACKDEST:
		{
		DWORD fv=0x23;  // default final register value
		if (value==SVIDEO)
		{
			fv|=8;
		}
		if (Dev->CurrentVideoMode==PAL)
			fv|=0x40;
		VidOutCtlPoke(Regs,fv);
		}
		break;

	default: return CMicrocode::SetParam(param,value);
	}
	return VT_NO_ERROR;
}
ECODE CPlayback::ReadData(void **DestPtr, DWORD *WordsRead)
{
	return VT_NO_ERROR;
}
