/* Copyright C-Cube Microsystems 1995	*/
/*		@(#)4500_ld.c	1.20 4/11/95 	*/
/**************************************************************************
 *
 * 4500_ld.c
 *
 * (C) Copyright 1993 - C-Cube Microsystems - All rights reserved
 *
 * V. Wilburn	20-Oct-94	Added PES support and config.sys support.
 * V. Wilburn	24-Jan-95	Added support for -NODEC, -WIDE_VIDA, and
 *				-WIDE_VIDB options.
 * V. Wilburn   08-Mar-95	Added support for -NOSCD and
 *				-NO_START_GOP_RESET options.
 * V. Wilburn	11-Apr-95	Bitrate now a long instead of a double.
 **************************************************************************/
#include "stdincs.h"
#include <stdlib.h>
#include <stdio.h>
#define WIN32_LEAN_AND_MEAN
#include "windows.h"

//#include "dtdefs.h"

#include "vt_acc.h"
#include "vt_regs.h"
#include "vt_vrp.h"
#include "4000_reg.h"
#include "mcode.h"
//#include "vt_helper.h"
#include "recode.h"

//#include "hostlib\\sc_cmds.h"
#define SIF
#define SINGLE_CHIP
#define RECODER
#define VIDA_BUS_16_WIDE
#define VIDB_BUS_16_WIDE

#include "rc_dmm.h"
#include "rc_api.h"
#include "rc_def.h"
#include "rc_vid.h"






//#include "4500_def.h"
// THIS LINE IS THE ONLY INFO WE NEED FROM 4500_def.h
#define	VIDA_FILT_MODE		0x1	/* SIF decimation */


#define VBV_SIZE		327680	     /* total VBV size */
#define INIT_VBV_FULLVAL	327680	     /* initial VBV fullness */


static int polarity_switch = 0;
#define  dmem_clr         FALSE
static int pts_reg_value   = PTS_DISABLED;
static int pts_offset_value = 0;
static int pts_format_value = 0;
static int pes_data_value  = PES_DISABLED;
static int as_reg_value    = DA_DUMMY;
#define  cl950_value      FALSE
static int interrupt_enable_value = 0;
static int freq_filt_enable = 0;
static int decimation_flag_value;
#define  wide_vida_flag_value   (VIDA_BUS_WIDTH / 0x10)
#define  wide_vidb_flag_value  (VIDB_BUS_WIDTH / 0x10)
static int scd_flag_value = 1;
static int start_gop_reset_flag_value = 1;
static int cmd_discard_thres_val = 0x01000000;	/* one hour command discard  */
static int bit_dist_clip_ctl_val = 8;		/* 1/4 bit dist clipping     */
#ifdef RECODER
#define  no_stuffing_value  FALSE    /* enable bit stuffing is default */
#endif 


/***********************************************************************
 *
 *
 ***********************************************************************/
static ECODE init_SIF(CDevice *Dev, long bitrate);
#if 1
//static void mktablep(int y, int x);
//static void mktableb(int y, int x);
//static void clipme1(ulong addr);

int CMicrocode::ZigZag[8][8][2] ={
    {{0,0}, {0,1}, {1,0}, {2,0}, {1,1}, {0,2}, {0,3}, {1,2}},
    {{2,1}, {3,0}, {4,0}, {3,1}, {2,2}, {1,3}, {0,4}, {0,5}},
    {{1,4}, {2,3}, {3,2}, {4,1}, {5,0}, {6,0}, {5,1}, {4,2}},
    {{3,3}, {2,4}, {1,5}, {0,6}, {0,7}, {1,6}, {2,5}, {3,4}},
    {{4,3}, {5,2}, {6,1}, {7,0}, {7,1}, {6,2}, {5,3}, {4,4}},
    {{3,5}, {2,6}, {1,7}, {2,7}, {3,6}, {4,5}, {5,4}, {6,3}},
    {{7,2}, {7,3}, {6,4}, {5,5}, {4,6}, {3,7}, {4,7}, {5,6}},
    {{6,5}, {7,4}, {7,5}, {6,6}, {5,7},	{6,7}, {7,6}, {7,7}}};

int CMicrocode::IntraQuant[8][8] = {{ 8,16,19,22,26,27,29,34},
			    {16,16,22,24,27,29,34,37},
			    {19,22,26,27,29,34,34,38},
			    {22,22,26,27,29,34,37,40},
			    {22,26,27,29,32,35,40,48},
			    {26,27,29,32,35,40,48,58},
			    {26,27,29,34,38,46,56,69},
			    {27,29,35,38,46,56,69,83}};

 int 	CMicrocode::NonIntraQuant[8][8] = {{16,17,18,19,20,21,22,23},
			       {17,18,19,20,21,22,23,24},
			       {18,19,20,21,22,23,24,25},
			       {19,20,21,22,23,24,26,27},
			       {20,21,22,23,25,26,27,28},     
			       {21,16,23,24,26,27,28,30},      /* (1,5) fixup */
			       {22,23,24,26,27,28,30,31},
			       {23,24,25,27,28,30,31,33}};

int	CMicrocode::DefaultIntraQuant[8][8] = {{ 8,16,19,22,26,27,29,34},
				   {16,16,22,24,27,29,34,37},
				   {19,22,26,27,29,34,34,38},
				   {22,22,26,27,29,34,37,40},
				   {22,26,27,29,32,35,40,48},
				   {26,27,29,32,35,40,48,58},
				   {26,27,29,34,38,46,56,69},
				   {27,29,35,38,46,56,69,83}};

 int 	CMicrocode::DefaultNonIntraQuant[8][8] = {{16,17,18,19,20,21,22,23},
				      {17,18,19,20,21,22,23,24},
				      {18,19,20,21,22,23,24,25},
				      {19,20,21,22,23,24,26,27},
				      {20,21,22,23,25,26,27,28}, 
				      {21,16,23,24,26,27,28,30},  /* fixup    */
				      {22,23,24,26,27,28,30,31},
				      {23,24,25,27,28,30,31,33}};


#endif
//void loadClippingTables(int horizontal, int vertical);
CRecode::CRecode(DEVSTRUCT *dwDevice):CMicrocode(dwDevice) 
{
	m_DA_CLIPX=DA_CLIPX;
	m_DA_CLIPY=DA_CLIPY;
	m_DA_PTB=DA_PTB;
	m_DA_BTB=DA_BTB;
	m_ME1_CLIP_TABLE_P=ME1_CLIP_TABLE_P;
	m_ME1_CLIP_TABLE_B=ME1_CLIP_TABLE_B;
	m_Buffer1Size=0xD000; // size in DWORDS
	m_Buffer2Phys=Dev->FB_PhysAddr+m_Buffer1Size*sizeof(DWORD);
	m_Buffer2Size=Dev->FB_Size-m_Buffer1Size;
	m_Buffer2Lin=Dev->FB_LinAddr+m_Buffer1Size;
	m_ExtraSize=0;
	m_WriteBlockSize=0x2000;
	// Clear master register
	Change32(&Dev->Regs->Csr,MSTR_MODE_MASK ,0);

}

ECODE CRecode::Load()
{
//  long bitrate = 1150000;
  PREGS Regs=GET_STRUCT_PTR(Dev);

//  int use_Regss[2], init_nums[2];
//  int numRegss;
  uwide temp36;
   
  // check bitrate for begginer
	if (!(Dev->GetBoardCaps() & BROADWAY_CANDO_VCD))
	{
		int bitrate=Dev->RecodeInfo.DataRate;
		if (bitrate > 1100000 && bitrate <1160000)
		{
			Dev->ShowMessage(VT_ERR_HARDWARE_NOT_CAPABLE);
			return VT_ERR_HARDWARE_NOT_CAPABLE;
		}
	}
		VT_SetupFifo(Dev,70,8);  // reset fifo

  if (VIDA_FILT_MODE == 0x1)
      decimation_flag_value = TRUE;
  else
      decimation_flag_value = FALSE;


  
	VT_ResetVRP(Dev); 
	VT_ResetVRP(Dev); 
  
  
    
    
    /* reset Regs & clear IMEM - set up for initialization sequence */
    
    reset(Regs);
    imemClear(Regs);
    
    imemWrite(Regs,0x10,0x8c0);
    run_inst(Regs,32);
    imemWrite(Regs,0x10,0);
    reset(Regs);
    smemClear(Regs);
    
    /*  Enable DMA Unit (Normal, Interleaved, Refr Count = 0x100). */
    
//    GBusWrite(GBUS_DMAMODE,0xc9000000 | DMA_MODE_9_CHP);
    GBusWrite(GBUS_DMAMODE,VIDTOOL_MEMCONFIG); 
    
    /*  Reset Vlc_Start register. */
    GBusWrite(GBUS_VLCSTART,0x0);
    
    if(cl950_value)
    {
	/* turn on VLC unit (Px64, Intra, empty PACK & ZZ) */
	GBusWrite(GBUS_VLCCTL,0x0008010D);
	GBusWrite(GBUS_VLCCTL,0xc008010D);
    }
    else
    {
	/* turn on VLC unit (MPEG, Intra, empty PACK & ZZ) */
	GBusWrite(GBUS_VLCCTL,0x00080105);
	GBusWrite(GBUS_VLCCTL,0xc0080105);
    }

    /*  Enable CPU module (reset Ghalt, Greset), set PIO as input. */
    WBusWrite(Regs,WBUS_CPUCTL,0xc0000000);
    
    /*  Dummy VLD transfer to disable VLD. */
    WBusWrite(Regs,WBUS_CHMEM5,0x07840002);
    
    /*
     * set a breakpoint
     * run for awhile to initialize the VLD
     * then reset the Regs. 
     */
    GBusWrite(0x24,0x20);
    GBusWrite(0x24,0x0);
    
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);

    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    GBusWrite(GBUS_VLDDATA,0x0);
    

    /*  VLD initialized: start again. */
    reset(Regs);                             

    rmemClear(Regs);

    if(dmem_clr == TRUE) {
      dramClear(Regs);
    }
    
 
    /* if this is the last Regs to be initialized, initialize the
       scv register on Scorpio as well! */
		
    
    /* initialize rmem locations - MUST BE DONE BEFORE INITIALIZING IMEM! */
    
    temp36.loword = 0xc00000;
    temp36.hiword = 0;
    rmemWrite(Regs,22,&temp36);
    CpuWritePC(Regs, 0, 0, 0);
    
    temp36.loword = 0x800000;
    temp36.hiword = 0;
    rmemWrite(Regs,23,&temp36);
    CpuWritePC(Regs, 0, 0, 0);
    
    temp36.loword = 0;
    temp36.hiword = 0;
    rmemWrite(Regs,30,&temp36);
    CpuWritePC(Regs, 0, 0, 0);
   
    /* for E2 initialize this register to run CL4000 emulation mode */
    GBusWrite( GBUS_DMAREF, 0);

    /* Initialize initial IMEM image */
    
    /* printf("loading %s in imem # %d\n",imem_file,Regs); */
    //VT_LoadFile(Dev,VR_IMEM,"emr.imb");
    
    /* Initialize initial DMEM image */
    
    /* printf("loading %s in dram # %d\n",dmem_file,Regs); */
    //VT_LoadFile(Dev,VR_DRAM,"emr.dmb");
    ReturnIfError(LoadMicrocode("emr.dmb"));
   
    /* Load the tables and do the remainder of the initialization.  If SIF 
       resolution, make sure to initialize the rc and bitrate parameters! */
    
    init_SIF();   
    if (polarity_switch) 
      imemWrite(Regs, 0xA9, 0xFC1F0321);

    
    /*  set the Regsid */
    
    //GBusWrite(GBUS_HCTL,0x50001000 + (Regs_scorp << 4));
    
    /* start the Regs executing if it is not the last one in the array to be
       loaded. */
    
    

  /* start the last Regs executing, then exit this program. */
	// bug fix test
	dramWrite(Dev->Regs,0x6f7f0,0xa00001f);

	

  GBusWrite(GBUS_HCTL,0xf0000000);
	   Sleep(30);
		int status;

    /*
     *-------------------------------------------------------------------------
     * Send non-flat non-intra matrix through the API to be inserted into the
     * bitstream.  This should not be done if the frequency-domain-filtering
     * matrices were sent.
     *-------------------------------------------------------------------------
     */
     if (!freq_filt_enable)
	 {
//		 extern int DefaultNonIntraQuant[8][8];
//		 extern int ZigZag[8][8][2];
		 ulong data[65];
		 int data_index = 0;
		 int i,j;

		/*
		 *---------------------------------------------------------------------
		 * Set up quant matrix in zig-zag order.
		 *---------------------------------------------------------------------
		 */
		 data[data_index++] = 2;
		 for (i = 0; i <= 7; i++)
			 {
			 for (j = 0; j <= 7; j++)
			 {
			 data[data_index++] =
				 DefaultNonIntraQuant[ZigZag[i][j][0]][ZigZag[i][j][1]];
			 }
			 }

		/*
		 *---------------------------------------------------------------------
		 * Send zig-zag ordered matrix through api.
		 *---------------------------------------------------------------------
		 */
		 ReturnIfError(LoadParams(TC_NOW, 7, 65, data))
	 }

	ulong data[4];
    
	// set the frame type  (could we do any size here??????
	status = SetDefaultValues(TC_NOW, Dev->RecodeInfo.FrameType);

	// seting frame type requires reseting the data rate
	data[0] = 1;
	data[1] = Dev->RecodeInfo.DataRate / 400;
	ReturnIfError(LoadParams(TC_NOW, 3, 2, data));

      
  /*---------------------------------------------------------
   *  Set the encoder ReferenceTimeCodeRate
   *---------------------------------------------------------*/
	DWORD Outputcode;
	DWORD rate=Dev->RecodeInfo.FrameRate;
	if (rate<2400)
		Outputcode=0;
	else if (rate<2450)
		Outputcode=1;
	else if (rate<2900) 
		Outputcode=2;
	else if (rate<3000)
		Outputcode=3;
	else Outputcode=4;


	// set input rate
	data[0] = 1;
	data[1] = (Outputcode==0 ? 0 : Outputcode-1);
	LoadParams(TC_NOW, 2, 2, data); 

	
	// set output picture code rate and timecode rate 
	data[0] = 3; data[1] = Outputcode;
	data[2] = 4; data[3] = Outputcode;
	LoadParams(TC_NOW, 4, 4, data); 

	return VT_NO_ERROR;
  

}
//#define CLIP_TABLES_FROM_FILE
//#define QUANT_TABLES_FORM_FILE
/***********************************************************************
 *
 * Initialize data arrays in DRAM
 *
 ***********************************************************************/
ECODE CRecode::init_SIF()
{
  PREGS Regs=GET_STRUCT_PTR(Dev);
    ulong bps_scaled;
    int  i;

#ifdef RECODER /*------------------------------------------------------*/  
    /* load default DQ tables */
    VT_LoadFileBin(Dev,VR_DRAM,"dqtables.bii", D_IQM_Tbls>>2, 
		 (D_IQM_Tbls>>2) + 2*32*31-1, 0);

#if 0
    /* load the bit-stream */
    Dev->LoadFileBinSwap(VR_DRAM,"/SingleChip/ReCoder/DEMO/bs.bin", 
                 D_BITS_BUF>>2, (D_BITS_BUF>>2) + INPUT_BS_SIZE-1, 0);

    /* load the image */
    Dev->LoadFileBinSwap(VR_DRAM,"/SingleChip/ReCoder/DEMO/term.image", 
                 BUF_HDEC_EVEN_1, (BUF_HDEC_EVEN_1) + 0xA500-1, 0);
#endif 

#endif /* RECODER -----------------------------------------------------*/
#ifdef CLIP_TABLES_FROM_FILE

    VT_LoadFileBin(Dev,VR_DRAM,"BtabSIF.dti",  DA_BTB,
		 DA_BTB + DA_BTB_SIZE - 1, 0);
    VT_LoadFileBin(Dev,VR_DRAM,"PtabSIF.dti",  DA_PTB,
		 DA_PTB + DA_PTB_SIZE - 1, 0);
    VT_LoadFileBin(Dev,VR_DRAM,"clpxSIF.dti",  DA_CLIPX,
		 DA_CLIPX + DA_CLIPX_SIZE - 1, 0);
//    VT_LoadFileBin(Dev,VR_DRAM,"clpySIF.dti",  DA_CLIPY,
//		 DA_CLIPY + DA_CLIPY_SIZE - 1, 0);
	VT_LoadFileBin(Dev,VR_DRAM,"clpySIF.dti",  DA_CLIPY, // this file is 1024 bytes
		 DA_CLIPY + 0X100 - 1, 0);
    VT_LoadFileBin(Dev,VR_DRAM,"clpBSIF.bii", ME1_CLIP_TABLE_B,
		 ME1_CLIP_TABLE_B + ME1_CLIP_TABLE_SIZE - 1, 0);
    VT_LoadFileBin(Dev,VR_DRAM,"clpPSIF.bii", ME1_CLIP_TABLE_P,
		 ME1_CLIP_TABLE_P + ME1_CLIP_TABLE_SIZE - 1, 0);
#else
	loadClippingTables(22,15);
#endif

    if (freq_filt_enable)
        {
	//	printf("loading frequency domain filtering tables \n");
		VT_LoadFileBin(Dev,VR_DRAM,"qf_SIF.ini", QUANT_TABLES_INTRA,
				 QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
		VT_LoadFileBin(Dev,VR_DRAM,"qf_SIF.noi", QUANT_TABLES_NONINTRA,
				 QUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
		VT_LoadFileBin(Dev,VR_DRAM,"dq_SIF.ini",  DQUANT_TABLES_INTRA,
			DQUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);

		VT_LoadFileBin(Dev,VR_DRAM,"dq_SIF.noi",  DQUANT_TABLES_NONINTRA,
		     DQUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
       }
    else
        {
#ifdef QUANT_TABLES_FORM_FILE
		VT_LoadFileBin(Dev,VR_DRAM,"q_SIF.ini", QUANT_TABLES_INTRA,
				 QUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
		VT_LoadFileBin(Dev,VR_DRAM,"q_SIFnf.noi", ALT_QUANT_TABLES_NONINTRA,
				 ALT_QUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
		VT_LoadFileBin(Dev,VR_DRAM,"dq_SIF.ini",  DQUANT_TABLES_INTRA,
			DQUANT_TABLES_INTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);
        VT_LoadFileBin(Dev,VR_DRAM,"dq_SIFnf.noi", ALT_DQUANT_TABLES_NONINTRA,
		     ALT_DQUANT_TABLES_NONINTRA + TOTAL_QUANT_TABLE_SIZE - 1, 0);

#else	// Calculate Quant tables
	/*---------------------------------------------------------------------
	* Generate default quant tables and send to chip.  Non-intra tables
	* are not the MPEG standard, and so are sent to the ping-ponged
	* buffer.  The encoder is flagged via a command sent through the API
	* in main().
	*---------------------------------------------------------------------
	*/
		qmatrix( QUANT_TABLES_INTRA, TRUE, TRUE);
		qmatrix( DQUANT_TABLES_INTRA, FALSE, TRUE);
		qmatrix( ALT_QUANT_TABLES_NONINTRA, TRUE, FALSE);
		qmatrix( ALT_DQUANT_TABLES_NONINTRA, FALSE, FALSE);
#endif

        }

	// Load Math looup tables

    VT_LoadFileBin(Dev,VR_DRAM,"cos_SIF.tai", COS_TABLE,
		 COS_TABLE + COS_TABLE_SIZE - 1, 0);
    VT_LoadFileBin(Dev,VR_DRAM,"fvbfvbs.bii", DA_F_VBS_VBF,
                 DA_F_VBS_VBF + DA_F_VBS_VBF_SIZE - 1, 0);

	// Load Vlc table
    VT_LoadFileBin(Dev,VR_DRAM,"vlc_SIF.tai", VLC_TABLES,
		 VLC_TABLES + VLC_TABLES_SIZE - 1, 0);

    /* write bitrate parameters into DRAM  - MUST be done after code is loaded! */
	int bitrate=Dev->RecodeInfo.DataRate;
	dprintf("Bitrate Requested %d actual %d\n",bitrate,bitrate/400);
    bps_scaled = bitrate/400;

    dramWrite(Regs , BITS_PER_SEC_DIV_400 >> 2, bps_scaled);
    dramWrite(Regs , INIT_VBV_FULLNESS    >> 2, INIT_VBV_FULLVAL);
    dramWrite(Regs , HDR_VBV_SIZE_LOC     >> 2, VBV_SIZE);

    /* load the polarity bit with the desired polarity. */
    if (polarity_switch)
      dramWrite(Regs, POLARITY_BIT, 1);   /* use the alternate polarity */
    else
      dramWrite(Regs, POLARITY_BIT, 0);   /* use the default polarity */
    
    /* Initialize the interrupt enable locations */
    for (i=0; i< INTERRUPT_ENABLE_SIZE; i++) 
    	dramWrite(Regs , (INTERRUPT_ENABLE_BLOCK + i), interrupt_enable_value); 
	
    /* Setup Memory locations for audio_start_register */
    dramWrite(Regs , DA_AUDIO_START_REG>>2, as_reg_value); 

    /* Setup Memory location for pts register */
    dramWrite(Regs , DA_PTS_REG_ADDR>>2, pts_reg_value); 

    /* Setup Memory location for pts offset   */
    dramWrite(Regs, DA_PTS_OFFSET >> 2, pts_offset_value);

    /* Setup Memory location for pts format	*/
    dramWrite(Regs, DA_PTS_FORMAT >> 2, pts_format_value);

    /* Setup Memory location for PES data	*/
    dramWrite(Regs, DA_PES_DATA >> 2, pes_data_value);

    /* Setup Memory location for decimation flag	*/
    dramWrite(Regs, DA_DECIMATION_FLAG >> 2, decimation_flag_value);

    /* Setup Memory location for wide video A flag	*/
    dramWrite(Regs, DA_WIDE_VIDA_FLAG >> 2, wide_vida_flag_value);

    /* Setup Memory location for wide video B flag	*/
    dramWrite(Regs, DA_WIDE_VIDB_FLAG >> 2, wide_vidb_flag_value);

    /* Setup Memory location for scene change detection control	*/
    dramWrite(Regs, DA_SCENE_CHANGE_CONTROL >> 2, 
        (start_gop_reset_flag_value << 1) | scd_flag_value);

    /* Setup Memory location for command discard threshold */
    dramWrite(Regs, DA_DISCARD_THRESHOLD >> 2, cmd_discard_thres_val);

    /* Setup Memory location for bit distribution clipping control */
    dramWrite(Regs, DA_BIT_DIST_CLIP_CONTROL >> 2, bit_dist_clip_ctl_val);

#ifdef RECODER
    /* Setup Memory location for stuffing flag */ 
    dramWrite(Regs, DA_STUFFING_FLAG >> 2, no_stuffing_value);    
#endif

   /*
    *-------------------------------------------------------------------------
    * Initialize any DRAM loactions indicated by the config.sys file.  This
    * will override command-line settings.  Config.sys is not required to
    * exist.
    *-------------------------------------------------------------------------
    */
	// removed untill needed by PEB
#if 0
    switch(InitDramFromFile(Regs, "config.sys")) {
    case 2:
      OutputDebugString ("Syntax error in config.sys\n");
      break;
      
    case 3:
      OutputDebugString ("Dram address out of range in config.sys\n");
      break;
    }
#endif    
    /* Initialize ME MemCtl */
    GBusWrite( GBUS_MEMEMCTL, 0xc0000040L);    

    /* Clear Host semaphore bit */
    GBusWrite( GBUS_SEMA, 0x0L);               

    /* Disable all INTs. */    
    WBusWrite(Regs, WBUS_INTCTL, 0xfffefffeL);      
   
    /* Reset Mul_Cntl Reg (clip 8) */
    /* Note: the setting of MULCTL will be overwritten by the ucode */
    /* so the setting here is don't care */
    WBusWrite(Regs,WBUS_MULCTL,0x4);             
    
    /*
     * Enable DMA Unit 
     * (Normal, Interleaved, 8 or 9-bit page, Refr Count = 0x100) 
     */
    GBusWrite(GBUS_DMAMODE,VIDTOOL_MEMCONFIG); 
    
    /* Reset Vlc_Start register. */
    GBusWrite(GBUS_VLCSTART,0x0);

    if(cl950_value)
    {
	/* turn on VLC unit (Px64, Intra, empty PACK & ZZ) */
	GBusWrite(GBUS_VLCCTL,0x0008010D);
	GBusWrite(GBUS_VLCCTL,0xc008010D);
    }
    else
    {
	/* turn on VLC unit (MPEG, Intra, empty PACK & ZZ) */
	GBusWrite(GBUS_VLCCTL,0x00080105);
	GBusWrite(GBUS_VLCCTL,0xc0080105);
    }

    /* Zero out VLC Pack register, 
     * enable CPU module (reset Ghalt, Greset), set PIO as input, 
     */
    WBusWrite(Regs,WBUS_CPUPACK,0x0);
    WBusWrite(Regs,WBUS_CPUCTL,0xc0000000);

    /* enable smem, refresh and VLC */
    WBusWrite(Regs,WBUS_INTCTL,0x00010201);
 
    /* setup VLC DMA */
    WBusWrite(Regs,WBUS_CHMEM5,0xff980003); 
	return VT_NO_ERROR;
}

ECODE CRecode::SetParam(DWORD param,long  value)
{
	switch (param)
	{
	case RECODEBYPASS:
		if (value) 
		{
			DWORD temp[2]={6,1};
			m_WriteBlockSize=(Dev->RecodeInfo.FrameWidth*Dev->RecodeInfo.FrameHeight)>>1;
			ReturnIfError(LoadParams(0,2,2,temp));
		}
		break;
	case RECODEBLOCKSIZE:
			m_WriteBlockSize=value;
		break;

	default: return CMicrocode::SetParam(param,value);
	}
	return VT_NO_ERROR;
}

ECODE CRecode::Start()
{
	DWORD scount=0;

    CrChange(Dev->Regs,CTRL1,0xfe,0x10);
	// dma init ??
	CrChange(Dev->Regs,CTRL2,FIFO_MODE_MASK,FIFO_MODE_RECODE);
	VT_LoadDma(Dev,MASTER2,m_Buffer2Size,m_Buffer2Phys);
	VT_LoadDma(Dev,MASTER1,m_WriteBlockSize,Dev->FB_PhysAddr);

	Change32(&Dev->Regs->Csr,MSTR_MODE_MASK ,MSTR_OUTPUT);
	
	//dramWrite(Dev->Regs, WRITE_PTR_ADDR, 0x200);
	//ReturnIfError(CMicrocode::Start());
	VRP_COMMAND Cmd={EMI_Start,2,TC_NOW};
	VT_SendCommand(Dev,&Cmd);

	/*	
	// for start to be processed
	dramRead(Dev->Regs,PRIORITY_BUFFER,&data);
	while (data & 0xffff0000)
	{
		Sleep(10);
		dramRead(Dev->Regs,PRIORITY_BUFFER,&data);
		scount++;
		if (scount>500) return (0xBADD0000);
	}
*/
/*
	dramRead(Dev->Regs, WRITE_PTR_ADDR, &data);
	scount=0;
	while (data ==0x200)
	{
		Sleep(10);
		dramRead(Dev->Regs,WRITE_PTR_ADDR,&data);
		scount++;
	}
*/
	return VT_NO_ERROR;
}

//#define  NUM_BLOCKS  (200)

/*
__inline DWORD  max(DWORD a,DWORD b)
{
	if (a>b) return a;
	else return b;
}
*/
/*
extern "C" ECODE VT_INTERFACE VT_WriteRecodeData(DEVID dwDevice, const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten)
{
	return (((CRecode*)dwDevice->MicroCode)->WriteData(SrcPtr, Words, WordsWritten));
}
*/

/***********************************************************************
 *
 * Load Clipping Tables Command.
 *
 ***********************************************************************/
#if 0

#define	BLOCK_H	16
#define	BLOCK_V	16
#define ON	1
#define OFF	0
#define XSKIP	8
#define YSKIP	4

	int		vertical_mb_resolution = 15;
	int		horizontal_mb_resolution = 22;
	int		clip_x[720];
	int		clip_y[288];
	int		data[24][64];

typedef struct
	{
	  unsigned long rfxmin	: 3,
			mxmin	: 7,
			mymin	: 6,
			rfxmax	: 3,
			mxmax	: 7,
			mymax	: 6;
	}  meminmax;

meminmax r_minmax;

	int		pixnumx, pixnumy, pixreftop, pixrefbot;
	int		xnum, ynum, bksizex, bksizey;
	int		minx, maxx, miny, maxy, extime;
	int		curnum, refnum;

/*-----------------------------------------------------------------------*/
void CMicrocode::loadClippingTables(int horizontal, int vertical)
{
  int    horizontal_resolution;
  int    vertical_resolution;
  int	 index;
  ulong	 addr;
  int	 mvx, mvy;

  vertical_mb_resolution = vertical;
  horizontal_mb_resolution = horizontal;

  vertical_resolution = vertical_mb_resolution * 16;
  horizontal_resolution = horizontal_mb_resolution * 16;
  
  for(index = 0; index < horizontal_resolution; index++)  {
    clip_x[index] = (0 << 22) + (7 << 6) + (7 << 13);
  }
  for(index = 0; index < vertical_resolution; index++)  {
    clip_y[index] = (0 << 16) + 7;
  }
  clip_x[0] = (4 << 22) + (7 << 6) + (7 << 13);
  clip_x[horizontal_resolution - BLOCK_H] = (0 << 22) + (4 << 6) + (7 << 13);
  clip_y[0] = (4 << 16) + 7;
  clip_y[vertical_resolution - BLOCK_V] = (0 << 16) + 4;
  VT_Write(Dev,VR_DRAM, DA_CLIPX, (DWORD*)clip_x,horizontal_resolution);
  VT_Write(Dev,VR_DRAM, DA_CLIPY, (DWORD*)clip_y,vertical_resolution);

  
  for(mvy = 0; mvy < 24; mvy++)  {
    for(mvx = 0; mvx < 48; mvx++)  {
      mktablep(mvy, mvx);
    }
  }
  
  addr = DA_PTB;
  for(mvy = 0; mvy < 24; mvy++)  {
    for(mvx = 0; mvx < 64; mvx++)  {
      dramWrite(Dev->Regs, addr++, data[mvy][mvx]);
    }
  }
  
  for(mvy = 0; mvy < 16; mvy++)  {
    for(mvx = 0; mvx < 32; mvx++)  {
      mktableb(mvy, mvx);
    }
  }
  
  addr = DA_BTB;
  for(mvy = 0; mvy < 16; mvy++)  {
    for(mvx = 0; mvx < 32; mvx++)  {
      dramWrite(Dev->Regs, addr++, data[mvy][mvx]);
    }
  }
  
  pixnumx = horizontal_resolution / 2;
  pixnumy = vertical_resolution / 2;
  pixreftop = 0;
  pixrefbot = 0;
  bksizex = 8;
  bksizey = 8;
  curnum = 6;
  refnum = 4;
  minx = -24;
  maxx = 23;
  miny = -12;
  maxy = 11;
  extime = 2;
  
  clipme1(ME1_CLIP_TABLE_P);
  
  pixnumx = horizontal_resolution / 2;
  pixnumy = vertical_resolution / 2;
  pixreftop = 0;
  pixrefbot = 0;
  bksizex = 8;
  bksizey = 8;
  curnum = 4;
  refnum = 3;
  minx = -16;
  maxx = 15;
  miny = -8;
  maxy = 7;
  extime = 1;
  
  clipme1(ME1_CLIP_TABLE_B);
}

/*-----------------------------------------------------------------------*/
static void mktablep(int y, int x)
{
  int	address;
  int	p, xxx, yyy, zzz;
  int	new_y, new_x;
  
  new_y = y + 3;
  new_x = x + 7;
  
  p = new_y / 8;
  yyy = new_y - p * 8;
  
  xxx = new_x / 2;
  zzz = new_x % 2;
  
  address = p * (horizontal_mb_resolution) * 256 
            + xxx * 64 + yyy * 8 + zzz * 4;
  address -= (256 + 64);
  
  data[y][x] = address;
}

/*-----------------------------------------------------------------------*/
static void mktableb(int y, int x)
{
  int	address;
  int	p, xxx, yyy, zzz;
  int	new_y, new_x;
  
  new_y = y + 7;
  new_x = x + 7;
  
  p = new_y / 8;
  yyy = new_y - p * 8;
  
  xxx = new_x / 2;
  zzz = new_x % 2;
  
  address = p * (horizontal_mb_resolution) * 256 
              + xxx * 64 + yyy * 8 + zzz * 4;
  address -= (horizontal_mb_resolution + 1) * 256;
  
  data[y][x] = address;
}


#pragma warning (disable: 4018)
 
/*-----------------------------------------------------------------------*/
void CMicrocode::clipme1(ulong addr)
{
  int x, y;
  int MINX, MAXX, MINY, MAXY ;
  int ovrtopy, ovrboty, right, left, mid, temp, temp2, prev ;
  int clipminx, clipmaxx, clipminy, clipmaxy ;
  int curmax, firstcurnum ;
  ulong dmem;
  PREGS Regs=GET_STRUCT_PTR(Dev);
 
  MINY = (YSKIP+(miny%YSKIP))%YSKIP*2  ;
  MAXY = (MINY + (maxy - miny)*2) + 1 ;
  ovrtopy = ((0 - miny + YSKIP - 1)/YSKIP)*YSKIP ;
  ovrboty = ((0 + maxy + YSKIP - 1)/YSKIP)*YSKIP ;
  
  if(curnum<=4) {
    curmax = 4;
    firstcurnum = 2;
  }
  else if(curnum<=8) {	
    curmax = 8;
    if(extime == 2) 
      firstcurnum = 3;
    if(extime == 3)
      if(curnum != 6) 
	printf(" ERROR !!! ") ;
  }
  else {
    printf("Error:  Over Horizontal Search Range!") ;
    exit(0) ;
  }
  
  MINX = ((curmax-curnum)*XSKIP + (curnum/2)*bksizex + minx)*2 ;
  temp = (curnum/2)*bksizex + maxx ;
  MAXX = ((curmax-curnum+(temp/bksizex))*XSKIP + (temp%bksizex))*2 + 1  ;
  right = ((curmax-curnum+((curnum-2)/2))*XSKIP)*2 ;
  left = ((curmax-((curnum-2)/2))*XSKIP)*2 - 1 ;
  mid = (right+left+1) ;

  xnum = (pixnumx+bksizex-1)/bksizex;;
  ynum = (pixnumy+bksizey-1)/bksizey;;
  
  prev = 0 ;
  for(y=0; y<ynum; y++) {   
    clipminy = (ovrtopy - (y*bksizey) - pixreftop)*2 ;
    clipmaxy = (ovrtopy + pixnumy - ((y+1)*bksizey) + pixrefbot)*2 ;
    for(x=0; x<xnum; x++) {
      clipmaxx = left + (x*XSKIP)*2 ;
      clipminx = right + (((x+2)*bksizex - pixnumx)/bksizex)*XSKIP*2 ;
      r_minmax.rfxmin = 0 ;
      r_minmax.rfxmax = clipminx<=right?(bksizex-1):
	(clipminx-right)>(bksizex-1)?0:((bksizex-1)-(clipminx-right)) ;
      if((curnum<=4) && (refnum<=4) && (extime == 1)) {
	temp = MINY>clipminy?MINY:clipminy ;
	r_minmax.mymax = MAXY<clipmaxy?MAXY:clipmaxy ;
	r_minmax.mymin = r_minmax.mymax<temp?r_minmax.mymax:temp ;
	temp = MINX>clipminx?MINX:mid<clipminx?mid:clipminx ;
	r_minmax.mxmax = MAXX<clipmaxx?MAXX:clipmaxx ;
	r_minmax.mxmin = r_minmax.mxmax<temp?r_minmax.mxmax:temp ;
	
	dmem = *((ulong *)&r_minmax);
	dramWrite(Regs, addr++, dmem);
	
      }
      else if((curnum<=8) && (refnum<=4) && (extime == 2))
	{	temp = MINY>clipminy?MINY:clipminy ;
		r_minmax.mymax = MAXY<clipmaxy?MAXY:clipmaxy ;
		r_minmax.mymin = r_minmax.mymax<temp?r_minmax.mymax:temp ;
		temp = (curmax-firstcurnum)*XSKIP*2 ;
		r_minmax.mxmax = clipmaxx<MAXX?clipmaxx:MAXX ;
		r_minmax.mxmin = r_minmax.mxmax<temp?r_minmax.mxmax:temp ;

		dmem = *((ulong *)&r_minmax);
		dramWrite(Regs, addr++, dmem);

		temp = clipminx>MINX?clipminx:MINX ;
		r_minmax.mxmax = ((curmax-firstcurnum)*XSKIP)*2-1 ;
		r_minmax.mxmin = r_minmax.mxmax<temp?r_minmax.mxmax:temp ;

		dmem = *((ulong *)&r_minmax);
		dramWrite(Regs, addr++, dmem);

	    }
      else if((curnum==6) && (refnum<=4) && (extime == 3))
	{	temp = MINY>clipminy?MINY:clipminy ;
		r_minmax.mymax = MAXY<clipmaxy?MAXY:clipmaxy ;
		r_minmax.mymin = r_minmax.mymax<temp?r_minmax.mymax:temp ;
		temp = (curmax-2)*XSKIP*2 ;
		r_minmax.mxmax = clipmaxx<MAXX?clipmaxx:MAXX ;
		r_minmax.mxmin = r_minmax.mxmax<temp?r_minmax.mxmax:temp ;

		dmem = *((ulong *)&r_minmax);
		dramWrite(Regs, addr++, dmem);

		temp = clipmaxx<MAXX?clipmaxx:MAXX ;
		temp2 = ((curmax-2)*XSKIP)*2-1 ;
		r_minmax.mxmax = temp>temp2?temp2:temp ;
		temp = clipminx>MINX?clipminx:MINX ;
		temp2 = (curmax-(2*2))*XSKIP ;
		r_minmax.mxmin = temp<temp2?temp2:temp ;

		dmem = *((ulong *)&r_minmax);
		dramWrite(Regs, addr++, dmem);

		temp = clipminx>MINX?clipminx:MINX ;
		r_minmax.mxmax = ((curmax-(2*2))*bksizex)*2 - 1 ;
		r_minmax.mxmin = r_minmax.mxmax<temp?r_minmax.mxmax:temp ;

		dmem = *((ulong *)&r_minmax);
		dramWrite(Regs, addr++, dmem);

	      }
      else if((curnum<=4) && (refnum==5))
	{	temp = MINX>clipminx?MINX:mid<clipminx?mid:clipminx ;
	 	r_minmax.mxmax = MAXX<clipmaxx?MAXX:clipmaxx ;
		r_minmax.mxmin = r_minmax.mxmax<temp?r_minmax.mxmax:temp ;
		temp = MINY>clipminy?MINY:clipminy ;
		r_minmax.mymax = (5-3)*bksizey*2 - 1 ;
		r_minmax.mymin = r_minmax.mymax<temp?r_minmax.mymax:temp ;

		dmem = *((ulong *)&r_minmax);
		dramWrite(Regs, addr++, dmem);

		temp = MAXY<clipmaxy?MAXY:clipmaxy ;
		r_minmax.mymin = (5-3)*bksizey*2 ;
		r_minmax.mymax = temp>r_minmax.mymin?temp:r_minmax.mymin ;

		dmem = *((ulong *)&r_minmax);
		dramWrite(Regs, addr++, dmem);

		extime = 2;
	      }
    }
  }
  r_minmax.mxmin = 1;
  r_minmax.mxmax = 1;
  r_minmax.mymin = 1;
  r_minmax.mymax = 1;
  for(x=0; x<extime*curnum/2; x++) {
    dmem = *((ulong *)&r_minmax);
    dramWrite(Regs, addr++, dmem);
  }
}

#endif 


#ifdef _DEBUG
static ECODE CheckMasterErr(volatile PREGS Regs)
{
	if (Regs->Csr & 0x10)
	{
		OutputDebugString("Master Abort\n");
		return 0xDEADDEAD;
	}
	else 
		return VT_NO_ERROR;
}
#else
#define CheckMasterErr(_x) VT_NO_ERROR
#endif

static int TotalInput=0;
static int TotalWritten=0;

//#define WRITEDATABRUCE
#define WRITEDATAOLD
//#define WRITEDATAPIO

#ifdef WRITEDATAPIO
ECODE CRecode::WriteData(const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten)
{
//   Disable dma and clear Done Flags
	int Size;
	*WordsWritten=0;
	if (Dev->Regs->Status & FIFO_OVERFLOW)
	{
		return VT_ERR_FIFOOVERFLOW;
	}

    if ( Read32(&Dev->Regs->Csr) & VRP_LOCAL) 
		return VT_NO_ERROR;


    //copy all input to transfer area
    CopyMemory(Dev->FB_LinAddr+m_m_ExtraSize,SrcPtr,Words*sizeof(DWORD));

	Size=m_WriteBlockSize-m_m_ExtraSize;
	if (Size>(int)Words)
	{
		Size=Words;
	}
	SrcPtr+=Size;
	*WordsWritten+=Size;
	Words-=Size;
	Size+=m_m_ExtraSize;  // buffer both sets of data
	m_m_ExtraSize=0;  // so that return while transfer works
    DWORD *Addr = Dev->FB_LinAddr;

	while (Words>0)  // while good buffer
	{

		for (DWORD i=0;i<m_WriteBlockSize;i++)
		{
			int timeout=0;
			while (Dev->Regs->Csr & (PORTA_FLAG | VRP_LOCAL))
			{
				if (Dev->Regs->Csr &  VRP_LOCAL)
					Sleep(1);
				if (timeout++>IREG_WRITE_TIMEOUT)
				{
					return VT_NO_ERROR;
				}
			}
			Dev->Regs->PortAIn=*Addr++;
		}

		// wait for compleation
        int SleepCount ;
        SleepCount = 0;
			// code a simple delay here
			for (i=0;i<200;i++)
				__asm  nop;

            while ( Read32(&Dev->Regs->Csr) & VRP_LOCAL) {
                if (SleepCount++ > 200)
                    return 0x78;
                Sleep(10);
            }


		if (Words>m_WriteBlockSize)
		{
			Size=m_WriteBlockSize;
		}
		else
		{
			Size=Words;
		    CopyMemory(Dev->FB_LinAddr,SrcPtr,Size*sizeof(DWORD));	
		}
		SrcPtr+=Size;
		Words-=Size;
//		TotalWritten+=Size;
		*WordsWritten+=Size;
	}
	m_m_ExtraSize=Size;
	return VT_NO_ERROR;
}


#endif
#ifdef WRITEDATAOLD
ECODE CRecode::WriteData(const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten)
{
//   Disable dma and clear Done Flags
	DWORD Size;
	*WordsWritten=0;
	if (Dev->Regs->Status & FIFO_OVERFLOW)
	{
		return VT_ERR_FIFOOVERFLOW;
	}
	if (!(Dev->Regs->Status & DONE_FLAG_1) && (Dev->Regs->Csr & MSTR_INPUT) 
		|| Dev->Regs->Csr & VRP_LOCAL )
	{
		// Not ready for more data
		return VT_NO_ERROR;
	}
	Size=m_WriteBlockSize-m_ExtraSize;
	if (Words==0)
	{// Flushing bufferd data
		if (m_ExtraSize==0) return VT_ERR_FIFO_EMPTY;
		Words=Size;
		ZeroMemory(Dev->FB_LinAddr+m_ExtraSize,Size*sizeof(DWORD));
	}
	else
	{
		if (Size>(int)Words)
		{
			Size=Words;
		}
		CopyMemory(Dev->FB_LinAddr+m_ExtraSize,SrcPtr,Size*sizeof(DWORD));	
		SrcPtr+=Size;
	}
	*WordsWritten+=Size;
	Words-=Size;
	Size+=m_ExtraSize;  // buffer both sets of data
	m_ExtraSize=0;  // so that return while transfer works
	while (Size>=m_WriteBlockSize)  // while good buffer
	{
		// Clear dma
		ReturnIfError(CheckMasterErr(Dev->Regs));
		Change32(&Dev->Regs->Csr,MSTR_INPUT ,0);
		ReturnIfError(CheckMasterErr(Dev->Regs));
		Change32(&Dev->Regs->Status,DONE_FLAG_1,DONE_FLAG_1);
		ReturnIfError(CheckMasterErr(Dev->Regs));
		// Start The DMA
		//Sleep(10);
//		VT_LoadDma(Dev,MASTER1,m_WriteBlockSize,Dev->FB_PhysAddr);
		// flush cach
		VT_FlushCache(Dev);
//		if (Read32(&Dev->Regs->Status) & DONE_FLAG_1)
//			Write32(&Dev->Regs->Status,DONE_FLAG_1);
//		else
			Change32(&Dev->Regs->Csr,MSTR_INPUT | STOP_1DONE_IN,MSTR_INPUT |STOP_1DONE_IN);

		// if last block return
		if (Words==0) 
			return VT_NO_ERROR;

		// wait for compleation

		while(!(Read32(&Dev->Regs->Status) & DONE_FLAG_1))
		{
			// code a simple delay here
			if (m_WriteBlockSize<0x400)
			{
				for (int i=0;i<100;i++)
					__asm  nop;
			}
			else
				Sleep(0);
			if ( Read32(&Dev->Regs->Csr) & VRP_LOCAL)
				return VT_NO_ERROR; // Not ready?
			//dprintf("Calling sleep\n");
			//Sleep(0);  // do quickly
		}


		if (Words>=m_WriteBlockSize)
		{
			Size=m_WriteBlockSize;
		}
		else
		{
			Size=Words;
		}
		CopyMemory(Dev->FB_LinAddr,SrcPtr,Size*sizeof(DWORD));	
		SrcPtr+=Size;
		Words-=Size;
//		TotalWritten+=Size;
		*WordsWritten+=Size;
	}
	m_ExtraSize=Size;
	return VT_NO_ERROR;
}
#endif 
#ifdef WRITEDATANEW
ECODE CRecode::WriteData(const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten)
{
//   Disable dma and clear Done Flags
	*WordsWritten=0;
	if (Dev->Regs->Status & FIFO_OVERFLOW)
	{
		return VT_ERR_FIFOOVERFLOW;
	}
	if (!(Dev->Regs->Status & DONE_FLAG_1) && (Dev->Regs->Csr & MSTR_INPUT) 
		|| Dev->Regs->Csr & VRP_LOCAL )
	{
		// Not ready for more data
		return VT_NO_ERROR;
	}
	int Loops;
	CopyMemory(Dev->FB_LinAddr,SrcPtr,Words*sizeof(DWORD));	
	while (*WordsWritten<Words)
	{
		Loops=0;
		while (!(Dev->Regs->Status & DONE_FLAG_1) && (Dev->Regs->Csr & MSTR_INPUT) 
			|| Dev->Regs->Csr & VRP_LOCAL )
		{
			// Not ready for more data
			Sleep(1);
			if (Loops++>500) return 0;
		}

		// Clear dma
		ReturnIfError(CheckMasterErr(Dev->Regs));
		Change32(&Dev->Regs->Csr,MSTR_INPUT ,0);
		ReturnIfError(CheckMasterErr(Dev->Regs));
		Write32(&Dev->Regs->Status,DONE_FLAG_1);
		ReturnIfError(CheckMasterErr(Dev->Regs));
		// Start The DMA
		//Sleep(10);
		VT_LoadDma(Dev,MASTER1,m_WriteBlockSize,Dev->FB_PhysAddr+*WordsWritten*sizeof(DWORD));
		*WordsWritten+=m_WriteBlockSize;
		// flush cach
		//VT_FlushCache(Dev);
		Change32(&Dev->Regs->Csr,MSTR_INPUT | STOP_1DONE_IN,MSTR_INPUT |STOP_1DONE_IN);
		Sleep(1);
	}
	return VT_NO_ERROR;
}
#endif
#ifdef WRITEDATABRUCE
ECODE CRecode::WriteData(const DWORD *SrcPtr, DWORD Words, DWORD *WordsWritten)
{
	int Size;
	*WordsWritten=0;

    //exit if overflow
	if (Dev->Regs->Status & FIFO_OVERFLOW)
	{
		return VT_ERR_FIFOOVERFLOW;
	}

    //exit if transfer still in progress
	if (!(Dev->Regs->Status & DONE_FLAG_1) && (Dev->Regs->Csr & MSTR_INPUT) 
		|| Dev->Regs->Csr & VRP_LOCAL )
	{
		return VT_NO_ERROR;
	}

    //copy all input to transfer area
    CopyMemory(Dev->FB_LinAddr+m_ExtraSize,SrcPtr,Words*sizeof(DWORD));
    //VT_FlushCache(Dev);	
	Size=m_WriteBlockSize-m_ExtraSize;
	if (Size>(int)Words)
	{
		Size=Words;
	}
	SrcPtr+=Size;
	*WordsWritten+=Size;
	Words-=Size;
	Size+=m_ExtraSize;  // buffer both sets of data
	m_ExtraSize=0;  // so that return while transfer works
    DWORD PhysAddr = Dev->FB_PhysAddr;

	while (Words>0)  // while good buffer
	{
		// Clear dma
		ReturnIfError(CheckMasterErr(Dev->Regs));
		Change32(&Dev->Regs->Csr,MSTR_INPUT ,0);
		ReturnIfError(CheckMasterErr(Dev->Regs));
		Write32(&Dev->Regs->Status,DONE_FLAG_1);
		ReturnIfError(CheckMasterErr(Dev->Regs));
		// Start The DMA
		//Sleep(10);
		VT_LoadDma(Dev,MASTER1,m_WriteBlockSize,PhysAddr);
		if (Dev->Regs->MasterStart1!=PhysAddr)
		{
			dprintf("Bad start address is %x should be %x\n",Dev->Regs->MasterStart1,PhysAddr);
			return (1000);
		}
		Change32(&Dev->Regs->Csr,MSTR_INPUT | STOP_1DONE_IN,MSTR_INPUT |STOP_1DONE_IN);
        PhysAddr += m_WriteBlockSize*sizeof(DWORD);

		// wait for compleation
        int SleepCount ;
        SleepCount = 0;
		while(!(Read32(&Dev->Regs->Status) & DONE_FLAG_1))
		{
			// code a simple delay here
			for (int i=0;i<100;i++)
				__asm  nop;

            if ( Read32(&Dev->Regs->Csr) & VRP_LOCAL) {
                if (SleepCount++ > 200)
                    return 0x78;
                Sleep(10);
            }
		}
		if (Dev->Regs->MasterStart1!=PhysAddr-m_WriteBlockSize*sizeof(DWORD))
		{
			dprintf("Bad start  at finish address is %x should be %x\n",Dev->Regs->MasterStart1,PhysAddr-m_WriteBlockSize*sizeof(DWORD));
			return (1001);
		}


		if (Words>m_WriteBlockSize)
		{
			Size=m_WriteBlockSize;
		}
		else
		{
			Size=Words;
		    CopyMemory(Dev->FB_LinAddr,SrcPtr,Size*sizeof(DWORD));	
		}
		SrcPtr+=Size;
		Words-=Size;
//		TotalWritten+=Size;
		*WordsWritten+=Size;
	}
	m_ExtraSize=Size;
	return VT_NO_ERROR;
}
#endif

// This routine returns two values The linear addres of the output buffer
// and the size of the output buffer
ECODE CRecode::ReadData(void **DestPtr, DWORD *WordsRead)
{
	*DestPtr=m_Buffer2Lin;
	*WordsRead=m_Buffer2Size;
	VT_FlushCache(Dev);
	return VT_NO_ERROR;
}

DWORD CRecode::Stop()
{
#ifdef _DEBUG
	DWORD tmp;
		VT_Read(Dev,VR_DRAM,&tmp,0x1fe,1);
		dprintf("%d frames encoded\n",tmp);
#endif
	//return CMicrocode::Stop();
	VRP_COMMAND Cmd={EMI_Stop,2,TC_NOW};

	return VT_SendCommand(Dev,&Cmd);
}
