#ifdef VTOOLSD
#include <vtoolsc.h>
#else
//#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#endif

//#include "dt_scorp.h"
#define DEVNODE DWORD
#include <vtdioc.h>
#include "vt_acc.h"
#include "vt_regs.h"
#include "vt_vrp.h"
//#include "dtdefs.h"
#include "sc_def.h"
//#include "4000_com.h"
#include "4000_reg.h"
#include "4100_api.h"
#include <stdio.h>

#ifdef _DEBUG
void __cdecl dprintf(LPSTR szFormat, ...);

static char* DebugMessage=__FILE__ "error %d returned from line %d\n";
//static char DebugBuffer[120];

#define ReturnIfError(__func) {ECODE __ecode=__func; \
if (__ecode) {dprintf(DebugMessage,__ecode,__LINE__);return __ecode;} } 
#else
#define dprintf / ## /
#define ReturnIfError(__func) {ECODE __ecode=__func; if (__ecode) return __ecode;} 
#endif

volatile int HaveMutex;
HANDLE Mutex=NULL;
#if 0
#if 1
//#define GetMutex() if (!HaveMutex) {int status=WaitForSingleObject(Mutex,2000);} HaveMutex++
//#define ReleaseMutex() if (!--HaveMutex) {int status=ReleaseMutex(Mutex);} 
#define GetMutex() HaveMutex++
#define ReleaseMutex() HaveMutex-- 
#else
int GetMutex()
{
	int status=0;
	if (!HaveMutex) 
	{
		status=WaitForSingleObject(Mutex,2000);
	}
	HaveMutex++;
	return status;
}

int ReleaseMutex()
{
	int status=0;
	if (!--HaveMutex)
	{
		status=ReleaseMutex(Mutex);
	}
	return status
}

#endif
#endif


ECODE VT_INTERFACE VT_AquireMutex()
{
	int status=0;
	
	status=WaitForSingleObject(Mutex,INFINITE);

	return (status == WAIT_OBJECT_0) ?VT_NO_ERROR:VT_ERR_OTHER;
}


ECODE VT_INTERFACE VT_ReleaseMutex()
{
	int status=0;

	status=ReleaseMutex(Mutex);

	return (status == FALSE) ?VT_ERR_OTHER:VT_NO_ERROR;
}





#if 0
PREGS bd_addr;



ECODE lbus_peek(DWORD addr, DWORD *dptr)
{
	int i=0;
	bd_addr->Csr&=~IREG_WR;
    bd_addr->IRegAddr = addr;
	while (bd_addr->Csr & IREG_OP_BUSY) 
	   if (i++>IREG_READ_TIMEOUT) return VT_ERR_IREG_TIMEOUT;	
    *dptr = bd_addr->IRegData;
    return(0);
}

ECODE lbus_poke(DWORD addr, DWORD data)
{
 	int i=0;
	bd_addr->Csr|=IREG_WR;
    bd_addr->IRegAddr=addr;
    bd_addr->IRegData=data;
	while (bd_addr->Csr & IREG_OP_BUSY) 
	   if (i++>IREG_WRITE_TIMEOUT) return VT_ERR_IREG_TIMEOUT;	
    return(0);
}

#endif
#pragma data_seg (".SysGlobal")
volatile int InIReg=FALSE;
#pragma data_seg (".data") 




ECODE VrpPeekNoMutex(PREGS bd_addr,DWORD addr, DWORD *dptr)
{
	int i=0;
//	VT_AquireMutex();
	bd_addr->Csr&=~IREG_WR;
    bd_addr->IRegAddr = addr;
	while (bd_addr->Csr & IREG_OP_BUSY) 
		if (i++>IREG_READ_TIMEOUT) 
#ifdef USEEXCEPTIONS
		{
//			VT_ReleaseMutex();
			RaiseException(VT_ERR_IREG_TIMEOUT,0,0,NULL);
		}
#else
		{
//			VT_ReleaseMutex();
			return VT_ERR_IREG_TIMEOUT;	
		}
#endif
    *dptr = bd_addr->IRegData;
//	VT_ReleaseMutex();
#ifdef DIAGNOSE
	if (!(bd_addr->Csr & VRP_SEL)) return VT_ERR_VRP_SEL;
#endif
    return(0);
}

ECODE VrpPeek(PREGS bd_addr,DWORD addr, DWORD *dptr)
{
	ECODE ec;
	VT_AquireMutex();
	ec=VrpPeekNoMutex(bd_addr,addr, dptr);
	VT_ReleaseMutex();
	return ec;
}


ECODE VrpPokeNoMutex(PREGS bd_addr,DWORD addr, DWORD data)
{
 	int i=0;
//	VT_AquireMutex();
	bd_addr->Csr|=IREG_WR;
    bd_addr->IRegAddr=addr;
    bd_addr->IRegData=data;
	while (bd_addr->Csr & IREG_OP_BUSY) 
		if (i++>IREG_WRITE_TIMEOUT) 
#ifdef USEEXCEPTIONS
		{
//			VT_ReleaseMutex();
			RaiseException(VT_ERR_IREG_TIMEOUT,0,0,NULL);
		}
#else
		{
//			VT_ReleaseMutex();
			return VT_ERR_IREG_TIMEOUT;	
		}
#endif
#ifdef DIAGNOSE
	if (!(bd_addr->Csr & VRP_SEL)) return VT_ERR_VRP_SEL;
#endif
//	VT_ReleaseMutex();
    return(0);
}

ECODE VrpPoke(PREGS bd_addr,DWORD addr, DWORD data)
{
	ECODE ec;
	VT_AquireMutex();
	ec=VrpPokeNoMutex(bd_addr,addr, data);
	VT_ReleaseMutex();
	return ec;
}

void dramClear(PREGS Regs)
{
	dramFill(Regs,0,0,0x80000);
}


void VrpFill(PREGS Regs, DWORD addr, DWORD Value, DWORD Words)
{
  ulong       i,j;
  VT_AquireMutex();
	Regs->Csr|=IREG_WR;
  for(i = 0; i < Words; i++) 
  {
    Regs->IRegAddr=addr;
    Regs->IRegData=Value;
	j=0;
	addr+=4;
	while (Regs->Csr & IREG_OP_BUSY) 
		if (j++>IREG_WRITE_TIMEOUT) 
#ifdef USEEXCEPTIONS
		{
			VT_ReleaseMutex();
			RaiseException(VT_ERR_IREG_TIMEOUT,0,0,NULL);
		}
#else
		{
			VT_ReleaseMutex();
			return VT_ERR_IREG_TIMEOUT;	
		}
#endif
  } 
	VT_ReleaseMutex();
}

ECODE VrpChange(PREGS bd_addr,DWORD addr,DWORD mask, DWORD data)
{
	DWORD prevData;
	ECODE error;
 	VT_AquireMutex();
	if( (error=VrpPeek(bd_addr, addr, &prevData)) && (error!=VT_ERR_VRP_SEL)) {
	  	VT_ReleaseMutex();
  		return error;
	}
	VrpPoke(bd_addr, addr, (prevData & ~mask) | (data & mask));
  	VT_ReleaseMutex();
}

ECODE VT_ResetVRP(DEVID dwDevice)
{
    //PREGS bd_addr=GET_STRUCT_PTR(dwDevice);
 	VT_ReadModifyWrite(dwDevice,CR_REGS,CTRL1,0x80,0x80);
	VT_ReadModifyWrite(dwDevice,CR_REGS,CTRL1,0x80,0);
	return VT_NO_ERROR;
}

/*
#define GBusRead(_a,_b,_c) VrpPeek(_a,((_b << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,_c)
#define GBusWrite(_a,_b,_c) VrpPoke(_a,((_b << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,_c)
#define GBusChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,_c,_d)

#define WBusRead(_a,_b,_c) VrpPeek(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c)
#define WBusWrite(_a,_b,_c) VrpPoke(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c)
#define WBusChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c,_d)

#define dramRead(_a,_b,_c) VrpPeek(_a,((_b << 2) & 0x007ffffc) | VRP_CHIP,_c)
#define dramWrite(_a,_b,_c) VrpPoke(_a,((_b << 2) &  0x007ffffc) | VRP_CHIP,_c)
#define dramChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) &  0x007ffffc) | VRP_CHIP,_c,_d)
*/

VrpRead(PREGS bd_addr, DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i,timeout;
  	VT_AquireMutex();
	bd_addr->Csr&=~IREG_WR;

	for (i=0;i<Words;i++)
	{
	    bd_addr->IRegAddr = Source;
		Source+=4;
		timeout=0;
		while (bd_addr->Csr & IREG_OP_BUSY) 
			if (timeout++>IREG_READ_TIMEOUT)
#ifdef USEEXCEPTIONS
			{
				VT_ReleaseMutex();
				RaiseException(VT_ERR_IREG_TIMEOUT,0,0,NULL);
			}
#else
			{	
				VT_ReleaseMutex();
				return VT_ERR_IREG_TIMEOUT;	
			}
#endif
			*DestPtr++ = bd_addr->IRegData;
	}
#ifdef DIAGNOSE
	if (!(bd_addr->Csr & VRP_SEL)) return VT_ERR_VRP_SEL;
#endif
  	VT_ReleaseMutex();
    return(0);
}

VrpWrite(PREGS bd_addr, DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i,timeout;
  	VT_AquireMutex();
	bd_addr->Csr|=IREG_WR;

	for (i=0;i<Words;i++)
	{
	    bd_addr->IRegAddr=Dest;
	    bd_addr->IRegData=*SrcPtr++;
		Dest+=4;
		timeout=0;
		while (bd_addr->Csr & IREG_OP_BUSY) 
			if (timeout++>IREG_WRITE_TIMEOUT)
#ifdef USEEXCEPTIONS
			{
				VT_ReleaseMutex();
				RaiseException(VT_ERR_IREG_TIMEOUT,0,0,NULL);
			}
#else
			{	
				VT_ReleaseMutex();
				return VT_ERR_IREG_TIMEOUT;	
			}
#endif
	}
#ifdef DIAGNOSE
	if (!(bd_addr->Csr & VRP_SEL)) return VT_ERR_VRP_SEL;
#endif
	bd_addr->Csr&=~IREG_WR;
  	VT_ReleaseMutex();
    return(0);
}

VrpWriteSwap(PREGS bd_addr, DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i,timeout;
	const unsigned char *p=(const unsigned char*)SrcPtr;
	VT_AquireMutex();
	bd_addr->Csr&=~IREG_WR;
	for (i=0;i<Words;i++)
	{
		bd_addr->Csr|=IREG_WR;
	    bd_addr->IRegAddr=Dest;
	    bd_addr->IRegData=(p[0] << 24) | (p[1] << 16) | (p[2]<<8) | p[3];
		p+=4;
		Dest+=4;
//		for (j=0;j<200;j++) 
//		{
//			__asm nop
//		}
		timeout=0;
		while (bd_addr->Csr & IREG_OP_BUSY) 
			if (timeout++>IREG_WRITE_TIMEOUT)
#ifdef USEEXCEPTIONS
			{
				VT_ReleaseMutex();
				RaiseException(VT_ERR_IREG_TIMEOUT,0,0,NULL);
			}
#else
			{
				VT_ReleaseMutex();
				return VT_ERR_IREG_TIMEOUT;	
			}
#endif
	}
#ifdef DIAGNOSE
	if (!(bd_addr->Csr & VRP_SEL)) return VT_ERR_VRP_SEL;
#endif
	VT_ReleaseMutex();
    return(0);
}

ECODE CrRead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	ECODE tmp;
	VT_AquireMutex();
	CLEAR_CSR_BITS(VRP_SEL);
	tmp=VrpRead(bd_addr, DestPtr,  Source<<2,  Words);
	SET_CSR_BITS(VRP_SEL);
	VT_ReleaseMutex();
#ifdef DIAGNOSE
	if (tmp==VT_ERR_VRP_SEL) return VT_NO_ERROR;
	else 
#endif
	return tmp;
}

ECODE CrWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	ECODE tmp;
	VT_AquireMutex();
	CLEAR_CSR_BITS(VRP_SEL);
	tmp=VrpWrite(bd_addr,Dest<<2, SrcPtr, Words);
	SET_CSR_BITS(VRP_SEL);
	VT_ReleaseMutex();
#ifdef DIAGNOSE
	if (tmp==VT_ERR_VRP_SEL) return VT_NO_ERROR;
	else 
#endif
	return tmp;
}

ECODE CrPoke(PREGS bd_addr,DWORD addr, DWORD data)
{
	ECODE tmp;
	VT_AquireMutex();
	CLEAR_CSR_BITS(VRP_SEL);
	tmp=VrpPoke(bd_addr,addr<<2, data);
	SET_CSR_BITS(VRP_SEL);
	VT_ReleaseMutex();
#ifdef DIAGNOSE
	if (tmp==VT_ERR_VRP_SEL) return VT_NO_ERROR;
	else 
#endif
	return tmp;
}

ECODE VidOutCtlPoke(PREGS Regs,DWORD data)
{
	    DWORD ctrl2;
		CrRead(Regs,&ctrl2,CTRL2,1);
		CrChange(Regs,CTRL1,VIDEO_EN,0);
		CrChange(Regs,CTRL2,FIFO_RESET,FIFO_RESET);
		CrChange(Regs,CTRL1,FIRST_PIXEL,FIRST_PIXEL);
		CrPoke(Regs,CTRL2,FIFO_MODE_WRITE|FIFO_RESET);
		CrPoke(Regs,CTRL2,FIFO_MODE_WRITE|FIFO_RESET);
		CrPoke(Regs,FIFO_DATA,data);
		CrPoke(Regs,FIFO_DATA,data);
		CrChange(Regs,CTRL2,FIFO_LD,FIFO_LD);
		CrChange(Regs,CTRL2,FIFO_LD,0);
		CrChange(Regs,CTRL1,FIRST_PIXEL,0);
		return CrPoke(Regs,CTRL2,ctrl2);// if this worked all worked
}
#if 0
void Write32(volatile DWORD *addr,DWORD value)
{
	*addr=value;
/*
	__asm {
			mov dx,addr
			mov dword ptr dx,value
	}
*/
}

DWORD Read32(volatile DWORD *addr)
{
	return *addr;
/*
	__asm {
			mov dx,addr
			mov dword ptr dx,value
	}
*/
}

DWORD Change32(volatile DWORD *addr,DWORD mask,DWORD value)
{
		return *addr= (*addr & ~mask) | (value & mask);

/*
	__asm {
			mov dx,addr
			mov dword ptr dx,value
	}
*/
}
#endif

ECODE CrChange(PREGS bd_addr,DWORD addr,DWORD mask, DWORD data)
{
	ECODE tmp;
	VT_AquireMutex();
	CLEAR_CSR_BITS(VRP_SEL);
	tmp=VrpChange(bd_addr,addr<<2,mask,data);
	SET_CSR_BITS(VRP_SEL);
	VT_ReleaseMutex();
#ifdef DIAGNOSE
	if (tmp==VT_ERR_VRP_SEL) return VT_NO_ERROR;
	else 
#endif
	return tmp;
}
#if 0
void WriteCsrDelay(PREGS bd_addr,DWORD value)
{
   int i;
   for (i=0;i<50;i++)
	bd_addr->Csr=value;
}

ECODE WriteSerialStart(PREGS bd_addr)
{
	int i=0;
	DWORD cpy=bd_addr->Csr & ~(SDO | SCLK);
	WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
	while(!(bd_addr->Csr & SDI))
	{
		// recovery code
		WriteCsrDelay(bd_addr,cpy | SDO);
		WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
		if (i++>32) return VT_VIP_UNDEFINED;
	} 
	WriteCsrDelay(bd_addr,cpy | SCLK);
	return 0;
}

void WriteSerialStop(PREGS bd_addr)
{
	DWORD cpy=bd_addr->Csr & ~(SDO | SCLK);
	WriteCsrDelay(bd_addr,cpy | SDO);
	WriteCsrDelay(bd_addr,cpy);
	WriteCsrDelay(bd_addr,cpy | SCLK);
	WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
}


ECODE WriteSerial(PREGS bd_addr,DWORD data)
{
    long i;
	DWORD newdata=0;
	DWORD cpy=bd_addr->Csr & ~( SCLK);
	VT_AquireMutex();
	for (i=7;i >=0;i--)
	{
		WriteCsrDelay(bd_addr,cpy);
		if (data & (1<< i)) 
		   cpy|=SDO;	// set data
		else
		   cpy&=~SDO;	// CLEAR DATA
		WriteCsrDelay(bd_addr,cpy);
		WriteCsrDelay(bd_addr,cpy | SCLK);

		if (bd_addr->Csr & SDI)
		{
		    newdata|=1<<i; 
		}

	}
	WriteCsrDelay(bd_addr,cpy);
	cpy|=SDO;	// set data
	WriteCsrDelay(bd_addr,cpy);
	WriteCsrDelay(bd_addr,cpy | SCLK);
 
	if (data!=newdata || (bd_addr->Csr & SDI))
	{
		VT_ReleaseMutex();
		return VT_ERR_SR_WRITE;
/*
		printf("%2x %2x",data,newdata);
		if (bd_addr->Csr & SDI)
		{
		    printf(" no ack"); 
		}
		printf("\n");
*/
	}
	VT_ReleaseMutex();
	return 0;

}

void ReadSerial(PREGS bd_addr,DWORD *data)
{
    long i;
	DWORD cpy=bd_addr->Csr & ~( SCLK ) | SDO;
	*data=0;
	VT_AquireMutex();
	bd_addr->Csr=cpy ; //DROP CLOCK AND RASE DATA note that data should be high already
	for (i=7;i >=0;i--)
	{
		WriteCsrDelay(bd_addr,cpy);
		if (bd_addr->Csr & SDI)
		{
		   *data|=1<<i; 
//			printf("%1d",1);
		}
//		else
//			printf("%1d",0);
		WriteCsrDelay(bd_addr,cpy | SCLK);
	}
	WriteCsrDelay(bd_addr,cpy);
	cpy&=~SDO; 	// clear output
	WriteCsrDelay(bd_addr,cpy);
	WriteCsrDelay(bd_addr,cpy | SCLK | SDO);
	VT_ReleaseMutex();
//	printf("\n");
}



ECODE SrRead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i;
	for (i=0;i<Words;i++)
	{
	    ReturnIfError(WriteSerialStart(bd_addr));
		ReturnIfError(WriteSerial(bd_addr,0x48)); // slave address
		ReturnIfError(WriteSerial(bd_addr,Source++)); // subaddress address
	    WriteSerialStop(bd_addr);
	    ReturnIfError(WriteSerialStart(bd_addr));
		ReturnIfError(WriteSerial(bd_addr,0x49)); // slave address
	    ReadSerial(bd_addr,DestPtr++);
	}
    WriteSerialStop(bd_addr);
	return 0;
}

ECODE SrWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i;
	for (i=0;i<Words;i++)
	{
		//dprintf("Write vip %x val %x\n",Dest,*SrcPtr);
    	ReturnIfError(WriteSerialStart(bd_addr));
		ReturnIfError(WriteSerial(bd_addr,0x48)); // slave address
		ReturnIfError(WriteSerial(bd_addr,Dest++)); // subaddress address
		ReturnIfError(WriteSerial(bd_addr,*SrcPtr++));
    	WriteSerialStop(bd_addr);
	}
	return 0;
}

ECODE SrReadFlash(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i;
	int slave;
	for (i=0;i<Words;i++)
	{
		slave=0xa0 | ((Source & 0x700) >>7 );
	    ReturnIfError(WriteSerialStart(bd_addr));
		ReturnIfError(WriteSerial(bd_addr,slave)); // slave address
		ReturnIfError(WriteSerial(bd_addr,Source++)); // subaddress address
	    WriteSerialStop(bd_addr);
	    ReturnIfError(WriteSerialStart(bd_addr));
		ReturnIfError(WriteSerial(bd_addr,slave | 1)); // slave address
	    ReadSerial(bd_addr,DestPtr++);
	}
    WriteSerialStop(bd_addr);
	return 0;
}

ECODE SrWriteFlash(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i;
    ReturnIfError(WriteSerialStart(bd_addr));
	ReturnIfError(WriteSerial(bd_addr,0xa0 | ((Dest & 0x700) >>7 ))); // slave address
	ReturnIfError(WriteSerial(bd_addr,Dest++)); // subaddress address
	for (i=0;i<Words;i++)
		ReturnIfError(WriteSerial(bd_addr,*SrcPtr++));
    WriteSerialStop(bd_addr);
	return 0;
}
#endif
/* READ DATA directly OUT OF THE A FIFO buffer in the vrp */ 
ECODE FifoARead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i;
    DWORD vactl_save;
	ReturnIfError(GBusRead(bd_addr,GBUS_VACTL, &vactl_save));
	for (i=0;i<Words;i++)
	{
        ReturnIfError(GBusChange(bd_addr,GBUS_VACTL, 0x1fc00000, Source++ << 22));
        ReturnIfError(GBusRead(bd_addr,GBUS_VADATA, DestPtr++));
	}
    ReturnIfError(GBusWrite(bd_addr,GBUS_VACTL, vactl_save));
	return 0;
}


ECODE FifoAWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i;
    DWORD vactl_save;
	ReturnIfError(GBusRead(bd_addr,GBUS_VACTL, &vactl_save));
    ReturnIfError(GBusChange(bd_addr,GBUS_VACTL, 0xe0000000, 0x40000000));
	for (i=0;i<Words;i++)
	{
        ReturnIfError(GBusChange(bd_addr,GBUS_VACTL, 0x1fc00000, Dest++ << 22));
        ReturnIfError(GBusWrite(bd_addr,GBUS_VADATA, *SrcPtr++));
	}
    ReturnIfError(GBusWrite(bd_addr,GBUS_VACTL, vactl_save));
	return 0;
}

ECODE FifoBRead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i;
    DWORD vbctl_save;
	ReturnIfError(GBusRead(bd_addr,GBUS_VBCTL, &vbctl_save));
    ReturnIfError(GBusChange(bd_addr,GBUS_VBCTL, 0xe0000008, 0x40000000));
	for (i=0;i<Words;i++)
	{
        ReturnIfError(GBusChange(bd_addr,GBUS_VBCTL, 0x1fc00000, Source++ << 22));
        ReturnIfError(GBusRead(bd_addr,GBUS_VBDATA, DestPtr++));
	}
    ReturnIfError(GBusWrite(bd_addr,GBUS_VBCTL, vbctl_save));
	return 0;
}


ECODE FifoBWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i;
    DWORD vbctl_save;
	ReturnIfError(GBusRead(bd_addr,GBUS_VBCTL, &vbctl_save));
    ReturnIfError(GBusChange(bd_addr,GBUS_VBCTL, 0xe0000008, 0x40000000));
	for (i=0;i<Words;i++)
	{
        ReturnIfError(GBusChange(bd_addr,GBUS_VBCTL, 0x1fc00000, Dest++ << 22));
        ReturnIfError(GBusWrite(bd_addr,GBUS_VBDATA, *SrcPtr++));
	}
    ReturnIfError(GBusWrite(bd_addr,GBUS_VBCTL, vbctl_save));
	return 0;
}

ECODE ImemRead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i;
	for (i=0;i<Words;i++)
	{
		imemRead(bd_addr, Source ,DestPtr++); 
		Source+=4;
	}
	return 0;
}

ECODE ImemWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
 {
	DWORD i;
	/* write address to imem ctrl reg */
	/* Set Hctl for write */

	ReturnIfError(GBusChange(bd_addr, GBUS_HCTL,1<<9,0 ));
	ReturnIfError(GBusWrite(bd_addr, GBUS_IMEMCTL, Dest & 0x000003ff));

	for (i=0;i<Words;i++)
	{

	/* write data */
		ReturnIfError(GBusWrite(bd_addr, GBUS_IMEMDATA, *SrcPtr++));
	}
	return 0;
}

ECODE SmemRead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i;
	uwide *dp=(uwide*)DestPtr;
	for (i=0;i<Words>>1;i++)
	{
		smemRead(bd_addr, Source,dp++);
		Source+=4;
	}
	return 0;
}

ECODE SmemWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i;
	uwide *sp=(uwide*)SrcPtr;
	for (i=0;i<Words>>1;i++)
	{
		smemWrite(bd_addr,Dest,sp++); 
		Dest+=4;
	}
	return 0;
}

ECODE RmemRead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words)
{
	DWORD i;
	uwide *dp=(uwide*)DestPtr;
	for (i=0;i<Words>>1;i++)
	{
		rmemRead(bd_addr, Source,dp++);
		Source+=4;
	}
	return 0;
}

ECODE RmemWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words)
{
	DWORD i;
	uwide *sp=(uwide*)SrcPtr;
	for (i=0;i<Words>>1;i++)
	{
		rmemWrite(bd_addr,Dest,sp++); 
		Dest+=4;
	}
	return 0;
}

													 

/***********************************************************************
 *
 * write a value into Imem.
 *
 ***********************************************************************/
void imemWrite(bd_addr, adr, data)
PREGS bd_addr;
ulong adr;
ulong data;
{
	/* write address to imem ctrl reg */
	GBusWrite(bd_addr, GBUS_IMEMCTL, adr & 0x000003ff);

	/* write data */
	GBusWrite(bd_addr, GBUS_IMEMDATA, data);
}


 /***********************************************************************
 *
 * Read a value from Imem
 *
 ***********************************************************************
 */
void imemRead(bd_addr, adr, data)
PREGS bd_addr;
ulong adr;
ulong *data;
{

        /* set up the IMEM to read mode */
	GBusChange(bd_addr, GBUS_HCTL, 0x600, 0x200);
	GBusChange(bd_addr, GBUS_HCTL, 0x600, 0x600);

	/* write address to imem ctrl reg */
	if (adr &0x1)
	   GBusWrite(bd_addr, GBUS_IMEMCTL, (0xa0000000 | adr));
        else
           GBusWrite(bd_addr, GBUS_IMEMCTL, (0xc0000000 | adr));
	
	/* read data fromt DIR reg */
	GBusRead(bd_addr, GBUS_DIR, data);
}

/***********************************************************************
 *
 * fill Imem with zeros.
 *
 ***********************************************************************/
void imemClear(bd_addr)
PREGS bd_addr;
{
	unsigned long imemwadr;
	int	adr;

	/* set imem adr pointer to 0 */
	GBusRead(bd_addr, GBUS_IMEMCTL, &imemwadr);
	imemwadr &= 0x3ff;
	GBusWrite(bd_addr, GBUS_IMEMCTL, 0);

	for(adr=0 ; adr<1024 ; adr++){
		/* loop thru all imem addresses */
		GBusWrite(bd_addr, GBUS_IMEMDATA, 0);
	}

	GBusWrite(bd_addr, GBUS_IMEMCTL, imemwadr);

}



/***********************************************************************
 *
 * read a value from the register file.
 *
 ***********************************************************************/
void rmemRead(PREGS bd_addr, ulong adr, uwide *data)
{
    ulong lsl;
    ulong msl;

    	if (adr >= 24) {
        	GBusWrite(bd_addr, GBUS_DIR, 0x000009C0); /* PQclr */
        	CpuSingleStep(bd_addr, 1, 0x60000000);
    	}   
        GBusWrite(bd_addr, GBUS_DIR, 0x02008000 | ((adr & 0x1f) << 26));
        GBusRead(bd_addr, GBUS_ISWRITE, &lsl);
        GBusRead(bd_addr, GBUS_GUARD_BIT, &msl);
        data->loword = lsl;
	data->hiword = msl;
}

/***********************************************************************
 *
 * write a value into the register file - DOES NOT RESTORE OR SAVE PC.
 *
 ***********************************************************************/
void rmemWrite(bd_addr, adr, data)
PREGS bd_addr;
ulong adr;
uwide *data;
{
    ulong	temp;

    if (adr >= 24) {
        GBusWrite(bd_addr, GBUS_DIR, 0x000009C0); /* PQclr */
        CpuSingleStep(bd_addr, 1, 0x60000000);
    }   

    temp = data->hiword;
    GBusChange(bd_addr, GBUS_GUARD_BIT, 0x0000000f, temp);
    temp = data->loword;
    GBusWrite(bd_addr, GBUS_ISWRITE, temp);

    temp = 0x020093c0 | (adr & 0x1f);
    GBusWrite(bd_addr, GBUS_DIR, temp);
    CpuSingleStep(bd_addr, 1, 0x60000000);

}

/***********************************************************************
 *
 * zero out all values in RMEM
 *
 ***********************************************************************/
void rmemClear(bd_addr)
PREGS bd_addr;
{
    uwide       temp;
    ulong       i;

    temp.loword = 0; temp.hiword = 0;

    for(i = 0; i < 32; i++) {
      rmemWrite(bd_addr, i, &temp);
      CpuWritePC(bd_addr, 0, 0, 0);
    }

}


/***********************************************************************
 *
 * write a value into Smem
 *
 ***********************************************************************/
void smemWrite(bd_addr, addr, data)
PREGS bd_addr;
ulong addr;
uwide *data;
{
    uwide rmem_save[2];
    uwide temp[2];

    rmemRead(bd_addr, 1, &rmem_save[0]);
    rmemRead(bd_addr, 2, &rmem_save[1]);
 
    temp[0].loword = (ulong)(0xc00000 | ((addr << 2) & 0xffc));
    temp[0].hiword = (ulong) 0;

    rmemWrite(bd_addr, 1, &temp[0]);
    CpuWritePC(bd_addr, 0, 0, 0);
    rmemWrite(bd_addr, 2, data);
    CpuWritePC(bd_addr, 0, 0, 0);
    GBusWrite(bd_addr, GBUS_DIR, 0x0ac14000); /* store (r2,r1,0) */
    CpuSingleStep(bd_addr, 1, 0x60000000);
    CpuWritePC(bd_addr, 0, 0, 0);
    rmemWrite(bd_addr, 1, &rmem_save[0]);
    CpuWritePC(bd_addr, 0, 0, 0);
    rmemWrite(bd_addr, 2, &rmem_save[1]);
    CpuWritePC(bd_addr, 0, 0, 0);
 }
					  
/***********************************************************************
 *
 * read a value into Smem
 *
 ***********************************************************************/
void smemRead(bd_addr, addr, data)
PREGS bd_addr;
ulong addr;
uwide *data;
{
   uwide rmem_save[2];
   uwide temp;

   rmemRead(bd_addr, 1, &rmem_save[0]);
   rmemRead(bd_addr, 2, &rmem_save[1]);

   temp.loword = (ulong)(0xc00000 | ((addr << 2) & 0xffc));
   temp.hiword = 0;
   rmemWrite(bd_addr, 1, &temp);
   CpuWritePC(bd_addr, 0, 0, 0);
   GBusWrite(bd_addr, GBUS_DIR, 0x0bc14000); /* load (0,r1,r2) */
   CpuSingleStep(bd_addr, 1, 0x60000000);
   CpuWritePC(bd_addr, 0, 0, 0);
   rmemRead(bd_addr, 2, data);
   CpuWritePC(bd_addr, 0, 0, 0);
   rmemWrite(bd_addr, 1, &rmem_save[0]);
   CpuWritePC(bd_addr, 0, 0, 0);
   rmemWrite(bd_addr, 2, &rmem_save[1]);
   CpuWritePC(bd_addr, 0, 0, 0);

}

/***********************************************************************
 *
 * zero out all values in SMEM
 *
 ***********************************************************************/
void smemClear(bd_addr)
PREGS bd_addr;
{
    uwide	temp;
    ulong	i;

    temp.loword = 0; temp.hiword = 0;
    for(i = 0; i < 1024; i++)
      smemWrite(bd_addr, i, &temp);
}

/***********************************************************************
 *
 * execute a single-step on a chip.
 *
 ***********************************************************************/
// it seems that c-cube is currently defining this value ???
#define STORE_SINGLE_STEP_BUG

#ifdef STORE_SINGLE_STEP_BUG

#define MASK(hi, lo) ( \
        (((ulong)0xffffffff) << \
            (32 - ((hi) - (lo) + 1)) \
        ) >> (31 - (hi)) \
    )
#define BITS(r, hi, lo) ((r) & MASK((hi), (lo)))
#define BIT(r, x) ((r) & MASK((x), (x)))
#define OPCODE5(ir) (BITS((ir), 25, 21) >> 21)
#define OPCODE7_5(ir) (OPCODE5(ir) << 2)
#define IS_STORE(ir) ((OPCODE7_5(ir) == 0x58) && BIT((ir), 14))

#endif /* STORE_SINGLE_STEP_BUG */


void CpuSingleStep(bd_addr, count, command)
PREGS bd_addr;
ulong count;
ulong command;
{
	unsigned long imemctl;
#ifdef STORE_SINGLE_STEP_BUG
	unsigned long dir;
	unsigned long dir_save;
#endif /* STORE_SINGLE_STEP_BUG */

#ifdef STORE_SINGLE_STEP_BUG
	GBusRead(bd_addr, GBUS_DIR, &dir_save);
#endif /* STORE_SINGLE_STEP_BUG */

	while (count--) {
		GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, command);

#ifdef STORE_SINGLE_STEP_BUG
		GBusRead(bd_addr, GBUS_DIR, &dir);
		if (dir == dir_save) {
			if (IS_STORE(dir)) {
				GBusWrite(bd_addr, GBUS_DIR, 0x00000000); /* noop */
				GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, 0x60000000);
			}

		} else {
			dir_save = dir;
		}
#endif /* STORE_SINGLE_STEP_BUG */

		/*
         * If the SKIP bit is 1, we must single-step again to finish
         * executing the instruction
         */
		GBusRead(bd_addr, GBUS_IMEMCTL, &imemctl);
		if (imemctl & 0x40000000) {
			GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, 0x60000000);
		}
	}
}

/***********************************************************************
 *
 * write a value to the PC.
 *
 ***********************************************************************/
void CpuWritePC(bd_addr,  pc0, pc1, odd)
PREGS bd_addr;
ulong pc0;
ulong pc1;
ulong odd;
{
	unsigned long hctl_save;

	GBusRead(bd_addr, GBUS_HCTL, &hctl_save);

	GBusChange(bd_addr, GBUS_HCTL, 0xf0000200, 0x50000200);
	GBusWrite(bd_addr, GBUS_IMEMCTL, 0x20000000 | (pc1 & 0x3ff));
	GBusWrite(bd_addr, GBUS_IMEMCTL, 0x80000000 | (pc0 & 0x3ff) | ((odd & 0x1) << 30));

	GBusWrite(bd_addr, GBUS_HCTL, hctl_save);
}

/***********************************************************************
 *
 * reset a chip (not the whole board).
 *
 ***********************************************************************/
void reset(bd_addr)
PREGS bd_addr;
{
  static ulong Zeros[32];  /* will be initialized to 0 */
  
  /* halt */
  GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, 0x50000000);
  
  /* Disable all interrupts */
  WBusWrite(bd_addr, WBUS_INTCTL, 0xfffefffe);
  
  /* Set interleaved mode and refresh cycle and enable refresh timer */
    GBusWrite(bd_addr, GBUS_DMAMODE, VIDTOOL_MEMCONFIG);
	// original code
	//  GBusWrite(bd_addr, GBUS_DMAMODE, 0xc900003c | DMA_MODE_9_CHP);
  
  WBusWrite(bd_addr, WBUS_INTCTL, 0x00010001);
  
  /* Reset multiplier */
  WBusWrite(bd_addr, WBUS_MULCTL, 0x00000000);
  
  /* Reset and halt VLC */
  GBusWrite(bd_addr, GBUS_VLCCTL, 0x00000000);
  GBusWrite(bd_addr, GBUS_VLCCTL, 0x40000000);
  GBusWrite(bd_addr, GBUS_VLCSTART, 0x00000000);
  
  /* Reset and halt ME */
  GBusWrite(bd_addr, GBUS_MEMEMCTL, 0x00000000);
  GBusWrite(bd_addr, GBUS_MEMEMCTL, 0x40000000);
  
  /* Reset and halt CPU */
  WBusWrite(bd_addr, WBUS_CPUCTL, 0x40000000);
  
  /* Reset and halt video A and B */
  GBusWrite(bd_addr, GBUS_VACTL, 0x00000000);
  GBusWrite(bd_addr, GBUS_VACTL, 0x40000000);
  GBusWrite(bd_addr, GBUS_VBCTL, 0x00000000);
  GBusWrite(bd_addr, GBUS_VBCTL, 0x40000000);
  
  /* Clear guard bit */
  GBusWrite(bd_addr, GBUS_GUARD_BIT, 0x00000000);
  
  /* Reset all, halt all and host bus, single-step twice */
  GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, 0xc0000000);
  GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, 0x50000000);
  CpuSingleStep(bd_addr, 2, 0x60000000);
  
  /* Clear pc0, pc1, odd, dir */
  CpuWritePC(bd_addr, 0, 0, 0);
  
  imemClear(bd_addr);
  
#if 0 /* this has been part of the clm4500 reset */
  rmemClear(bd_addr);
  
  GBusWrite(bd_addr,GBUS_DIR, 0x000008C0);
  CpuSingleStep(bd_addr,1, 0x60000000);
  GBusWrite(bd_addr,GBUS_DIR, 0x00000000);
  CpuSingleStep(bd_addr,1, 0x60000000);
  GBusWrite(bd_addr,GBUS_DIR, 0x00000000);
  CpuSingleStep(bd_addr,1, 0x60000000);
#endif
}


/***********************************************************************
 *
 * resume chip operation after a halt.
 *
 ***********************************************************************/
void cpu_resume(bd_addr)
PREGS bd_addr;
{
    GBusWrite(bd_addr,GBUS_DIR, 0x00000000);
    CpuSingleStep(bd_addr,1, 0x60000000);
 
    GBusWrite(bd_addr,GBUS_DIR, 0x00000000);
    CpuSingleStep(bd_addr,1, 0x60000000);
 
    GBusWrite(bd_addr,GBUS_DIR, 0x000008C0);
    CpuSingleStep(bd_addr,1, 0x60000000);
}
 

/***********************************************************************
 *
 *  this function causes the chip to run N cycles (inaccurate) before
 * the host bus is used to turn it off.  Note that this function does
 * not restore the chip adequately to be used many times in succession.
 * Since we know that the chip is to be reset after this function is
 * called, this is fine for the loader. 
 *
 ***********************************************************************/
#if 0
ulong CyclesToMicroSeconds(ulong count)
{
	return count/60;
}


void run_cycles(bd_addr, count)
PREGS bd_addr;
ulong count;
{
    ulong useconds;
 
    useconds = CyclesToMicroSeconds(count);
 
    /* turn the chip on */
    GBusChange(bd_addr,GBUS_HCTL, 0xf0000000, 0xf0000000);

    /* go to sleep for awhile while the chip crunches.... */
    Sleep(useconds/1000+1);

    /* time to turn it off! */
    GBusChange(bd_addr,GBUS_HCTL, 0xf0000000, 0x50000000);
}
#endif
/***********************************************************************
 *
 * set a breakpoint at addr.
 *
 ***********************************************************************/
#define MAKE_BRK_INST(addr) (0x41E00000 | ((addr) & 0x1f) | (((addr) & 0x3e0) << 11))


void stop_at(bd_addr, addr)
PREGS bd_addr;
ulong addr;
{
	imemWrite(bd_addr, addr, MAKE_BRK_INST(addr));
	imemWrite(bd_addr, 0x3c, 0x80000700);
	imemWrite(bd_addr, 0x3d, 0x00000000);
	imemWrite(bd_addr, 0x3e, 0x00000000);
	imemWrite(bd_addr, 0x3f, 0x00000000);
}

/***************************************************************************
 * 
 *   run the chip for a number of instructions (use single step for 
 *   accuracy.
 *
 ***************************************************************************/

void run_inst(bd_addr, count)
PREGS bd_addr;
ulong count;
 {
    ulong imemctl;
#ifdef STORE_SINGLE_STEP_BUG
    ulong dir;
    ulong dir_save;
#endif /* STORE_SINGLE_STEP_BUG */

#ifdef STORE_SINGLE_STEP_BUG
    GBusRead(bd_addr, GBUS_DIR, &dir_save);
#endif /* STORE_SINGLE_STEP_BUG */
    while (count--) {
        GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, stepCmd);
#ifdef STORE_SINGLE_STEP_BUG
        GBusRead(bd_addr, GBUS_DIR, &dir);
        if (dir == dir_save) {
            if (OPCODE7_5(dir) == 0x58) { /* store() only */
                GBusWrite(bd_addr, GBUS_DIR, 0x00000000); /* noop */
                GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, 0x60000000);
            }
        } else {
            dir_save = dir;
        }
#endif /* STORE_SINGLE_STEP_BUG */
 
        /*
         * If the SKIP bit is 1, we must single-step again to finish
         * executing the instruction
         */
        GBusRead(bd_addr, GBUS_IMEMCTL, &imemctl);
        if (imemctl & 0x40000000) {
            GBusChange(bd_addr, GBUS_HCTL, 0xf0000000, 0x60000000);
        }
    }

}

ECODE VT_WritePortA(DEVID dwDevice, const DWORD *SrcPtr, DWORD Words)
{
    PREGS bd_addr=GET_STRUCT_PTR(dwDevice);
	DWORD i;
	int timeout;
	ReturnIfError(CrPoke(bd_addr,CTRL2,FIFO_MODE_RECODE));
	for (i=0;i<Words;i++)
	{
		bd_addr->PortAIn=*SrcPtr++;
		timeout=0;
		while (bd_addr->Csr & PORTA_FLAG) 
		   if (timeout++>IREG_WRITE_TIMEOUT) return i;
	}
	return 0;
	
}

ECODE VT_ReadPortB(DEVID dwDevice, DWORD *DestPtr, DWORD Words)
{
    PREGS bd_addr=GET_STRUCT_PTR(dwDevice);
	DWORD i,timeout;
	if (!(bd_addr->Csr & FIFO_EMPTYN)) return VT_ERR_FIFO_EMPTY;

	//ReturnIfError(CrPoke(bd_addr,CTRL2,FIFO_MODE_RECODE));
	for (i=0;i<Words;i++)
	{
		timeout=0;
		while (!(bd_addr->Csr & FIFO_EMPTYN)) 
		   if (timeout++>IREG_WRITE_TIMEOUT) return i;
		*DestPtr++=bd_addr->FifoData;
	}
}

ECODE VT_SetupFifo(DEVID dwDevice,DWORD aEmpty,DWORD aFull)
{
	PREGS bd_addr=GET_STRUCT_PTR(dwDevice);
	int ctl2=0;
	int i;
#define WRITE_TWICE(__val) for (i=0;i<2;i++) ReturnIfError(CrPoke(bd_addr,CTRL2,__val))
#define CLOCK_FIFO_WR  ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_WR,FIFO_WR));ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_WR,0))
	ctl2=FIFO_MODE_PROGRAM|FIFO_LD;
	WRITE_TWICE(ctl2);
	WRITE_TWICE(ctl2|FIFO_RESET);
	WRITE_TWICE(ctl2);

	ReturnIfError(CrPoke(bd_addr,FIFO_DATA,aEmpty));
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL,FIFO_DATAH_SEL));
	ReturnIfError(CrPoke(bd_addr,FIFO_DATA,aEmpty>>8));
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL,0));
	CLOCK_FIFO_WR;
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL,FIFO_DATAH_SEL));
	CLOCK_FIFO_WR;
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL,0));

	ReturnIfError(CrPoke(bd_addr,FIFO_DATA,aFull));
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL,FIFO_DATAH_SEL));
	ReturnIfError(CrPoke(bd_addr,FIFO_DATA,aFull>>8));
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL,0));
	CLOCK_FIFO_WR;
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL,FIFO_DATAH_SEL));
	CLOCK_FIFO_WR;
	ReturnIfError(CrChange(bd_addr,CTRL2,FIFO_DATAH_SEL | FIFO_LD,0));
}

