// captures.cpp : implementation file
//

#include "stdafx.h"
#include "bwdialog.h"

#include "captures.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

extern HWND AFXAPI AfxGetSafeOwner(CWnd* pParent, HWND* phTopLevel = NULL);

/////////////////////////////////////////////////////////////////////////////
// CCaptureSheet

IMPLEMENT_DYNAMIC(CCaptureSheet, CPropertySheet)

//xxxxx I added this to change the style
static BOOL AFXAPI ChangeStyle(HWND hWnd, int nStyleOffset,
	DWORD dwRemove, DWORD dwAdd, UINT nFlags)
{
	ASSERT(hWnd != NULL);
	DWORD dwStyle = ::GetWindowLong(hWnd, nStyleOffset);
	DWORD dwNewStyle = (dwStyle & ~dwRemove) | dwAdd;
	if (dwStyle == dwNewStyle)
		return FALSE;

	::SetWindowLong(hWnd, nStyleOffset, dwNewStyle);
	if (nFlags != 0)
	{
		::SetWindowPos(hWnd, NULL, 0, 0, 0, 0,
			SWP_NOSIZE | SWP_NOMOVE | SWP_NOZORDER | SWP_NOACTIVATE | nFlags);
	}
	return TRUE;
}

BOOL CCaptureSheet::Create(CWnd* pParent, DWORD dwStyle, DWORD dwExStyle)
{
dwExStyle |= WS_EX_CONTEXTHELP;

	return CreateEx(dwExStyle,
		AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_SAVEBITS,
		LoadCursor(NULL, IDC_ARROW), (HBRUSH)(COLOR_BTNFACE+1)),
		m_strCaption, dwStyle, CW_USEDEFAULT, CW_USEDEFAULT, 400, 200,
		pParent->GetSafeHwnd(), NULL);
}

CCaptureSheet::CCaptureSheet(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
}

CCaptureSheet::CCaptureSheet(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_psh.dwFlags |= PSH_HASHELP;
}

CCaptureSheet::~CCaptureSheet()
{
}


BEGIN_MESSAGE_MAP(CCaptureSheet, CPropertySheet)
	//{{AFX_MSG_MAP(CCaptureSheet)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CCaptureSheet message handlers


int CCaptureSheet::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
lpCreateStruct->dwExStyle |= WS_EX_CONTEXTHELP;

	if (CPropertySheet::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	CWnd *pWnd = (CWnd *)this;

	//xxxxx I added this to change the style
	ChangeStyle(pWnd->m_hWnd, GWL_EXSTYLE, 0, WS_EX_CONTEXTHELP, 0);

	// TODO: Add your specialized creation code here
	
	return 0;
}



void CCaptureSheet::EnablePage (int nPage, BOOL bEnable)
{
    // if we want to enable the page
    if (bEnable)
    {
        // remove the index from the map
        m_DisabledPages.RemoveKey (nPage);
        // take out " - Disabled" from tab label
        CTabCtrl* pTab = GetTabControl();
        ASSERT (pTab);
        TC_ITEM ti;
        char szText[100];
        ti.mask = TCIF_TEXT;
        ti.pszText = szText;
        ti.cchTextMax = 100;
        VERIFY (pTab->GetItem (nPage, &ti));
        char * pFound = strstr (szText, " - Disabled");
        if (pFound)
        {
			*pFound = '\0';
            VERIFY (pTab->SetItem (nPage, &ti));
        }
	}
    // if we want to disable it
    else
    {
        // add the index to the map
        m_DisabledPages.SetAt (nPage, nPage);
        // add " - Disabled" to tab label
        CTabCtrl* pTab = GetTabControl();
        ASSERT (pTab);
        TC_ITEM ti;
        char szText[100];
        ti.mask = TCIF_TEXT;
        ti.pszText = szText;
        ti.cchTextMax = 100;
        VERIFY (pTab->GetItem (nPage, &ti));
        strcat (szText, " - Disabled");
        VERIFY (pTab->SetItem (nPage, &ti));
    }
}

BOOL CCaptureSheet::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
    NMHDR* pnmh = (NMHDR*)lParam;
    // tab is about to change
    if (TCN_SELCHANGING == pnmh->code)
        // save the current page index
        m_nLastActive = GetActiveIndex ();
	// tab has been changed
	else if (TCN_SELCHANGE == pnmh->code)
    {
        // get the current page index
        int nCurrentPage = GetActiveIndex ();
        // if current page is in our map of disabled pages
        if (m_DisabledPages.Lookup (nCurrentPage, nCurrentPage))
        // activate the previous page
        PostMessage (PSM_SETCURSEL, m_nLastActive);
    }
    return CPropertySheet::OnNotify(wParam, lParam, pResult);
}
