//captaud.cpp : implementation file
//

#include "stdafx.h"
#include "bwdialog.h"
#include "captaud.h"

#include "afxpriv.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

const unsigned int	CCaptureAudio::m_kNUM_HEADERS = 5;
const unsigned int	CCaptureAudio::m_kTimerPEAK	  = 0;
const unsigned int	CCaptureAudio::m_kTimerVOLUME = 1;
const unsigned int	CCaptureAudio::m_kTimerPEAKINTERVAL   = 10;
const unsigned int	CCaptureAudio::m_kTimerVOLUMEINTERVAL = 10;

/////////////////////////////////////////////////////////////////////////////
//CCaptureAudio property page

IMPLEMENT_DYNCREATE(CCaptureAudio, CPropertyPage)

void CCaptureAudio::SetModified(BOOL bChanged)
{
	m_bChanged = bChanged;  
	CPropertyPage::SetModified( bChanged );
}

CCaptureAudio::CCaptureAudio() : CPropertyPage(CCaptureAudio::IDD)
{
	//{{AFX_DATA_INIT(CCaptureAudio)
	//}}AFX_DATA_INIT
	m_psp.dwFlags |= PSP_HASHELP;
	m_bChanged = FALSE;
	m_waveHdr = NULL;
	m_hWave = NULL;
	m_HelpDisplayed = FALSE;
}

CCaptureAudio::~CCaptureAudio()
{
}

void CCaptureAudio::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCaptureAudio)
	DDX_Control(pDX, IDC_SHOWHELP, m_chkShowHelp);
	DDX_Control(pDX, IDC_MIXER, m_Mixer);
	DDX_Control(pDX, IDC_AUDIO_POWER, m_Power);
	DDX_Control(pDX, IDC_AUDIO_VOLUME, m_Volume);
	DDX_Control(pDX, IDC_AUDIO_ENABLE, m_EnableAudio);
	DDX_Control(pDX, IDC_AUDIO_DEFAULTS, m_Defaults);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCaptureAudio, CPropertyPage)
	//{{AFX_MSG_MAP(CCaptureAudio)
	ON_BN_CLICKED(IDC_AUDIO_DEFAULTS, OnDefaults)
	ON_BN_CLICKED(IDC_AUDIO_11KHZ, On11khz)
	ON_BN_CLICKED(IDC_AUDIO_22KHZ, On22khz)
	ON_BN_CLICKED(IDC_AUDIO_44KHZ, On44khz)
	ON_BN_CLICKED(IDC_AUDIO_STEREO, OnMono)
	ON_BN_CLICKED(IDC_AUDIO_MONO, OnStereo)
	ON_BN_CLICKED(IDC_AUDIO_ENABLE, OnAudioEnable)
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_MIXER, OnMixer)
	ON_BN_CLICKED(IDC_SHOWHELP, OnShowhelp)
	//}}AFX_MSG_MAP
    ON_MESSAGE( WM_COMMANDHELP, OnCommandHelp )
END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////
//CCaptureAudio message handlers
BOOL CCaptureAudio::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

    CWnd* pWnd = GetDlgItem (ID_HELP);
    if (pWnd) {
		pWnd->ShowWindow(TRUE);
	}

	//Setup Volume
	m_Volume.SetRange(0,65535,TRUE);
	m_Volume.SetTicFreq(8192);

	int nVolume = AudioLevel.RecordingVolume();
	m_Volume.SetPos(65535-nVolume);

	if (AudioLevel.RecordingVolume(nVolume) != CAudioLevelSTATUSOK) {
		m_Volume.EnableWindow(FALSE);
	}
	
	SetTimer(m_kTimerPEAK, m_kTimerPEAKINTERVAL, NULL);
	SetTimer(m_kTimerVOLUME, m_kTimerVOLUMEINTERVAL, NULL);
	
	//Setup Power Meter
	m_Range = 0;
	m_Power.SetBitmap(IDB_POWER0 + m_Range);
	m_bIsRecording = BeginRecording ();

	m_nIsMpeg = pApp->m_Settings.CaptureMode() == CAPMODE_IFRAME ?FALSE:TRUE;
	pWnd = GetDlgItem( IDC_AUDIO_NOTE_STATIC );
	pWnd->ShowWindow( m_nIsMpeg);

	if (m_nIsMpeg) {

		WINDOWPLACEMENT wp, wpg1, wpg2;

		m_EnableAudio.ShowWindow (FALSE);
		
		pWnd = GetDlgItem( IDC_AUDIO_STEREO );
		pWnd->ShowWindow(FALSE);
		pWnd = GetDlgItem( IDC_AUDIO_MONO );
		pWnd->ShowWindow(FALSE);
		pWnd = GetDlgItem( IDC_AUDIO_CHANNEL_STATIC );
		pWnd->ShowWindow(FALSE);

		wp.length = wpg1.length = wpg2.length = sizeof(WINDOWPLACEMENT); 
		pWnd = GetDlgItem( IDC_AUDIO_FORMAT_STATIC );
		pWnd->GetWindowPlacement (&wpg1);
		pWnd->CenterWindow();
		pWnd->GetWindowPlacement (&wpg2);
		wpg2.rcNormalPosition.top = wpg1.rcNormalPosition.top;
		wpg2.rcNormalPosition.bottom = wpg1.rcNormalPosition.bottom;
		pWnd->SetWindowPlacement (&wpg2);

		pWnd = GetDlgItem( IDC_AUDIO_44KHZ );
		pWnd->GetWindowPlacement (&wp);
		wp.rcNormalPosition.left += wpg2.rcNormalPosition.left - wpg1.rcNormalPosition.left;
		wp.rcNormalPosition.right += wpg2.rcNormalPosition.left - wpg1.rcNormalPosition.left ;
		pWnd->SetWindowPlacement (&wp);

		pWnd = GetDlgItem( IDC_AUDIO_22KHZ );
		pWnd->GetWindowPlacement (&wp);
		wp.rcNormalPosition.left += wpg2.rcNormalPosition.left - wpg1.rcNormalPosition.left;
		wp.rcNormalPosition.right += wpg2.rcNormalPosition.left - wpg1.rcNormalPosition.left ;
		pWnd->SetWindowPlacement (&wp);

		pWnd = GetDlgItem( IDC_AUDIO_11KHZ );
		pWnd->GetWindowPlacement (&wp);
		wp.rcNormalPosition.left += wpg2.rcNormalPosition.left - wpg1.rcNormalPosition.left;
		wp.rcNormalPosition.right += wpg2.rcNormalPosition.left - wpg1.rcNormalPosition.left ;
		pWnd->SetWindowPlacement (&wp);
	}


	UINT nAudioEnable = pApp->m_Settings.AudioEnable();
	SetAudioEnable (nAudioEnable);

	UINT nAudioMode = pApp->m_Settings.AudioMode();
	SetAudioMode (nAudioMode);

	UINT nAudioRate = pApp->m_Settings.AudioRate();
	SetAudioRate(nAudioRate);

    //the settings may change based on the sound card capabilities 
	m_nAudioEnable = GetAudioEnable();
	m_nAudioMode = GetAudioMode();
	m_nAudioRate = GetAudioRate();

	//to show or not to show help
	m_chkShowHelp.SetCheck(pApp->m_Settings.ShowVolumeHelp());

	return TRUE;  //return TRUE unless you set the focus to a control
	              //EXCEPTION: OCX Property Pages should return FALSE
}


BOOL CCaptureAudio::BeginRecording ()
{
	//verify we have a wave in device 
	if (waveInGetNumDevs() == 0) {
        return FALSE;
    }

	UINT nChannels = GetAudioMode() == AUDIO_MONO ?1:2;
	UINT nSamplesPerSec = GetAudioRate(); 
	UINT wBitsPerSample = 16; 

    //set up the requested audio mode 
    m_Format.wFormatTag      = WAVE_FORMAT_PCM;        
    m_Format.nChannels       = nChannels;         
    m_Format.wBitsPerSample  = wBitsPerSample;    
    m_Format.nSamplesPerSec  = nSamplesPerSec;   
    m_Format.nBlockAlign     = (m_Format.nChannels * m_Format.wBitsPerSample) / 8;      
    m_Format.nAvgBytesPerSec = m_Format.nSamplesPerSec * m_Format.nBlockAlign;  
    m_Format.cbSize          = 0;            

	//allocate memory for the wave headers 
    m_waveHdr = new WAVEHDR[m_kNUM_HEADERS];
	if (m_waveHdr == NULL) {
		return FALSE;
	}

	//init the wave headers 
	int Index;
	memset (m_waveHdr, 0, sizeof(WAVEHDR)*m_kNUM_HEADERS);

	for (Index=0;Index<m_kNUM_HEADERS;Index++) {
		m_waveHdr[Index].lpData		   = NULL;
		m_waveHdr[Index].dwBufferLength  = m_Format.nAvgBytesPerSec/10;
		m_waveHdr[Index].dwBytesRecorded = 0;
		m_waveHdr[Index].dwUser          = 0;
		m_waveHdr[Index].dwFlags         = 0;
		m_waveHdr[Index].dwLoops         = 0;
		m_waveHdr[Index].lpNext          = 0;
		m_waveHdr[Index].reserved        = 0;
	}
					 
	//open the wave input device 
    if (waveInOpen(&m_hWave, WAVE_MAPPER, &m_Format, (DWORD)m_hWnd, (DWORD)this, CALLBACK_WINDOW) != 0) {
        return FALSE;
    }

    //allocate the wave buffers 
	for (Index=0;Index<m_kNUM_HEADERS;Index++) {
		m_waveHdr[Index].lpData = new char[m_waveHdr[Index].dwBufferLength];
		if (m_waveHdr[Index].lpData == NULL) {
			EndRecording();
			return FALSE;
		}
	}

    //prepare the headers 
	for (Index=0;Index<m_kNUM_HEADERS;Index++) {
		if (waveInPrepareHeader (m_hWave, &m_waveHdr[Index], sizeof(WAVEHDR)) != 0) {
			EndRecording();
			return FALSE;
		}
    }

	//reset to remove any buffers from the queue 
	waveInReset (m_hWave);

	//add the buffers 
	for (Index=0;Index<m_kNUM_HEADERS;Index++) {
		if (waveInAddBuffer (m_hWave, &m_waveHdr[Index], sizeof(WAVEHDR)) != 0) {
			EndRecording();
			return FALSE;
		}
	}

	//Start it up 
	if (waveInStart (m_hWave) != 0) {
		EndRecording();
		return FALSE;
	}

	return TRUE;
}


BOOL CCaptureAudio::EndRecording ()
{
	m_bIsRecording = FALSE;
	
	//reset to remove all buffers from the queue 
	if (m_hWave != NULL) {
	
		waveInReset (m_hWave);

		if (m_waveHdr != NULL) {
	
			//unprepare and free the wave buffers 
			int Index;
			for (Index=0;Index<m_kNUM_HEADERS;Index++) {
			
				if (m_waveHdr[Index].lpData != NULL) {		
			
					if (m_waveHdr[Index].dwFlags & WHDR_PREPARED)	{
						waveInUnprepareHeader (m_hWave, &m_waveHdr[Index], sizeof(WAVEHDR));                      
					}

					delete m_waveHdr[Index].lpData;
				}
			}
		
		delete m_waveHdr;
		}
	
		//close up the device 
		waveInClose (m_hWave);
		
		m_hWave = NULL;
		m_waveHdr = NULL;
	}

	return TRUE;
}

void CCaptureAudio::SetAudioEnable ( BOOL bEnable ) 
{

	m_EnableAudio.SetCheck (bEnable);

	CWnd *pWnd = GetDlgItem( IDC_AUDIO_STEREO );
	pWnd->EnableWindow(bEnable);
	pWnd = GetDlgItem( IDC_AUDIO_MONO );
	pWnd->EnableWindow(bEnable);
	pWnd = GetDlgItem( IDC_AUDIO_CHANNEL_STATIC );

	if (m_nIsMpeg) {
		return;
	}

	pWnd = GetDlgItem( IDC_AUDIO_11KHZ );
	pWnd->EnableWindow( bEnable);
	pWnd = GetDlgItem( IDC_AUDIO_22KHZ );
	pWnd->EnableWindow( bEnable);
	pWnd = GetDlgItem( IDC_AUDIO_44KHZ );
	pWnd->EnableWindow( bEnable);
}
			

UINT CCaptureAudio::GetAudioEnable()
{
	if (m_EnableAudio.GetCheck( ) ) {
		return( 1 );
	}

	return( 0 );
}

UINT CCaptureAudio::GetAudioMode() 
{
	UINT nChecked = GetCheckedRadioButton( IDC_AUDIO_STEREO, IDC_AUDIO_MONO);
	UINT nValue;

	switch (nChecked)
	{
		case IDC_AUDIO_MONO:
			nValue = AUDIO_MONO;
			break;
		case IDC_AUDIO_STEREO:
			nValue = AUDIO_STEREO;
			break;
		default:
			nValue = AUDIO_MONO;
			break;
	}

	return( nValue );
}

void CCaptureAudio::SetAudioMode( UINT nAudioMode )
{
	switch( nAudioMode )
	{
		case AUDIO_MONO:
			CheckRadioButton( IDC_AUDIO_STEREO, IDC_AUDIO_MONO, IDC_AUDIO_MONO);
			break;
		case AUDIO_STEREO:
			CheckRadioButton( IDC_AUDIO_STEREO, IDC_AUDIO_MONO, IDC_AUDIO_STEREO);
			break;
		default:
			CheckRadioButton( IDC_AUDIO_STEREO, IDC_AUDIO_MONO, IDC_AUDIO_MONO);
			break;
	}
}

void CCaptureAudio::SetAudioRate(UINT nAudioRate)
{
	//mark the selected rate
	switch( nAudioRate )
	{
		case AUDIO_RATE_11KHZ:
			CheckRadioButton( IDC_AUDIO_44KHZ, IDC_AUDIO_11KHZ, IDC_AUDIO_11KHZ);
    		break;
		case AUDIO_RATE_22KHZ:
			CheckRadioButton( IDC_AUDIO_44KHZ, IDC_AUDIO_11KHZ, IDC_AUDIO_22KHZ);
    		break;
		case AUDIO_RATE_44KHZ:
			CheckRadioButton( IDC_AUDIO_44KHZ, IDC_AUDIO_11KHZ, IDC_AUDIO_44KHZ);
    		break;
        default:
			CheckRadioButton( IDC_AUDIO_44KHZ, IDC_AUDIO_11KHZ, IDC_AUDIO_44KHZ);
	}
}


UINT CCaptureAudio::GetAudioRate()
{
	UINT nValue;
	UINT nId = GetCheckedRadioButton( IDC_AUDIO_44KHZ, IDC_AUDIO_11KHZ );

	switch( nId )
	{
		case IDC_AUDIO_11KHZ:
			nValue = AUDIO_RATE_11KHZ;
		    break;
		case IDC_AUDIO_22KHZ:
			nValue = AUDIO_RATE_22KHZ;
		    break;
		case IDC_AUDIO_44KHZ:
			nValue = AUDIO_RATE_44KHZ;
		    break;
		default	:
			nValue = AUDIO_RATE_44KHZ;
	}
	return( nValue );
}

BOOL CCaptureAudio::OnKillActive( )
{
	m_nAudioEnable = GetAudioEnable();
	m_nAudioMode = GetAudioMode();
	m_nAudioRate = GetAudioRate();

	m_nShowHelp = m_chkShowHelp.GetCheck();

	return( TRUE );
}

void CCaptureAudio::OnOK( )
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	if (m_bChanged)
	{
		pApp->m_Settings.SetAudioEnable( m_nAudioEnable );
		pApp->m_Settings.SetAudioMode( m_nAudioMode );
		pApp->m_Settings.SetAudioRate( m_nAudioRate );
		pApp->m_Settings.SetShowVolumeHelp(m_nShowHelp);
		
		SetModified( FALSE );
	}
	CPropertyPage::OnOK();
}

void CCaptureAudio::On11khz() 
{
	EndRecording();
	BeginRecording();
	SetModified( TRUE );	
}

void CCaptureAudio::On22khz() 
{
	EndRecording();
	BeginRecording();
	SetModified( TRUE );	
}

void CCaptureAudio::On44khz() 
{
	EndRecording();
	BeginRecording();
	SetModified( TRUE );	
}

void CCaptureAudio::OnMono() 
{
	EndRecording();
	BeginRecording();
	SetModified( TRUE );
}

void CCaptureAudio::OnStereo() 
{
	EndRecording();
	BeginRecording();
	SetModified( TRUE );
}

void CCaptureAudio::OnShowhelp() 
{
	SetModified( TRUE );
}

void CCaptureAudio::OnAudioEnable() 
{
	SetAudioEnable (GetAudioEnable());
	EndRecording();
	BeginRecording();
	SetModified( TRUE );
}

void CCaptureAudio::OnDefaults() 
{
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	UINT nAudioEnable = pApp->m_Settings.DefaultAudioEnable();
	UINT nAudioMode = pApp->m_Settings.DefaultAudioEnable();
	UINT nAudioRate = pApp->m_Settings.DefaultAudioRate();
	UINT nShowHelp = pApp->m_Settings.DefaultShowVolumeHelp();

	UINT nDlgAudioEnable = GetAudioEnable ();
	UINT nDlgAudioMode = GetAudioMode ();
	UINT nDlgAudioRate = GetAudioRate();
	UINT nDlgShowHelp = m_chkShowHelp.GetCheck();
			 
	if (nDlgAudioEnable != nAudioEnable || nDlgAudioMode != nAudioMode  
							|| nDlgAudioRate != nAudioRate
							|| nDlgShowHelp != nShowHelp) {

        SetAudioEnable(nAudioEnable);
        SetAudioMode(nAudioMode);
        SetAudioRate(nAudioRate);

		m_chkShowHelp.SetCheck(nShowHelp);

		SetModified( TRUE );
	}
}			

//xxxxx this was added 
LRESULT CCaptureAudio::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{

	//TODO: Add your specialized code here and/or call the base class
	if (message == WM_HELP)	{
		HELPINFO* pHelpInfo = (HELPINFO*) lParam;
		OnHelpInfo(pHelpInfo);
		return TRUE;
	} else if (message == WM_COMMAND)	{
		if (wParam == ID_HELP) {
			HELPINFO HelpInfo;

			HelpInfo.iContextType = HELPINFO_WINDOW;
			HelpInfo.iCtrlId = IDC_CAPTURE_OPTIONS;
			OnHelpInfo(&HelpInfo);
			return TRUE;
		}
	} else if (message == WIM_DATA) {
		
		if (m_bIsRecording) {
			WAVEHDR * waveHdr = (WAVEHDR*)lParam;
			int nret = waveInAddBuffer (m_hWave, waveHdr, sizeof(WAVEHDR));
		}
		return TRUE;

	} else if (message == WIM_OPEN || message == WIM_CLOSE) {
		return TRUE;
	}

	return CDialog::WindowProc(message, wParam, lParam);
}


BOOL CCaptureAudio::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	if ( pHelpInfo->iContextType==HELPINFO_WINDOW )
	{
		long lParam = pHelpInfo->iCtrlId + HIDC_MYBASE;
    	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
    	CWnd* pMainWnd = this;

	    //return global app help mode state to FALSE (backward compatibility)
	    pApp->m_bHelpMode = FALSE;
	    pMainWnd->PostMessage(WM_KICKIDLE); //trigger idle update

	    pMainWnd->WinHelp(lParam, HELP_CONTEXT);
	}
	return TRUE;
}

LRESULT CCaptureAudio::OnCommandHelp( WPARAM, LPARAM lParam )
{
    int nCtrlID = GetFocus()->GetDlgCtrlID(); //Get the ID of the control with the current focus

	lParam = nCtrlID + HIDC_MYBASE;
   	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
   	CWnd* pMainWnd = this;

    //return global app help mode state to FALSE (backward compatibility)
    pApp->m_bHelpMode = FALSE;
    pMainWnd->PostMessage(WM_KICKIDLE); //trigger idle update

    pMainWnd->WinHelp(lParam, HELP_CONTEXT);

    return TRUE;
}



void CCaptureAudio::UpdateTargetSpecs() {

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

}
void CCaptureAudio::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

    //handle scroll message based on source window
    HWND sourceWnd = pScrollBar->GetSafeHwnd();

    if (sourceWnd == NULL) {
        //default processing if no source
		CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
    }
	else if (sourceWnd == m_Volume.GetSafeHwnd()) {
		SetModified( TRUE );
		int nVolume = m_Volume.GetPos();
		AudioLevel.RecordingVolume(65535-nVolume);
	}

	CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CCaptureAudio::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{

	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();
	
    //handle scroll message based on source window
    HWND sourceWnd = pScrollBar->GetSafeHwnd();

    if (sourceWnd == NULL) {
        //default processing if no source
		CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
    }
	else if (sourceWnd == m_Volume.GetSafeHwnd()) {
		SetModified( TRUE );
		int nVolume = m_Volume.GetPos();
		AudioLevel.RecordingVolume(65535-nVolume);
	}

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CCaptureAudio::OnTimer(UINT nIDEvent) 
{
	//TODO: Add your message handler code here and/or call default
	
	CPropertyPage::OnTimer(nIDEvent);

	if (nIDEvent == m_kTimerPEAK) {
	
		UINT Peak = AudioLevel.RecordingPeak();

		UINT Range = (Peak/3276);
	
		Range = min (9, Range);
		Range = max (Peak == 0 ?(UINT)0:(UINT)1, Range);

		RECT rc;

		m_Power.SetBitmap(IDB_POWER0 + m_Range);
		m_Power.GetClientRect (&rc);	
		m_Power.InvalidateRect (&rc, FALSE);

		m_Range = Range;
	
	} else if (nIDEvent == m_kTimerVOLUME) {

		if (m_Volume.IsWindowEnabled()) {
			int nVolume = AudioLevel.RecordingVolume();
			m_Volume.SetPos(65535-nVolume);
		}
	}
}

void CCaptureAudio::OnDestroy() 
{
	CPropertyPage::OnDestroy();
	
    KillTimer (0);
	EndRecording ();
}

void CCaptureAudio::OnMixer() 
{
	CBwdialogApp *pApp = (CBwdialogApp *)AfxGetApp();

	UINT nShowHelp = m_chkShowHelp.GetCheck() && !m_HelpDisplayed;

	CAudioLevelSTATUS status = AudioLevel.Run();
	
	if ((status == CAudioLevelSTATUSOK || status == CAudioLevelSTATUSRUNNING) && nShowHelp) {

		HWND hWnd;

		m_HelpDisplayed = TRUE;		 

 		MSG Msg;
		do {
			if (PeekMessage (&Msg, NULL, 0, 0, PM_REMOVE)) 
			{
				TranslateMessage (&Msg);
				DispatchMessage (&Msg);
			}
		} while ((hWnd = AudioLevel.GetUtilityWindow()) == NULL);

		GetParent()->EnableWindow(FALSE);
		EnableWindow(FALSE);

		CVolumeHelp Help(CWnd::FromHandle(hWnd));
		Help.DoModal();
		m_HelpDisplayed = FALSE;

		GetParent()->EnableWindow(TRUE);
		EnableWindow(TRUE);
		
		hWnd = AudioLevel.GetUtilityWindow();
    	if (hWnd != NULL) 
		{
			if (!::IsIconic(hWnd))
				::SetForegroundWindow(hWnd);
		}																									
	}
}

