// progress.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "progress.h"
#include "bwdialog.h"

#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

CModelessDialog::CModelessDialog(CModelessDialog** ppSelf)
{
	//m_ppSelf = ppSelf;
}
CModelessDialog::~CModelessDialog()
{
	//ASSERT(m_ppSelf==NULL || *m_ppSelf == this);
	//*m_ppSelf = NULL;
}

//Delete self agter window has been destroyed, to avoid TRACE
//message in CWnd.  This assumes dialog object is created in the heap
//not on the stack!!

void CModelessDialog::PostNcDestroy()
{
	delete this;
}

//Must override MFC implementation of CDialog::OnOk and OnCancel,
//which call EndDialog, which is for modal dialogs only.
//For modeless dialogs, must call DestroyWindow instead.

void CModelessDialog::OnOK()
{
	if (!UpdateData(TRUE)) { //Do Data Exchange
		TRACE0("UpdateData failed during dialog termination\n");
		//the UpdateData routine will set focus to the correct item
		return;
	}
	DestroyWindow();
}

void CModelessDialog::OnCancel()
{
	DestroyWindow();  //without updatedata
}


/////////////////////////////////////////////////////////////////////////////
// CCalibrationProgress dialog

CCalibrationProgress::CCalibrationProgress(CWnd* pParent /*=NULL*/, CCalibrationProgress** ppSelf /*=NULL*/,
                 LPCTSTR lpstrFile/*=NULL*/, DWORD TotalCounts/*=2500*/)
	: CModelessDialog((CModelessDialog **)ppSelf)
//	: CDialog(CCalibrationProgress::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCalibrationProgress)
	//}}AFX_DATA_INIT

	m_pParent = pParent;
	m_sFileName.Empty();
	if (lpstrFile != NULL)
		m_sFileName = lpstrFile;

	m_TotalCounts = TotalCounts;
}

CCalibrationProgress::~CCalibrationProgress()
{
}

void CCalibrationProgress::DoDataExchange(CDataExchange* pDX)
{
	CModelessDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCalibrationProgress)
	DDX_Control(pDX, IDC_TEXT, m_Text);
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_FILE_NAME, m_FileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCalibrationProgress, CModelessDialog)
	//{{AFX_MSG_MAP(CCalibrationProgress)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()



#define MAX_PATHNAME 256
#define MAX_REGISTRY_PATH 256

#define STR_BROADWAY_HARDWARE_SUBKEY "SOFTWARE\\DataTranslation\\Broadway\\HardwareOptions"
#define STR_AUDIO_CAL_FACTOR        "AudioCalFactor"
#define STR_DRIVER_INSTALL			"DriverInstallComplete"

/////////////////////////////////////////////////////////////////////////////
// CCalibrationProgress message handlers

BOOL CCalibrationProgress::OnInitDialog() 
{
	CModelessDialog::OnInitDialog();

	m_Continue = TRUE;

	m_Progress.SetRange(0, m_TotalCounts);

    DWORD dwResult = 0, Type, Length, lRet;
    HKEY hkOptions;

    /* See if we can get a registry handle to our settings data */
    lRet = RegOpenKey(HKEY_LOCAL_MACHINE, STR_BROADWAY_HARDWARE_SUBKEY, &hkOptions);
    if (lRet  == ERROR_SUCCESS) {

        /* try to get the current driver install setting */
        Length = sizeof(dwResult);  
        lRet = RegQueryValueEx(hkOptions
                               ,STR_DRIVER_INSTALL
                               ,NULL
                               ,&Type
                               ,(PUCHAR)&dwResult
                               ,&Length
                               );

        RegCloseKey(hkOptions);

	    if (lRet  != ERROR_SUCCESS || Type != REG_DWORD) {
			dwResult = 0;
		}
	}

	CString sString;
	if (!dwResult) {	
		sString.LoadString(IDS_CALTEXT1);
	} else {
		sString.LoadString(IDS_CALTEXT2);
	}

	m_Text.SetWindowText(sString);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CCalibrationProgress::PreTranslateMessage(MSG* pMsg) 
{
	BOOL bRet = CModelessDialog::PreTranslateMessage(pMsg);

	return bRet;
}

void CCalibrationProgress::SetPercentage( UINT nPercent ) 
{
	//update progress bar
	m_Progress.SetPos( nPercent );
}

void CCalibrationProgress::OnCancel() 
{
	m_Continue = FALSE;
}

void CCalibrationProgress::OnDestroy() 
{
	CModelessDialog::OnDestroy();
}


LRESULT CCalibrationProgress::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
		
	return CModelessDialog::WindowProc(message, wParam, lParam);
}


