// BwHelper.h Helper functions for use by the Broadway application.
//#include <vt_acc.h>  // needed for now

#define BROADWAY_CANDO_VCD					1<<2
#define BROADWAY_ISBEGINNER					1<<5
#define	BROADWAY_CANCAPTURE_MPEG			1<<7
#define	BROADWAY_CANCAPTURE_IMPEG			1<<12
#define	BROADWAY_CANOUTPUT_IMPEG			1<<15
#define	BROADWAY_CANUSE_EXTERNAL_TARGETS	1<<20
#define BROADWAY_ENABLE_PREFERENCES			1<<21
#define BROADWAY_DEFAULT_CAPS	(BROADWAY_CANDO_VCD | BROADWAY_CANUSE_EXTERNAL_TARGETS | \
									BROADWAY_ENABLE_PREFERENCES |BROADWAY_CANCAPTURE_IMPEG )
#define CHECKSUM_LOC					22
#define CHECKSUM_MASK					(0X3F<<CHECKSUM_LOC)
#ifdef BUILD_DLL
#define BW_INTERFACE VT_INTERFACE
#else
#define BW_INTERFACE __stdcall
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifndef ECODE
#define ECODE DWORD
#endif

#ifdef __cplusplus
class CDevice;
typedef CDevice *BWDEV;
#else
typedef struct _DEVSTRUCT *BWDEV;
#endif

 
ECODE BW_INTERFACE BroadwayOpenDevice(BWDEV *dev,int BoardNumber);
ECODE BW_INTERFACE BroadwayCloseDevice(BWDEV dev);

ECODE BW_INTERFACE BroadwayGetHardwareVersion(BWDEV dwDevice,LPSTR StringVersion,int StrLen);
ECODE BW_INTERFACE BroadwayGetHardwareSerial(BWDEV dwDevice,LPSTR StringVersion,int StrLen);
ECODE BW_INTERFACE BroadwayGetUpgradeSerial(BWDEV dwDevice,LPSTR StringVersion,int StrLen);    // is this needed?
ECODE BW_INTERFACE BroadwayGetBoardName(BWDEV dwDevice,LPSTR StringVersion,int StrLen); // Broadway ,,, Broadway Beginner
ECODE BW_INTERFACE BroadwayGetBoardType(BWDEV Device,LPDWORD pType);
ECODE BW_INTERFACE BroadwayGetBoardCaps(BWDEV dwDevice,LPDWORD Caps);

ECODE BW_INTERFACE BroadwaySetHardwareKey(BWDEV dwDevice,LPVOID Key);

ECODE BW_INTERFACE BroadwaySetSerialNumber(BWDEV dwDevice,DWORD SerialNumber);
ECODE BW_INTERFACE BroadwayInitHardware(BWDEV Device,int type,DWORD sn);

#ifdef __cplusplus
}
#endif

