// vt_vrp.h 
// defineitions for vrp related stuff
#ifndef __VT_Vrp
#define __VT_Vrp

#ifdef __cplusplus
extern "C" {
#endif

#if 0
// these addresses are byte addresses code uses dword addreses

#define VRP_MESSAGE_BASE	(0x7f900<<2)

#define HOST_TO_CHIP_BUFFER	0X0
#define HOST_TO_CHIP_WRITE	(0X100<<2)
#define HOST_TO_CHIP_READ	(0X101<<2)
#define CHIP_TO_HOST_BUFFER	(0X102<<2)
#define CHIP_TO_HOST_WRITE	(0X202<<2)
#define CHIP_TO_HOST_READ	(0X203<<2)
#define PRIORITY_BUFFER		(0X204<<2)
#define PROCESSING_CMD_FLAG	(0X208<<2)
#define DISABLE_CMD_PROCESSING (0X209<<2)
#define ENCODER_STATUS_REGISTER (0x20C <<2)

#endif

#define EMI_SetOutputTimeCode  	1
#define EMI_Start				3
#define EMI_Stop				4
#define EMI_LoadParams			8
#define EMI_SetRefTimeCode		14

#define EMR_SetOutputTimeCode  	1
#define EMR_SetDefaultValues	2
#define EMR_Start				3
#define EMR_Stop				4
#define EMR_Pause				5
#define EMR_Continue			6
#define EMR_LoadParams			8
#define EMR_ReportStatus		9
#define EMR_StartGop			10
#define EMR_SeqUserData			11
#define EMR_GopUserData			12
#define EMR_PicUserData			13
#define EMR_SetRefTimeCode		14


#define  IREG_READ_TIMEOUT	 1000
#define  IREG_WRITE_TIMEOUT	 1000
//#define DMA_MODE_9_SCV  0x01000000
#define DMA_MODE_8_CHP  0x00000000
#define DMA_MODE_9_CHP  0x00000040

//#define MAKE_BRK_INST(addr) (0x41E00000 | ((addr) & 0x1f) | (((addr) & 0x3e0) << 11))

#define stepCmd 0xa0000000

typedef unsigned long ulong;
typedef struct {
	unsigned long hiword;
	unsigned long loword;
	}  uwide;

#define CHIP_ID  0x5
#define VRP_CHIP 0xf0000000	| (CHIP_ID <<24) 
// refresh count is 0x372 
#define VIDTOOL_MEMCONFIG (0xc8000000 | DMA_MODE_9_CHP| (0x372<<16))

#define DRAM_ADDR(_x) ( ((_x << 2) & 0x007ffffc) | VRP_CHIP)

unsigned long VrpPeekNoMutex(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long *dptr);
unsigned long VrpPokeNoMutex(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long data);

unsigned long VT_INTERFACE VrpPeek(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long *dptr);
unsigned long VT_INTERFACE VrpPoke(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long data);
unsigned long VT_INTERFACE VrpChange(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long mask,unsigned long data);


#ifndef NO_ACCESS_MACROS
  // not used for hdb

__inline ECODE GBusRead(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long *dptr)
{
	return VrpPeekNoMutex(bd_addr,((addr << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,dptr);
}

__inline ECODE GBusWrite(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long data)
{
	return VrpPokeNoMutex(bd_addr,((addr << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,data);
}


#define GBusChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) & 0x000000fc) | 0x00800000 | VRP_CHIP,_c,_d)

#define WBusRead(_a,_b,_c) VrpPeekNoMutex(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c)
#define WBusWrite(_a,_b,_c) VrpPokeNoMutex(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c)
#define WBusChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) & 0x0000007c) | 0x00a00000| VRP_CHIP,_c,_d)

#define dramRead(_a,_b,_c) VrpPeekNoMutex(_a,((_b << 2) & 0x007ffffc) | VRP_CHIP,_c)
#define dramWrite(_a,_b,_c) VrpPokeNoMutex(_a,((_b << 2) &  0x007ffffc) | VRP_CHIP,_c)
#define dramChange(_a,_b,_c,_d) VrpChange(_a,((_b << 2) &  0x007ffffc) | VRP_CHIP,_c,_d)
#define dramFill(_a,_b,_c,_d) VrpFill(_a,((_b << 2) &  0x007ffffc) | VRP_CHIP,_c,_d)
#endif

int VT_INTERFACE VrpRead(volatile VT_REGS *bd_addr,unsigned long *DestPtr,unsigned long Source,unsigned long Words);
int VT_INTERFACE VrpWrite(volatile VT_REGS *bd_addr,unsigned long Dest,const unsigned long *SrcPtr,unsigned long Words);
int VT_INTERFACE VrpWriteSwap(volatile VT_REGS *bd_addr,unsigned long Dest,const unsigned long *SrcPtr,unsigned long Words);
ECODE VT_INTERFACE CrRead(volatile VT_REGS *bd_addr,unsigned long *DestPtr,unsigned long Source,unsigned long Words);
ECODE VT_INTERFACE CrWrite(volatile VT_REGS *bd_addr,unsigned long Dest,const unsigned long *SrcPtr,unsigned long Words);
ECODE VT_INTERFACE CrChange(volatile VT_REGS *bd_addr,unsigned long addr,unsigned long mask,unsigned long data);
ECODE VT_INTERFACE CrPoke(PREGS bd_addr,DWORD addr, DWORD data);
ECODE VT_INTERFACE VidOutCtlPoke(PREGS bd_addr,DWORD data);

#if 0
ECODE VT_INTERFACE WriteSerialStart(volatile VT_REGS *bd_addr);
void WriteSerialStop(volatile VT_REGS *bd_addr);
ECODE WriteSerial(volatile VT_REGS *bd_addr,unsigned long data);
void ReadSerial(volatile VT_REGS *bd_addr,unsigned long *data);
unsigned long SrRead(volatile VT_REGS *bd_addr,unsigned long *DestPtr,unsigned long Source,unsigned long Words);
unsigned long SrWrite(volatile VT_REGS *bd_addr,unsigned long Dest,const unsigned long *SrcPtr,unsigned long Words);
#endif
unsigned long  VT_INTERFACE ImemRead(volatile VT_REGS *bd_addr,unsigned long *DestPtr,unsigned long Source,unsigned long Words);
unsigned long  VT_INTERFACE ImemWrite(volatile VT_REGS *bd_addr,unsigned long Dest,const unsigned long *SrcPtr,unsigned long Words);
unsigned long  VT_INTERFACE SmemRead(volatile VT_REGS *bd_addr,unsigned long *DestPtr,unsigned long Source,unsigned long Words);
unsigned long  VT_INTERFACE SmemWrite(volatile VT_REGS *bd_addr,unsigned long Dest,const unsigned long *SrcPtr,unsigned long Words);
unsigned long VT_INTERFACE RmemRead(volatile VT_REGS *bd_addr,unsigned long *DestPtr,unsigned long Source,unsigned long Words);
unsigned long VT_INTERFACE RmemWrite(volatile VT_REGS *bd_addr,unsigned long Dest,const unsigned long *SrcPtr,unsigned long Words);

ECODE FifoBRead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words);
ECODE FifoARead(PREGS bd_addr,DWORD *DestPtr, DWORD Source, DWORD Words);
ECODE FifoAWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words);
ECODE FifoBWrite(PREGS bd_addr,DWORD Dest, const DWORD *SrcPtr, DWORD Words);

//void cl4000Peek(PREGS bd_addr, ulong adr, ulong *data);
//void cl4000Poke(PREGS bd_addr, ulong adr, ulong data);
//void mmap_cl4000Poke(PREGS bd_addr, ulong adr, ulong data);


//void dramRead(PREGS bd_addr, ulong adr, ulong *data);
//void VT_INTERFACE dramWrite(PREGS bd_addr, ulong adr, ulong data);
//void mmap_dramWrite(PREGS bd_addr, ulong adr, ulong data);
//void dramFill(PREGS bd_addr, ulong adr_start, ulong adr_end, ulong data);
void VrpFill(PREGS Regs, DWORD addr, DWORD Value, DWORD Words);

void dramClear(PREGS bd_addr);
//void loadDram(PREGS bd_addr, char* dataFileName);
//void loadDram_bin(PREGS bd_addr, char* dataFileName, ulong adr_start,
//		 ulong adr_end, ulong file_offset);

void VT_INTERFACE imemRead(PREGS bd_addr, ulong adr, ulong *data);
void VT_INTERFACE imemWrite(PREGS bd_addr, ulong adr, ulong data);
void VT_INTERFACE imemClear(PREGS bd_addr);
//void loadImem(PREGS bd_addr, char *dataFileName);

void VT_INTERFACE rmemRead(PREGS bd_addr, ulong adr, uwide *data);
void VT_INTERFACE rmemWrite(PREGS bd_addr, ulong adr, uwide *data);
void VT_INTERFACE rmemClear(PREGS bd_addr);

void VT_INTERFACE smemRead(PREGS bd_addr, ulong addr, uwide *data);
void VT_INTERFACE smemWrite(PREGS bd_addr, ulong addr, uwide *data);
void VT_INTERFACE smemClear(PREGS bd_addr);
int VT_INTERFACE loadSmem(PREGS bd_addr, char* dataFileName);

void VT_INTERFACE CpuSingleStep(PREGS bd_addr, ulong count, ulong command);
void VT_INTERFACE CpuWritePC(PREGS bd_addr,  ulong pc0, ulong pc1, ulong odd);
void VT_INTERFACE reset(PREGS bd_addr);
void VT_INTERFACE cpu_resume(PREGS bd_addr);
//void VT_INTERFACE run_cycles(PREGS bd_addr,ulong count);
void stop_at(PREGS bd_addr, ulong addr);
void VT_INTERFACE run_inst(PREGS bd_addr, ulong count);

ECODE VRP_Start(DEVID dwDevice);
ECODE VRP_StartP(DEVID dwDevice);


#ifdef __cplusplus
}
#endif

#endif
