/*
 * Broadway.c
 *
 *
 * Broadway WinNT kernel-mode driver 
 * Main inititialization routine
 *
 * Mark Vrabel, June 96
 */
                                 
#include "vtkernel.h"		

#define BROADWAY_DEVICE_ID			0x4000
#define BROADWAY_VENDOR_ID			0x1116
#define BROADWAY_MEMORY_REQUIRED	0x86000


/*
 *   Device load-time initialization.
 */
NTSTATUS
DriverEntry(IN PDRIVER_OBJECT pDriverObject, IN PUNICODE_STRING	RegistryPathName)
{
    PDEVICE_EXT pDevExt;

	pDevExt = VT_Init(pDriverObject
					  ,RegistryPathName
					  ,BROADWAY_DEVICE_ID
					  ,BROADWAY_VENDOR_ID
					  ,BROADWAY_MEMORY_REQUIRED
					  );

	if (pDevExt == NULL) {
		KdPrint(("driver load failed"));
		return(STATUS_UNSUCCESSFUL);
	}
    

	KdPrint(("driver loaded"));
    return (STATUS_SUCCESS);
}


