/*
 * xlate.h   
 *
 */

#include <windows.h>
#include <windowsx.h>
#include <msvideo.h>
#include <memory.h>  


#ifdef __cplusplus
extern "C" {
#endif


/* yuv422 to rgb translation, in xlate.c */

/*
 * build yuv422 -> RGB555 xlate table
 */
LPVOID BuildYUV422ToRGB555();


// build yuv422 -> RGB565
PVOID BuildYuvToPal(PUCHAR pBuffer,ULONG Length);
PVOID BuildYUVToRGB555(void);
PVOID BuildYUVToRGB24(void);


/*
 * translate one frame from yuv421 to rgb 555 or 565
 */
VOID CopyYUVToPal8(
    PUCHAR pXlate,	
    DWORD Width,	
    DWORD Height,	
    PUCHAR pDst,	
    PUCHAR pSrc); 	

VOID CopyYUVToRGB555(
    PWORD pXlate,	
    DWORD Width,	
    DWORD Height,	
    PUCHAR pDst,	
    PUCHAR pSrc,
    BOOL bYUVSwapBytes); 	

VOID CopyYUVToRGB24(
    PDWORD pXlate,	
    DWORD Width,	
    DWORD Height,	
    PUCHAR pDst,	
    PUCHAR pSrc); 	


#ifdef __cplusplus
}
#endif

 
